!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCGDI.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
 END

 INCLUDE('CFCGDI.inc'),ONCE
CFCGDIClass.RGB                  PROCEDURE(LONG r, LONG g, LONG b)
 CODE
 RETURN BOR(BOR(r,BSHIFT(g,8)),BSHIFT(b,16))

CFCGDIClass.LoadIconFromDll PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>)
loc:cstrIconDll               CSTRING(256)
loc:cstrIconResource          CSTRING(256)
loc:DllHandle                 ULONG
loc:Width                     LONG
loc:Height                    LONG
 CODE
 IF OMITTED(4)
    loc:Width = 16
 ELSE
    loc:Width = inWidth
 END
 IF OMITTED(5)
    loc:Height = 16
 ELSE
    loc:Height = inHeight
 END

 IF OMITTED(3)
    loc:DllHandle = SYSTEM{PROP:ImageInstance}
 ELSE
    loc:cstrIconDll = CLIP(inDllName)
    loc:DllHandle = CFC_GetModuleHandle(ADDRESS(loc:cstrIconDll))
 END
 loc:cstrIconResource = SUB(inIconName,1,LEN(CLIP(inIconName))-4)&'_ICO'
 RETURN CFC_LoadImage(loc:DllHandle,ADDRESS(loc:cstrIconResource),CFC_IMAGE_ICON,loc:Width,loc:Height,CFC_LR_SHARED)
CFCGDIClass.ConvertIcoToBmp     PROCEDURE(ULONG inIconHandle,<ULONG inBrush>,<LONG inWidth>,<LONG inHeight>)
loc:Width                     LONG
loc:Height                    LONG
loc:hDC                       ULONG
loc:hbitmap                   ULONG
loc:mem_hDC                   ULONG
loc:hbitmap_old               ULONG
loc:hBrush                    ULONG
loc:rcWork                    LIKE(CFC_RECT)
 CODE
 IF OMITTED(3)
    loc:hBrush = CFC_GetSysColorBrush(CFC_COLOR_BTNFACE)
 ELSE
    loc:hBrush = inBrush
 END

 IF OMITTED(4)
    loc:Width = 16
 ELSE
    loc:Width = inWidth
 END
 IF OMITTED(5)
    loc:Height = 16
 ELSE
    loc:Height = inHeight
 END

 loc:hDC = CFC_GetDC(0)

 IF loc:hDC
    loc:hbitmap = CFC_CreateCompatibleBitmap(loc:hDC,loc:Width,loc:Height)
    IF loc:hbitmap
       loc:mem_hDC = CFC_CreateCompatibleDC(loc:hDC)
       IF loc:mem_hDC
          loc:hbitmap_old = CFC_SelectObject(loc:mem_hDC, loc:hbitmap)
          loc:rcWork.right = loc:Width
          loc:rcWork.bottom = loc:Height
          CFC_FillRect(loc:mem_hDC,ADDRESS(loc:rcWork),loc:hBrush)
          CFC_DrawIconEx(loc:mem_hDC,0,0,inIconHandle,loc:Width,loc:Height,0,0,CFC_DI_NORMAL)
       END
    END
 END
 IF loc:hbitmap_old
    Err# = CFC_SelectObject(loc:mem_hDC,loc:hbitmap_old)
 END

 IF OMITTED(3)
    Err# = CFC_DeleteObject(loc:hBrush)
 END

 Err# = CFC_DeleteObject(loc:mem_hDC)
 CFC_ReleaseDC(0,loc:hDC)
 RETURN loc:hbitmap
CFCGDIClass.CreateDisabledIcon   PROCEDURE(ULONG hIcon)
iInfo       LIKE(CFC_ICONINFO)
bmp         LIKE(CFC_BITMAP)
hDC         ULONG
hDcMask     ULONG
hBmp        ULONG
hBmpMask    ULONG
hNewIcon    ULONG
clrMask     LONG
clr         ULONG
nGray       ULONG
 CODE
 IF CFC_GetIconInfo(hIcon, ADDRESS(iInfo))
    hDC = CFC_CreateCompatibleDC(0)
    hBmp = CFC_SelectObject(hDC, iInfo.hbmColor)
    
    hDcMask = CFC_CreateCompatibleDC(0)
    hBmpMask = CFC_SelectObject(hDcMask, iInfo.hbmMask)

    CFC_GetObject(iInfo.hbmColor, SIZE(CFC_BITMAP), ADDRESS(bmp))

    LOOP j# = 0 TO bmp.bmHeight - 1
       LOOP i#=0 TO bmp.bmWidth - 1
          clrMask = CFC_GetPixel(hDcMask, i#, j#)
          clr = CFC_GetPixel(hDC, i#, j#)
          IF NOT clrMask = 0FFFFFFH
             nGray = (0.30 * SELF.GetRValue(clr)) + (0.59 * SELF.GetGValue(clr)) + (0.11 * SELF.GetBValue(clr))
             nGray = SELF.LightenColor(100,nGray)

             CFC_SetPixel(hDC, i#, j#, SELF.RGB(nGray,nGray,nGray))
             CFC_SetPixel(hDcMask, i#, j#, 0)
          ELSE
              CFC_SetPixel(hDc, i#, j#, 0)
              CFC_SetPixel(hDcMask, i#, j#, 0FFFFFFH)
          END
       END
    END
    Err# = CFC_SelectObject(hDcMask, hBmpMask)
    Err# = CFC_DeleteDC(hDcMask)
    Err# = CFC_SelectObject(hDC, hBmp)
    Err# = CFC_DeleteDC(hDC)

    hNewIcon = CFC_CreateIconIndirect(ADDRESS(iInfo))

    Err# = CFC_DeleteObject(iInfo.hbmColor)
    Err# = CFC_DeleteObject(iInfo.hbmMask)
 end
 RETURN hNewIcon
CFCGDIClass.GetRValue PROCEDURE(LONG COLORREF)
 CODE
 RETURN BAND(COLORREF, 255)

CFCGDIClass.GetGValue PROCEDURE(LONG COLORREF)
 CODE
 RETURN BAND(BSHIFT(COLORREF, -8), 255)

CFCGDIClass.GetBValue PROCEDURE(LONG COLORREF)
 CODE
 RETURN BAND(BSHIFT(COLORREF, -16), 255)
CFCGDIClass.LightenColor PROCEDURE(LONG lScale,LONG lColor)
 CODE
 red# = CFC_MulDiv(255-SELF.GetRValue(lColor),lScale,255)+SELF.GetRValue(lColor)
 green# = CFC_MulDiv(255-SELF.GetGValue(lColor),lScale,255)+SELF.GetGValue(lColor)
 blue# = CFC_MulDiv(255-SELF.GetBValue(lColor),lScale,255)+SELF.GetBValue(lColor)

 RETURN SELF.RGB(red#,green#,blue#)
CFCGDIClass.CreateVertex              PROCEDURE(ULONG inColor)
loc:Vertex    LIKE(CFC_TRIVERTEX)
 CODE
 CLEAR(loc:Vertex)
 loc:Vertex.Red = BAND(inColor, 0FFh) * 256
 loc:Vertex.Green = BAND(BSHIFT(inColor, -8), 0FFh) * 256
 loc:Vertex.Blue =  BAND(BSHIFT(inColor, -16), 0FFh) * 256
 RETURN loc:Vertex


