!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCHotKey.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
 END

 INCLUDE('CFCHotKey.inc'),ONCE
CFCHotKeyEntry.Init PROCEDURE(LONG inEntryFEQ,*ANY inEntryVar)
 code
 SELF.EntryFEQ = inEntryFEQ
 SELF.EntryFEQ{Prop:ReadOnly} = TRUE
 SELF.EntryVar &= inEntryVar
 SELF.SetCallback(SELF.EntryFEQ{Prop:Handle})


CFCHotKeyEntry.Kill PROCEDURE()
 code
 SELF.RemoveCallback()
 if NOT SELF.EntryVar &= NULL
    SELF.EntryVar &= NULL
 end
CFCHotKeyEntry.CallBackProc PROCEDURE(ULONG hWnd,ULONG Msg,ULONG wParam,LONG lParam)
loc:WM_KEYDOWN        EQUATE(0100h)
cstrKeys              CSTRING(256)

loc:VK_SHIFT          EQUATE(010h)      ! SHIFT
loc:VK_CONTROL        EQUATE(011h)      ! CTRL
loc:VK_MENU           EQUATE(012h)      ! ALT
loc:VK_LWIN           EQUATE(05Bh)      ! LEFT WINDOWS KEY
loc:VK_RWIN           EQUATE(05Ch)      ! RIGHT WINDOWS KEY

 code
 if Msg = loc:WM_KEYDOWN
    if CFC_GetKeyNameText(lParam,address(cstrKeys),size(cstrKeys))
       SELF.HotKeyString = ''

       SELF.VK_Code = wParam
       SELF.FlagCtrl = SELF.GetState(loc:VK_CONTROL)
       SELF.FlagAlt = SELF.GetState(loc:VK_MENU)
       SELF.FlagShift = SELF.GetState(loc:VK_SHIFT)
       SELF.FlagWin = SELF.GetState(loc:VK_LWIN)
       if NOT SELF.FlagWin
          SELF.FlagWin = SELF.GetState(loc:VK_RWIN)
       end

       if SELF.FlagCtrl
          SELF.HotKeyString = 'Ctrl+'
       end

       if SELF.FlagShift
          if len(clip(SELF.HotKeyString))
             SELF.HotKeyString = clip(SELF.HotKeyString) & 'Shift+'
          else
             SELF.HotKeyString = 'Shift+'
          end
       end

       if SELF.FlagWin
          if len(clip(SELF.HotKeyString))
             SELF.HotKeyString = clip(SELF.HotKeyString) & 'Win+'
          else
             SELF.HotKeyString = 'Win+'
          end
       end

       if SELF.FlagAlt
          if len(clip(SELF.HotKeyString))
             SELF.HotKeyString = clip(SELF.HotKeyString) & 'Alt+'
          else
             SELF.HotKeyString = 'Alt+'
          end
       end

       if wParam = loc:VK_SHIFT or |
          wParam = loc:VK_CONTROL or |
          wParam = loc:VK_MENU or |
          wParam = loc:VK_LWIN or |
          wParam = loc:VK_RWIN
             cstrKeys = ''
             SELF.VK_Code = 0
       end

       if len(clip(SELF.HotKeyString))
          SELF.HotKeyString = clip(SELF.HotKeyString) & cstrKeys
       else
          SELF.HotKeyString = cstrKeys
       end

       if NOT SELF.EntryVar &= NULL
          SELF.EntryVar = SELF.HotKeyString
          display(SELF.EntryFEQ)
       end
    end
 end

 return PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
CFCHotKeyEntry.GetState  PROCEDURE(LONG inVK)
ReturnValue BYTE
 code
 ReturnValue = FALSE
 if BAND(CFC_GetKeyState(inVK),10000000b) = 10000000b
    ReturnValue = TRUE
 end
 return ReturnValue

CFCHotKeyEntry.SaveToIni  PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
 CODE
 PARENT.SaveToIni(inSection,inCtrlName,inFileName)
 PUTINI(CLIP(inSection),CLIP(inCtrlName)& '.HotKeyString',SELF.HotKeyString,'.\mssqlfb.ini')
CFCHotKeyEntry.RestoreFromIni  PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
 CODE
 PARENT.RestoreFromIni(inSection,inCtrlName,inFileName)
 SELF.HotKeyString = GETINI(CLIP(inSection),CLIP(inCtrlName)& '.HotKeyString',,'.\mssqlfb.ini')
!*****************************************************************************************************
CFCHotKey.Init  PROCEDURE(WINDOW inWindowLabel)
 code
 SELF.Wnd &= inWindowLabel
 SELF.SetCallback(SELF.Wnd{Prop:Handle})
CFCHotKey.Kill PROCEDURE()
 code
 SELF.RemoveCallback()
CFCHotKey.CallBackProc PROCEDURE(ULONG hWnd,ULONG Msg,ULONG wParam,LONG lParam)
loc:WM_HOTKEY EQUATE(0312h)

lParamGroup   GROUP,OVER(lParam)
low              SHORT
hi               SHORT
              END

loc:MOD_ALT         EQUATE(1)
loc:MOD_CONTROL     EQUATE(2)
loc:MOD_SHIFT       EQUATE(4)
loc:MOD_WIN         EQUATE(8)

 code
 if Msg = loc:WM_HOTKEY
    if BAND(lParamGroup.low,loc:MOD_ALT) = loc:MOD_ALT then FlagAlt# = TRUE.
    if BAND(lParamGroup.low,loc:MOD_CONTROL) = loc:MOD_CONTROL then FlagCtrl# = TRUE.
    if BAND(lParamGroup.low,loc:MOD_SHIFT) = loc:MOD_SHIFT then FlagShift# = TRUE.
    if BAND(lParamGroup.low,loc:MOD_WIN) = loc:MOD_WIN then FlagWin# = TRUE.

    if SELF.FlagCtrl = FlagCtrl# and SELF.FlagAlt = FlagAlt# and SELF.FlagShift = FlagShift# and SELF.FlagWin = FlagWin# |
       and SELF.VK_Code = lParamGroup.Hi
       SELF.TakeAccepted()
    end
 end

 return PARENT.CallBackProc(hWnd,Msg,wParam,lParam)






CFCHotKey.RegisterHotKey  PROCEDURE()
ReturnValue         LONG

loc:MOD_ALT         EQUATE(1)
loc:MOD_CONTROL     EQUATE(2)
loc:MOD_SHIFT       EQUATE(4)
loc:MOD_WIN         EQUATE(8)

loc:MODE            LONG
 code
 ReturnValue = 0 !  
 loc:MODE = 0
 if SELF.FlagCtrl then loc:MODE += loc:MOD_CONTROL.
 if SELF.FlagAlt then loc:MODE += loc:MOD_ALT.
 if SELF.FlagShift then loc:MODE += loc:MOD_SHIFT.
 if SELF.FlagWin then loc:MODE += loc:MOD_WIN.

 if NOT CFC_RegisterHotKey(SELF.Wnd{Prop:Handle},SELF.HotKeyID,loc:MODE,SELF.VK_Code)
    ReturnValue = CFC_GetLastError()
 end

 return ReturnValue





CFCHotKey.UnregHotKey PROCEDURE()
 code
 Err#  = CFC_UnregisterHotKey(SELF.Wnd{Prop:Handle},SELF.HotKeyID)
CFCHotKey.TakeAccepted PROCEDURE()
 code
!*****************************************************************************************************
CFCHotKeyBase.SaveToIni             PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
 CODE
 PUTINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagCtrl',SELF.FlagCtrl,CLIP(inFileName))
 PUTINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagAlt',SELF.FlagAlt,'.\mssqlfb.ini')
 PUTINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagShift',SELF.FlagShift,'.\mssqlfb.ini')
 PUTINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagWin',SELF.FlagWin,'.\mssqlfb.ini')
 PUTINI(CLIP(inSection),CLIP(inCtrlName)& '.VK_Code',SELF.VK_Code,'.\mssqlfb.ini')
CFCHotKeyBase.RestoreFromIni        PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
 CODE
 SELF.FlagCtrl = GETINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagCtrl',,CLIP(inFileName))
 SELF.FlagAlt = GETINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagAlt',,'.\mssqlfb.ini')
 SELF.FlagShift = GETINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagShift',,'.\mssqlfb.ini')
 SELF.FlagWin = GETINI(CLIP(inSection),CLIP(inCtrlName)& '.FlagWin',,'.\mssqlfb.ini')
 SELF.VK_Code = GETINI(CLIP(inSection),CLIP(inCtrlName)& '.VK_Code',,'.\mssqlfb.ini')



