!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCMenus.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
CFC_MenuEnumerateWindows         PROCEDURE(ULONG hWnd,LONG lParam),BOOL,PASCAL
 END

 INCLUDE('CFCMenus.inc'),ONCE



!**************************************************************************************************************
CFCMenuBase.Construct            PROCEDURE
 CODE
 SELF.MIQ &= NEW CFCMenuItemQueue
 SELF.GDI &= NEW CFCGDIClass



CFCMenuBase.Destruct             PROCEDURE
 CODE
 IF NOT SELF.MIQ &= NULL THEN DISPOSE(SELF.MIQ).
 IF NOT SELF.GDI &= NULL THEN DISPOSE(SELF.GDI).

CFCMenuBase.CreateMenu               PROCEDURE
 CODE
 RETURN 0

CFCMenuBase.GetMenuItemPos       PROCEDURE(*CFCMenuItem inMenuItem)
get:mii      LIKE(CFC_MENUITEMINFO)
loc:RetValue LONG
 CODE
 loc:RetValue = -1
 LOOP j# = 0 TO SELF.GetMenuItemCount() - 1
    CLEAR(get:mii)
    get:mii.cbSize = SIZE(CFC_MENUITEMINFO)
    get:mii.fMask = CFC_MIIM_ID
    IF CFC_GetMenuItemInfo(SELF.hMenu,j#,TRUE,ADDRESS(get:mii))
       IF inMenuItem.ID = get:mii.wID
         loc:RetValue = j#
         BREAK
       END
    END
 END
 RETURN loc:RetValue

CFCMenuBase.GetMenuItemCount       PROCEDURE
 CODE
 RETURN CFC_GetMenuItemCount(SELF.hMenu)
CFCMenuBase.GetMenuItemByID       PROCEDURE(LONG inMenuItemID)
loc:RetValue &CFCMenuItem
 CODE
 loc:RetValue &= NULL
 LOOP j# = 1 TO RECORDS(SELF.MIQ)
    GET(SELF.MIQ,j#)
    IF SELF.MIQ.MenuItem.ID = inMenuItemID
       loc:RetValue &= SELF.MIQ.MenuItem
       BREAK
    END
 END
 RETURN loc:RetValue
CFCMenuBase.GetMenuItemByStrID       PROCEDURE(STRING inMenuItemID)
loc:RetValue &CFCMenuItem
 CODE
 loc:RetValue &= NULL
 LOOP j# = 1 TO RECORDS(SELF.MIQ)
    GET(SELF.MIQ,j#)
    IF NOT SELF.MIQ.MenuItem &= NULL
       IF SELF.MIQ.MenuItem.strID = inMenuItemID
          loc:RetValue &= SELF.MIQ.MenuItem
          BREAK
       END
    END
 END
 RETURN loc:RetValue
CFCMenuBase.SetBackground          PROCEDURE(ULONG inColor)
loc:lpcmi       LIKE(CFC_MENUINFO)
loc:RetValue    LONG
 CODE
 loc:RetValue = 0
 SELF.BkrColor = inColor
 CLEAR(loc:lpcmi)
 loc:lpcmi.cbSize = SIZE(CFC_MENUINFO)
 loc:lpcmi.fMask = CFC_MIM_BACKGROUND

 IF SELF.hbrBack ! free the background brush
    err# = CFC_DeleteObject(SELF.hbrBack)
 END

 SELF.hbrBack = CFC_CreateSolidBrush(inColor)
 IF SELF.hbrBack
    loc:lpcmi.hbrBack = SELF.hbrBack
    IF NOT SELF.Comctrl &= NULL
       IF SELF.Comctrl._CFC_SetMenuInfo_
          IF NOT CFC_SetMenuInfo(SELF.hMenu,ADDRESS(loc:lpcmi))
             loc:RetValue = CFC_GetLastError()
          END
       ELSE
          loc:RetValue = - 1
       END
    ELSE
       loc:RetValue = - 1
    END
 ELSE
    loc:RetValue = CFC_GetLastError()
 END
 RETURN loc:RetValue
CFCMenuBase.Kill          PROCEDURE
 CODE
 IF SELF.hbrBack ! free the background brush
    err# = CFC_DeleteObject(SELF.hbrBack)
 END
 CFC_DestroyMenu(SELF.hMenu)

CFCMenuBase.IsSubMenusExists       PROCEDURE
loc:RetValue LONG
 CODE
 loc:RetValue = 0
 LOOP j# = 1 TO SELF.GetMenuItemCount()
    GET(SELF.MIQ,j#)
    IF NOT SELF.MIQ.MenuItem &= NULL
       IF NOT SELF.MIQ.MenuItem.SubMenu &= NULL
          loc:RetValue = 1
          BREAK
       END
    END
 END
 RETURN loc:RetValue

CFCMenuBase.SetComctrlClass PROCEDURE(*CFCComctrlClass inComctrl)
 CODE
 SELF.Comctrl &= inComctrl
CFCMenuBase.SetDrawingClass      PROCEDURE(*CFCMenuItemDrawClass inDrawingClass,<BYTE inExcludeSubmenus>)
loc:ExcludeSubmenus BYTE
 CODE
 IF NOT OMITTED(3)
    loc:ExcludeSubmenus = inExcludeSubmenus
 END
 SELF.SetDrawingClass(inDrawingClass,loc:ExcludeSubmenus,SELF)

CFCMenuBase.SetDrawingClass      PROCEDURE(*CFCMenuItemDrawClass inDrawingClass,BYTE inExcludeSubmenus,*CFCMenuBase inMenuBase)
 CODE
 LOOP j# = 1 TO RECORDS(inMenuBase.MIQ)
    GET(inMenuBase.MIQ,j#)
    IF NOT inMenuBase.MIQ.MenuItem &= NULL
       inMenuBase.MIQ.MenuItem.SetDrawingClass(inDrawingClass)
       IF NOT inExcludeSubmenus ! process submenus ?
          IF NOT inMenuBase.MIQ.MenuItem.SubMenu &= NULL
             SELF.SetDrawingClass(inDrawingClass,inExcludeSubmenus,inMenuBase.MIQ.MenuItem.SubMenu)
          END
       END
    END
 END
CFCMenuBase.OnInitMenuPopup       PROCEDURE
 CODE
CFCMenuBase.OnUninitMenuPopup     PROCEDURE
 CODE
!**************************************************************************************************************
CFCMenu.CreateMenu               PROCEDURE
loc:RetValue   LONG
 CODE
 loc:RetValue = 0                     ! OK
 SELF.hMenu = CFC_CreateMenu()        ! create the menu
 IF NOT SELF.hMenu                    ! have an error with CFC_CreateMenu()
    loc:RetValue = CFC_GetLastError() ! here we know the problem
 END
 RETURN loc:RetValue                  ! return the error
CFCMenu.SetMenuToWnd           PROCEDURE(ULONG in_hWnd)
 CODE
 SELF.hWnd = in_hWnd
 RETURN CFC_SetMenu(SELF.hWnd,SELF.hMenu)

 ! The function sets the SELF.hWnd property.
 ! If the function succeeds, the return value is nonzero. If the function fails, the return value is zero.
CFCMenu.Update          PROCEDURE
 CODE
 Err# = CFC_DrawMenuBar(SELF.hWnd)
!**************************************************************************************************************
CFCPopupMenu.CreateMenu PROCEDURE
loc:RetValue   LONG
 CODE
 loc:RetValue = 0                     ! OK
 SELF.hMenu = CFC_CreatePopupMenu()   ! create the menu
 IF NOT SELF.hMenu                    ! have an error with CFC_CreateMenu()
    loc:RetValue = CFC_GetLastError() ! here we know the problem
 END
 RETURN loc:RetValue                  ! return the error
CFCPopupMenu.Run PROCEDURE(ULONG hWnd,<LONG x>,<LONG y>)
CurPos   LIKE(CFC_POINT)
RetValue LONG
 CODE
 SELF.hWnd = hWnd
 Err# = CFC_GetCursorPos(ADDRESS(CurPos))
 IF NOT OMITTED(3)
    CurPos.x = x
 END
 IF NOT OMITTED(4)
    CurPos.y = y
 END

 RetValue = CFC_TrackPopupMenu(SELF.hMenu,0,CurPos.x,CurPos.y,0,hWnd,0)
 CFC_PostMessage(0{Prop:Handle},0,0,0)

 RETURN RetValue
 


!**************************************************************************************************************
CFCMenuItem.Construct            PROCEDURE
 CODE

CFCMenuItem.Destruct             PROCEDURE
 CODE
 IF SELF.hIcon THEN CFC_DestroyIcon(SELF.hIcon).
 IF SELF.hIconDisabled THEN CFC_DestroyIcon(SELF.hIconDisabled).
 IF SELF.hCheckedIconDisabled THEN CFC_DestroyIcon(SELF.hCheckedIconDisabled).
 IF SELF.hCheckedIcon THEN CFC_DestroyIcon(SELF.hCheckedIcon).
 IF NOT SELF.cstrText &= NULL THEN DISPOSE(SELF.cstrText).

CFCMenuItem.SetCommandCnt        PROCEDURE(*CFCCommandCnt inCnt)
 CODE
 SELF.Cnt &= inCnt
CFCMenuItem.SetMenuItemStrID        PROCEDURE(STRING inMenuItemID)
 CODE
 SELF.strID = inMenuItemID
CFCMenuItem.InsertMenuItem       PROCEDURE(*CFCMenuBase inMenu,STRING inMenuItemText)
 CODE
 RETURN SELF.InsertMenuItemByPos(inMenu,inMenuItemText,RECORDS(inMenu.MIQ))
CFCMenuItem.InsertMenuItemByPos  PROCEDURE(*CFCMenuBase inMenu,STRING inMenuItemText,LONG inPos)
loc:RetValue       LONG
loc:lpmii          LIKE(CFC_MENUITEMINFO)
 CODE
 SELF.cstrText &= NEW CSTRING(LEN(CLIP(inMenuItemText))+1)
 IF NOT SELF.cstrText &= NULL
    SELF.cstrText = inMenuItemText

    CLEAR(inMenu.MIQ)
    inMenu.MIQ.MenuItem &= SELF
    ADD(inMenu.MIQ)
    SELF.ID = SELF.Cnt.GetNextID()  ! get the menu item id
    SELF.Text = inMenuItemText      ! set the menu item text
    SELF.Menu &= inMenu
    CLEAR(loc:lpmii)
    loc:lpmii.cbSize = SIZE(CFC_MENUITEMINFO)
    loc:lpmii.fMask = CFC_MIIM_STRING + CFC_MIIM_ID
    loc:lpmii.wID = SELF.ID
    loc:lpmii.dwTypeData = ADDRESS(SELF.cstrText)

    IF NOT CFC_InsertMenuItem(inMenu.hMenu,inPos,TRUE,ADDRESS(loc:lpmii))
       loc:RetValue = CFC_GetLastError()
    END

 ELSE
    loc:RetValue = -1
 END
 RETURN loc:RetValue
CFCMenuItem.InsertSeparator      PROCEDURE(*CFCMenuBase inMenu)
 CODE
 RETURN SELF.InsertSeparatorByPos(inMenu,RECORDS(inMenu.MIQ))
CFCMenuItem.InsertSeparatorByPos PROCEDURE(*CFCMenuBase inMenu,LONG inPos)
loc:lpmii          LIKE(CFC_MENUITEMINFO)
loc:RetValue       LONG
 CODE
 CLEAR(inMenu.MIQ)
 inMenu.MIQ.MenuItem &= SELF
 ADD(inMenu.MIQ)
 SELF.ID = SELF.Cnt.GetNextID()  ! get the menu item id
 SELF.Text = '-'                 ! set the menu item text
 SELF.Menu &= inMenu
 SELF.FlagSeparator = TRUE
 CLEAR(loc:lpmii)
 loc:lpmii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:lpmii.fMask = CFC_MIIM_FTYPE + CFC_MIIM_ID
 loc:lpmii.fType = CFC_MFT_SEPARATOR
 loc:lpmii.wID = SELF.ID

 IF NOT CFC_InsertMenuItem(inMenu.hMenu,inPos,TRUE,ADDRESS(loc:lpmii))
    loc:RetValue = CFC_GetLastError()
 END

 RETURN loc:RetValue
CFCMenuItem.GetMenuItemText      PROCEDURE()
 CODE
 RETURN SELF.Text
CFCMenuItem.SetMenuItemText      PROCEDURE(STRING inMenuItemText)
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 IF NOT SELF.cstrText &= NULL
    DISPOSE(SELF.cstrText)
 END

 SELF.cstrText &= NEW CSTRING(LEN(CLIP(inMenuItemText))+1)
 IF NOT SELF.cstrText &= NULL
    SELF.cstrText = inMenuItemText
    CLEAR(loc:mii)
    loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
    loc:mii.fMask = CFC_MIIM_STRING
    loc:mii.dwTypeData = ADDRESS(SELF.cstrText)
    IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
       loc:RetValue = CFC_GetLastError()
    ELSE
       SELF.Text = inMenuItemText
    END
 ELSE
    loc:RetValue = -1
 END

 RETURN loc:RetValue
CFCMenuItem.SetMenuItemChecked      PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_STATE
 IF NOT CFC_GetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = CFC_GetLastError()
 ELSE
    loc:mii.fState = BOR(loc:mii.fState,CFC_MFS_CHECKED)
    IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
       loc:RetValue = CFC_GetLastError()
    END
 END

 RETURN loc:RetValue


CFCMenuItem.SetMenuItemUnchecked      PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_STATE
 IF NOT CFC_GetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = CFC_GetLastError()
 ELSE
    IF BAND(loc:mii.fState,CFC_MFS_CHECKED) = CFC_MFS_CHECKED
       loc:mii.fState -= CFC_MFS_CHECKED
       IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
          loc:RetValue = CFC_GetLastError()
       END
    END
 END
 RETURN loc:RetValue
CFCMenuItem.IsMenuItemChecked      PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = FALSE
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_STATE
 IF NOT CFC_GetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = - CFC_GetLastError()
 ELSE
    IF BAND(loc:mii.fState,CFC_MFS_CHECKED) = CFC_MFS_CHECKED
       loc:RetValue = TRUE
    END
 END

 RETURN loc:RetValue
CFCMenuItem.SetMenuItemDisabled      PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_STATE
 IF NOT CFC_GetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = CFC_GetLastError()
 ELSE
    loc:mii.fState = BOR(loc:mii.fState,CFC_MFS_DISABLED)
    IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
       loc:RetValue = CFC_GetLastError()
    END
 END

 RETURN loc:RetValue


CFCMenuItem.SetMenuItemEnabled      PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_STATE
 IF NOT CFC_GetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = CFC_GetLastError()
 ELSE
    IF BAND(loc:mii.fState,CFC_MFS_DISABLED) = CFC_MFS_DISABLED
       loc:mii.fState -= CFC_MFS_DISABLED
       IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
          loc:RetValue = CFC_GetLastError()
       END
    END
 END
 RETURN loc:RetValue
CFCMenuItem.IsMenuItemDisabled      PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = FALSE
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_STATE
 IF NOT CFC_GetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = - CFC_GetLastError()
 ELSE
    IF BAND(loc:mii.fState,CFC_MFS_DISABLED) = CFC_MFS_DISABLED
       loc:RetValue = TRUE
    END
 END

 RETURN loc:RetValue
CFCMenuItem.AttachSubmenu        PROCEDURE(*CFCMenuBase inMenu)
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0                              ! OK
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_SUBMENU
 loc:mii.hSubMenu = inMenu.hMenu
 IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = CFC_GetLastError()
 ELSE
    SELF.SubMenu &= inMenu
 END
 RETURN loc:RetValue

CFCMenuItem.DetachSubmenu        PROCEDURE
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0                              ! OK
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_SUBMENU
 loc:mii.hSubMenu = 0
 IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
    loc:RetValue = CFC_GetLastError()
 ELSE
    SELF.SubMenu &= NULL
 END
 RETURN loc:RetValue

CFCMenuItem.GetSubmenu           PROCEDURE()
 CODE
 RETURN SELF.SubMenu
CFCMenuItem.SetIcon PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>)
loc:RetValue      LONG
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 loc:RetValue = 0 ! OK

 ! set IconName property
 SELF.IconName = inIconName

 ! load the icon and get the icon handle
 IF OMITTED(4)
    SELF.IconWidth = 16
 ELSE
    SELF.IconWidth = inWidth
 END
 IF OMITTED(5)
    SELF.IconHeight = 16
 ELSE
    SELF.IconHeight = inHeight
 END

 IF SELF.hIcon THEN CFC_DestroyIcon(SELF.hIcon).

 IF OMITTED(3)
    SELF.hIcon = SELF.Menu.GDI.LoadIconFromDll(SELF.IconName,,SELF.IconWidth,SELF.IconHeight)
 ELSE
    SELF.hIcon = SELF.Menu.GDI.LoadIconFromDll(SELF.IconName,inDllName,SELF.IconWidth,SELF.IconHeight)
 END

 IF NOT SELF.hIcon
    loc:RetValue = -1
 ELSE
    ! create the disabled icon
    SELF.hIconDisabled = SELF.Menu.GDI.CreateDisabledIcon(SELF.hIcon)

    CLEAR(loc:mii)
    loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
    loc:mii.fMask = CFC_MIIM_BITMAP
    loc:mii.hbmpItem = CFC_HBMMENU_CALLBACK

    IF NOT CFC_SetMenuItemInfo(SELF.Menu.hMenu,SELF.ID,0,ADDRESS(loc:mii))
       loc:RetValue = CFC_GetLastError()
    END
 END

 RETURN loc:RetValue
CFCMenuItem.SetCheckedIcon PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>)
loc:RetValue          LONG
loc:CheckedIconWidth  LONG
loc:CheckedIconHeight LONG
 CODE
 loc:RetValue = 0 ! OK

 ! set IconName property
 SELF.CheckedIconName = inIconName

 ! load the icon and get the icon handle
 IF OMITTED(4)
    loc:CheckedIconWidth = 16
 ELSE
    loc:CheckedIconWidth = inWidth
 END
 IF OMITTED(5)
    loc:CheckedIconHeight = 16
 ELSE
    loc:CheckedIconHeight = inHeight
 END

 IF SELF.hCheckedIcon THEN CFC_DestroyIcon(SELF.hCheckedIcon).

 IF OMITTED(3)
    SELF.hCheckedIcon = SELF.Menu.GDI.LoadIconFromDll(SELF.CheckedIconName,,loc:CheckedIconWidth,loc:CheckedIconHeight)
 ELSE
    SELF.hCheckedIcon = SELF.Menu.GDI.LoadIconFromDll(SELF.CheckedIconName,inDllName,loc:CheckedIconWidth,loc:CheckedIconHeight)
 END

 IF NOT SELF.hCheckedIcon
    loc:RetValue = -1
 ELSE
    ! create the disabled icon
    SELF.hCheckedIconDisabled = SELF.Menu.GDI.CreateDisabledIcon(SELF.hCheckedIcon)
 END

 RETURN loc:RetValue


CFCMenuItem.OnClick                  PROCEDURE()
 CODE
CFCMenuItem.OnMeasureItem        PROCEDURE(ULONG hWnd,LONG lParam)
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.OnMeasureItem(SELF,hWnd,lParam)
 END
CFCMenuItem.OnDrawItem        PROCEDURE(ULONG hWnd,LONG lParam)
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.OnDrawItem(SELF,hWnd,lParam)
 END
CFCMenuItem.SetOwnerdraw         PROCEDURE!,VIRTUAL
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.SetOwnerdraw(SELF)
 END
CFCMenuItem.RemoveOwnerdraw      PROCEDURE!,VIRTUAL
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.RemoveOwnerdraw(SELF)
 END
CFCMenuItem.SetTopLevel          PROCEDURE
 CODE
 SELF.FlagTopLevel = TRUE
CFCMenuItem.SetDrawingClass      PROCEDURE(*CFCMenuItemDrawClass inDrawingClass)
 CODE
 SELF.DrawingClass &= inDrawingClass
 SELF.RemoveOwnerdraw()
 SELF.SetOwnerdraw()
 SELF.UpdateMenuItem()
CFCMenuItem.GetDrawingClass      PROCEDURE
 CODE
 RETURN SELF.DrawingClass
CFCMenuItem.UpdateMenuItem       PROCEDURE!,VIRTUAL
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.UpdateMenuItem(SELF)
 END
CFCMenuItem.DeleteMenuItem       PROCEDURE
RetValue LONG
 CODE
 RetValue = CFC_DeleteMenu(SELF.Menu.hMenu,SELF.ID,0)
 IF RetValue
    LOOP k# = 1 TO RECORDS(SELF.Menu.MIQ)
       GET(SELF.Menu.MIQ,k#)
       IF NOT SELF.Menu.MIQ.MenuItem &= NULL
          IF SELF.Menu.MIQ.MenuItem.ID = SELF.ID
             DELETE(SELF.Menu.MIQ)
             BREAK
          END
       END
    END
 END

 RETURN RetValue
 ! If the function fails, the return value is zero
CFCMenuItem.AddMenuItem PROCEDURE(*CFCMenuBase inMenu,STRING inMenuItemText,*CFCCommandCnt inCnt,<BYTE inFlagTopLevel>,<STRING inItemStrID>)
 CODE
 SELF.SetCommandCnt(inCnt)
 
 IF NOT OMITTED(5)
    IF inFlagTopLevel
       SELF.SetTopLevel()
    END
 END
 IF NOT OMITTED(6)
    SELF.SetMenuItemStrID(inItemStrID)
 END

 RETURN SELF.InsertMenuItem(inMenu,inMenuItemText)
CFCMenuItem.AddSeparator PROCEDURE(*CFCMenuBase inMenu,*CFCCommandCnt inCnt,<STRING inItemStrID>)
 CODE
 SELF.SetCommandCnt(inCnt)
 
 IF NOT OMITTED(4)
    SELF.SetMenuItemStrID(inItemStrID)
 END

 RETURN SELF.InsertSeparator(inMenu)
CFCMenuItem.DrawTopLevelItem PROCEDURE
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.DrawTopLevelItem(SELF)
 END
CFCMenuItem.DrawMenuBar1px PROCEDURE
 CODE
 IF NOT SELF.DrawingClass &= NULL
    SELF.DrawingClass.DrawMenuBar1px(SELF)
 END

!**************************************************************************************************************
CFCMenuManager.Construct            PROCEDURE
 CODE
 SELF.MQ &= NEW CFCMenuQueue
 SELF.MDIChildQ &= NEW CFCMenuMdiChildWindowsQueue

CFCMenuManager.Destruct             PROCEDURE
 CODE
 IF NOT SELF.MQ &= NULL THEN DISPOSE(SELF.MQ).
 IF NOT SELF.MDIChildQ &= NULL THEN DISPOSE(SELF.MDIChildQ).
CFCMenuManager.AddMenu              PROCEDURE(*CFCMenuBase inMenu)
 CODE
 SELF.MQ.Menu &= inMenu
 ADD(SELF.MQ)
CFCMenuManager.DeleteMenu              PROCEDURE(*CFCMenuBase inMenu)
 CODE
 LOOP j# = 1 TO RECORDS(SELF.MQ)
    GET(SELF.MQ,j#)
    IF NOT SELF.MQ.Menu &= NULL
       IF SELF.MQ.Menu.hMenu = inMenu.hMenu
          DELETE(SELF.MQ)
          BREAK
       END
    END
 END
CFCMenuManager.GetMenuItemByID      PROCEDURE(LONG inMenuItemID)
loc:RetValue &CFCMenuItem
 CODE
 loc:RetValue &= NULL
 LOOP j# = 1 TO RECORDS(SELF.MQ)
    GET(SELF.MQ,j#)
    IF NOT SELF.MQ.Menu &= NULL
       LOOP k# = 1 TO RECORDS(SELF.MQ.Menu.MIQ)
          GET(SELF.MQ.Menu.MIQ,k#)
          IF NOT SELF.MQ.Menu.MIQ.MenuItem &= NULL
             IF SELF.MQ.Menu.MIQ.MenuItem.ID = inMenuItemID
                loc:RetValue &= SELF.MQ.Menu.MIQ.MenuItem
                BREAK
             END
          END
       END
    END
 END
 RETURN loc:RetValue
CFCMenuManager.GetMenuItemByStrID      PROCEDURE(STRING inMenuItemID)
loc:RetValue &CFCMenuItem
 CODE
 loc:RetValue &= NULL
 LOOP j# = 1 TO RECORDS(SELF.MQ)
    GET(SELF.MQ,j#)
    IF NOT SELF.MQ.Menu &= NULL
       LOOP k# = 1 TO RECORDS(SELF.MQ.Menu.MIQ)
          GET(SELF.MQ.Menu.MIQ,k#)
          IF NOT SELF.MQ.Menu.MIQ.MenuItem &= NULL
             IF SELF.MQ.Menu.MIQ.MenuItem.strID = inMenuItemID
                loc:RetValue &= SELF.MQ.Menu.MIQ.MenuItem
                BREAK
             END
          END
       END
    END
 END
 RETURN loc:RetValue
CFCMenuManager.GetAnyTopLevelItemByhWnd PROCEDURE(ULONG hwnd)
CurrItem   &CFCMenuItem
 CODE
 FlagFind# = FALSE
 IF NOT SELF.MQ &= NULL
    LOOP j# = 1 TO RECORDS(SELF.MQ)
       GET(SELF.MQ,j#)
       IF NOT SELF.MQ.Menu &= NULL
          IF NOT SELF.MQ.Menu.MIQ &= NULL
             LOOP k# = 1 TO RECORDS(SELF.MQ.Menu.MIQ)
                GET(SELF.MQ.Menu.MIQ,k#)
                IF NOT SELF.MQ.Menu.MIQ.MenuItem &= NULL
                   IF SELF.MQ.Menu.MIQ.MenuItem.FlagTopLevel
                      IF SELF.MQ.Menu.hWnd = hwnd
                         FlagFind# = TRUE
                         CurrItem &= SELF.MQ.Menu.MIQ.MenuItem
                         BREAK
                      END
                   END
                END
             END
          END
       END
       IF FlagFind#
          BREAK
       END
    END
 END
 RETURN CurrItem

CFCMenuManager.CallBackProc         PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:WM_COMMAND         EQUATE(0111h)
loc:WM_DRAWITEM        EQUATE(02Bh)
loc:WM_MEASUREITEM     EQUATE(002Ch)
loc:WM_INITMENUPOPUP   EQUATE(0117h)
loc:WM_UNINITMENUPOPUP EQUATE(0125h)
loc:WM_NCMOUSEMOVE     EQUATE(0A0h)
loc:WM_ERASEBKGND      EQUATE(0014h)
loc:WM_NCACTIVATE      EQUATE(0086h)
loc:WM_SYSCOMMAND      EQUATE(0112h)
loc:SC_KEYMENU         EQUATE(0F100h)
loc:HTMENU             EQUATE(5)
loc:wParamG        GROUP,OVER(wParam)
low                   USHORT
high                  USHORT
                   END
loc:lParamG        GROUP,OVER(lParam)
low                   SHORT
high                  SHORT
                   END

loc:dis            LIKE(CFC_DRAWITEMSTRUCT)
loc:mis            LIKE(CFC_MEASUREITEMSTRUCT)
 CODE

 IF SELF.FlagSuppressAlt AND SELF.FlagIsWindows7OrLater
    IF inMsg = loc:WM_SYSCOMMAND ! supress "alt" keys
       IF BAND(wParam,0FFF0h) = loc:SC_KEYMENU AND (lParam = 0 OR lParam = 32)
          RETURN TRUE
       END
    END
 END

 IF inMsg = loc:WM_COMMAND
    IF lParam = 0 AND loc:wParamG.high = 0 ! is menu item
        SELF.OnCommand(loc:wParamG.low)
    END
 END

 IF inMsg = loc:WM_MEASUREITEM
    IF wParam = 0 ! message sent by menu
       CFC_memcpy(ADDRESS(loc:mis),lParam,SIZE(CFC_MEASUREITEMSTRUCT))
       IF loc:mis.CtlType = CFC_ODT_MENU
          SELF.OnMeasureItem(hWnd,lParam)
       END
    END
 END

 IF inMsg = loc:WM_DRAWITEM
    IF wParam = 0 ! message is sent by menu
       CFC_memcpy(ADDRESS(loc:dis),lParam,SIZE(CFC_DRAWITEMSTRUCT))
       IF loc:dis.CtlType = CFC_ODT_MENU
          SELF.OnDrawItem(hWnd,lParam)
          RETURN TRUE
       END
    END
 END

 IF inMsg = loc:WM_INITMENUPOPUP
    SELF.OnInitMenuPopup(wParam)
 END

 IF inMsg = loc:WM_UNINITMENUPOPUP
    SELF.OnUninitMenuPopup(wParam)
 END

 IF inMsg = loc:WM_NCMOUSEMOVE
    IF wParam = loc:HTMENU
       SELF.OnNCMouseMove(loc:lParamG.low,loc:lParamG.high)
    END
 END

 IF inMsg = loc:WM_ERASEBKGND 
    RetVal# = PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
    SELF.OnEraseBkgnd(hwnd)
    RETURN RetVal#
 END

 IF inMsg = loc:WM_NCACTIVATE
    RetVal# = PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
    SELF.OnNCActivate(hwnd)
    RETURN RetVal#
 END

 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
CFCMenuManager.OnCommand PROCEDURE(LONG inID)
loc:CurrentItem       &CFCMenuItem
 CODE
 ! define which menu item was pressed
 loc:CurrentItem &= SELF.GetMenuItemByID(inID)
 IF NOT loc:CurrentItem &= NULL
    loc:CurrentItem.OnClick()
 END
CFCMenuManager.OnMeasureItem PROCEDURE(ULONG hWnd,LONG lParam)
loc:mis            LIKE(CFC_MEASUREITEMSTRUCT)
loc:CurrentItem    &CFCMenuItem
 CODE
 CFC_memcpy(ADDRESS(loc:mis),lParam,SIZE(CFC_MEASUREITEMSTRUCT))
 loc:CurrentItem &= SELF.GetMenuItemByID(loc:mis.itemID)
 IF NOT loc:CurrentItem &= NULL
    loc:CurrentItem.OnMeasureItem(hWnd,lParam)
 END
CFCMenuManager.OnDrawItem PROCEDURE(ULONG hWnd,LONG lParam)
loc:dis            LIKE(CFC_DRAWITEMSTRUCT)
loc:CurrentItem    &CFCMenuItem
 CODE
 CFC_memcpy(ADDRESS(loc:dis),lParam,SIZE(CFC_DRAWITEMSTRUCT))
 loc:CurrentItem &= SELF.GetMenuItemByID(loc:dis.itemID)
 IF NOT loc:CurrentItem &= NULL
    loc:CurrentItem.OnDrawItem(hWnd,lParam)
 END
CFCMenuManager.OnInitMenuPopup      PROCEDURE(ULONG wParam)
 CODE
 IF NOT SELF.MQ &= NULL
    LOOP j# = 1 TO RECORDS(SELF.MQ)
       GET(SELF.MQ,j#)
       IF NOT SELF.MQ.Menu &= NULL
          IF SELF.MQ.Menu.hMenu = wParam
             SELF.MQ.Menu.OnInitMenuPopup()
             BREAK
          END
       END
    END
 END

 ! finding the parent top level menu item
 IF NOT SELF.MQ &= NULL
    LOOP j# = 1 TO RECORDS(SELF.MQ)
       GET(SELF.MQ,j#)
       IF NOT SELF.MQ.Menu &= NULL
          IF NOT SELF.MQ.Menu.MIQ &= NULL
             LOOP k# = 1 TO RECORDS(SELF.MQ.Menu.MIQ)
                GET(SELF.MQ.Menu.MIQ,k#)
                IF NOT SELF.MQ.Menu.MIQ.MenuItem.Submenu &= NULL
                   IF SELF.MQ.Menu.MIQ.MenuItem.Submenu.hMenu = wParam
                      SELF.MQ.Menu.MIQ.MenuItem.FlagSubmenuIsOpened = TRUE
                      IF SELF.MQ.Menu.MIQ.MenuItem.FlagTopLevel
                         SELF.MQ.Menu.MIQ.MenuItem.DrawTopLevelItem()
                      END
                   END
                END
             END
          END
       END
    END
 END
CFCMenuManager.OnUninitMenuPopup    PROCEDURE(ULONG wParam)
 CODE
 IF NOT SELF.MQ &= NULL
    LOOP j# = 1 TO RECORDS(SELF.MQ)
       GET(SELF.MQ,j#)
       IF NOT SELF.MQ.Menu &= NULL
          IF SELF.MQ.Menu.hMenu = wParam
             SELF.MQ.Menu.OnUninitMenuPopup()
             BREAK
          END
       END
    END
 END

 ! finding the parent top level menu item
 IF NOT SELF.MQ &= NULL
    LOOP j# = 1 TO RECORDS(SELF.MQ)
       GET(SELF.MQ,j#)
       IF NOT SELF.MQ.Menu &= NULL
          IF NOT SELF.MQ.Menu.MIQ &= NULL
             LOOP k# = 1 TO RECORDS(SELF.MQ.Menu.MIQ)
                GET(SELF.MQ.Menu.MIQ,k#)
                IF NOT SELF.MQ.Menu.MIQ.MenuItem.Submenu &= NULL
                   IF SELF.MQ.Menu.MIQ.MenuItem.Submenu.hMenu = wParam
                      SELF.MQ.Menu.MIQ.MenuItem.FlagSubmenuIsOpened = FALSE
                      IF SELF.MQ.Menu.MIQ.MenuItem.FlagTopLevel
                         Err# = CFC_DrawMenuBar(SELF.MQ.Menu.hWnd)
                      END
                   END
                END
             END
          END
       END
    END
 END
CFCMenuManager.OnNCMouseMove PROCEDURE(SHORT x,SHORT y)
 CODE
CFCMenuManager.OnEraseBkgnd PROCEDURE(ULONG hwnd)
CurrItem         &CFCMenuItem
 CODE
 CurrItem &= SELF.GetAnyTopLevelItemByhWnd(hwnd)
 IF NOT CurrItem &= NULL
    CurrItem.DrawMenuBar1px()
 END
CFCMenuManager.OnNCActivate PROCEDURE(ULONG hwnd)
CurrItem         &CFCMenuItem
 CODE
 CurrItem &= SELF.GetAnyTopLevelItemByhWnd(hwnd)
 IF NOT CurrItem &= NULL
    CurrItem.DrawMenuBar1px()
 END
CFCMenuManager.FillMDIChildWindows PROCEDURE(ULONG in_MDIParent_hwnd)
 CODE
 FREE(SELF.MDIChildQ)
 Err# = CFC_EnumChildWindows(in_MDIParent_hwnd,ADDRESS(CFC_MenuEnumerateWindows),ADDRESS(SELF))

!**************************************************************************************************************
CFCMenuItemDrawClass.OnMeasureItem        PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
 CODE

CFCMenuItemDrawClass.OnDrawItem           PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
 CODE

CFCMenuItemDrawClass.SetOwnerdraw         PROCEDURE(*CFCMenuItem CurrItem)
 CODE
CFCMenuItemDrawClass.RemoveOwnerdraw         PROCEDURE(*CFCMenuItem CurrItem)
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_FTYPE
 IF CFC_GetMenuItemInfo(CurrItem.Menu.hMenu,CurrItem.ID,0,ADDRESS(loc:mii))
    IF BAND(loc:mii.fType,CFC_MFT_OWNERDRAW) = CFC_MFT_OWNERDRAW
       loc:mii.fType -= CFC_MFT_OWNERDRAW
       Err# = CFC_SetMenuItemInfo(CurrItem.Menu.hMenu,CurrItem.ID,0,ADDRESS(loc:mii))
    END
 END
CFCMenuItemDrawClass.UpdateMenuItem PROCEDURE(*CFCMenuItem CurrItem)
loc:mii  LIKE(CFC_MENUITEMINFO)
 CODE
 ! this API's below initiate a WM_MESUREITEM message
 IF NOT CurrItem.FlagTopLevel
    IF NOT CurrItem.FlagSeparator
       CLEAR(loc:mii)
       loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
       loc:mii.fMask = CFC_MIIM_BITMAP
       loc:mii.hbmpItem = CFC_HBMMENU_CALLBACK
       Err# = CFC_SetMenuItemInfo(CurrItem.Menu.hMenu,CurrItem.ID,0,ADDRESS(loc:mii))
    END
 END
CFCMenuItemDrawClass.DrawTopLevelItem PROCEDURE(*CFCMenuItem CurrItem)
 CODE
 
CFCMenuItemDrawClass.DrawMenuBar1px PROCEDURE(*CFCMenuItem CurrItem)
hTmpBrush        ULONG
loc:mbi          LIKE(CFC_MENUBARINFO)
loc:OBJID_MENU   EQUATE(-3)
loc:hDC          ULONG
rcWork           LIKE(CFC_RECT)
 CODE
 ! here we draw the 1px line in the bottom of the menubar
 IF CurrItem.Menu.BkrColor
    hTmpBrush = CFC_CreateSolidBrush(CurrItem.Menu.BkrColor)
 ELSE
    hTmpBrush = CFC_GetSysColorBrush(CFC_COLOR_MENUBAR)
    IF NOT hTmpBrush THEN hTmpBrush = CFC_GetSysColorBrush(CFC_COLOR_MENU).
 END

 CLEAR(loc:mbi)
 loc:mbi.cbSize = SIZE(CFC_MENUBARINFO)
 IF NOT CurrItem.Menu.Comctrl &= NULL
    IF CurrItem.Menu.Comctrl._CFC_SetMenuInfo_
       IF CFC_GetMenuBarInfo(CurrItem.Menu.hWnd,loc:OBJID_MENU,0,ADDRESS(loc:mbi))
          loc:hDC = CFC_GetWindowDC(CurrItem.Menu.hWnd)
          Err# = CFC_GetWindowRect(CurrItem.Menu.hWnd,ADDRESS(rcWork))

          width# = ABS(loc:mbi.rcBar.right - loc:mbi.rcBar.left)
          height# = ABS(loc:mbi.rcBar.bottom - loc:mbi.rcBar.top)

          loc:mbi.rcBar.left -= rcWork.left
          loc:mbi.rcBar.top -= rcWork.top
          loc:mbi.rcBar.right =  loc:mbi.rcBar.left + width#
          loc:mbi.rcBar.bottom = loc:mbi.rcBar.top + height#
          loc:mbi.rcBar.top = loc:mbi.rcBar.bottom
          loc:mbi.rcBar.bottom += 1

          CFC_FrameRect(loc:hDC,ADDRESS(loc:mbi.rcBar),hTmpBrush)
          CFC_ReleaseDC(CurrItem.Menu.hWnd,loc:hDC)
       END
    END
 END
 Err# = CFC_DeleteObject(hTmpBrush)
!**************************************************************************************************************
CFCMenuItemDrawClass:Std.Construct            PROCEDURE
 CODE
 SELF.MenuItemTextOffset = 4

CFCMenuItemDrawClass:Std.Destruct             PROCEDURE
 CODE

CFCMenuItemDrawClass:Std.OnMeasureItem        PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
loc:mis            LIKE(CFC_MEASUREITEMSTRUCT)
 CODE
 PARENT.OnMeasureItem(CurrItem,hWnd,lParam)

 CFC_memcpy(ADDRESS(loc:mis),lParam,SIZE(CFC_MEASUREITEMSTRUCT))
 loc:mis.itemWidth = SELF.MenuItemTextOffset
 loc:mis.itemHeight = CurrItem.IconHeight
 CFC_memcpy(lParam,ADDRESS(loc:mis),SIZE(CFC_MEASUREITEMSTRUCT))

CFCMenuItemDrawClass:Std.OnDrawItem           PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
loc:dis            LIKE(CFC_DRAWITEMSTRUCT)
 CODE
 PARENT.OnDrawItem(CurrItem,hWnd,lParam)

 CFC_memcpy(ADDRESS(loc:dis),lParam,SIZE(CFC_DRAWITEMSTRUCT))
 IF BAND(loc:dis.itemState,CFC_ODS_DISABLED) = CFC_ODS_DISABLED |
    OR BAND(loc:dis.itemState,CFC_ODS_GRAYED) = CFC_ODS_GRAYED
    IF CurrItem.hIconDisabled
       CFC_DrawIconEx(loc:dis.hDC,0,0,CurrItem.hIconDisabled,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
    END
 ELSE
    IF CurrItem.hIcon
       CFC_DrawIconEx(loc:dis.hDC,0,0,CurrItem.hIcon,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
    END
 END
!**************************************************************************************************************
CFCMenuItemDrawClass:XP.Construct            PROCEDURE
 CODE
 SELF.ItemHeight = 22
 SELF.IconBarWidth = 20
 SELF.MenuItemTextOffset = 4
 SELF.SubMenuOffset = 20

 SELF.Color:ItemBackground = COLOR:WHITE
 SELF.Color:SelectedItem = 0DFBFBFh
 SELF.Color:DisabledItemBackground = COLOR:WHITE
 SELF.Color:ItemBorder = 0800000h
 SELF.Color:PopupWindowBorder = 07A868Ah
 SELF.Color:Separator = COLOR:GRAY
 SELF.Color:Shadow:1 = 0919C9Eh
 SELF.Color:Shadow:2 = 0B4C2C4h
CFCMenuItemDrawClass:XP.Destruct             PROCEDURE
 CODE
CFCMenuItemDrawClass:XP.OnMeasureItem        PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
loc:mis            LIKE(CFC_MEASUREITEMSTRUCT)
loc:hDC            ULONG
mem:hDC            ULONG
loc:cstrTmp        &CSTRING
loc:hFont          ULONG
loc:hPrevFont      ULONG
loc:strRect        LIKE(CFC_RECT)
loc:strSize        GROUP(CFC_SIZESTRUCT).
 CODE
 PARENT.OnMeasureItem(CurrItem,hWnd,lParam)

 CFC_memcpy(ADDRESS(loc:mis),lParam,SIZE(CFC_MEASUREITEMSTRUCT))

 IF CurrItem.FlagSeparator
    loc:mis.itemHeight = 3
 ELSE
    loc:cstrTmp &= NEW CSTRING(LEN(CLIP(CurrItem.Text)) + 1)
    loc:cstrTmp = CLIP(CurrItem.Text)

    loc:hDC = CFC_GetDC(hWnd)

    mem:hDC = CFC_CreateCompatibleDC(loc:hDC)
    IF mem:hDC

       loc:hFont = CurrItem.Menu.Comctrl.RetrieveSystemMenuFont()
       loc:hPrevFont = CFC_SelectObject(mem:hDC,loc:hFont)

       CFC_SetTextCharacterExtra(mem:hDC,0)

       IF CFC_DrawText(mem:hDC,ADDRESS(loc:cstrTmp),LEN(loc:cstrTmp),ADDRESS(loc:strRect),CFC_DT_SINGLELINE + CFC_DT_VCENTER + CFC_DT_EXPANDTABS + CFC_DT_CALCRECT)
          loc:strSize.cx = ABS(loc:strRect.right - loc:strRect.left)
          loc:strSize.cy = ABS(loc:strRect.bottom - loc:strRect.top)
       ELSE
          CFC_GetTextExtentPoint32(mem:hDC,ADDRESS(loc:cstrTmp),LEN(CLIP(loc:cstrTmp)),ADDRESS(loc:strSize))
       END

       loc:mis.itemHeight = SELF.ItemHeight
       IF NOT CurrItem.FlagTopLevel
          loc:mis.itemWidth = loc:strSize.cx + SELF.IconBarWidth + SELF.MenuItemTextOffset * 2 + 10 ! 10px for beauty :)
       ELSE
          loc:mis.itemWidth = loc:strSize.cx
          loc:mis.itemHeight = 20
       END

       ! if submenu exists
       IF NOT CurrItem.FlagTopLevel
          IF CurrItem.Menu.IsSubMenusExists()
             loc:mis.itemWidth += SELF.SubMenuOffset
          END
       END

       Err# = CFC_SelectObject(mem:hDC,loc:hPrevFont)
       Err# = CFC_DeleteObject(loc:hFont)
       Err# = CFC_DeleteDC(mem:hDC)
    END
    CFC_ReleaseDC(hWnd,loc:hDC)
    DISPOSE(loc:cstrTmp)
 END
 
 CFC_memcpy(lParam,ADDRESS(loc:mis),SIZE(CFC_MEASUREITEMSTRUCT))
CFCMenuItemDrawClass:XP.OnDrawItem           PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
loc:dis                 LIKE(CFC_DRAWITEMSTRUCT)

rcInfo                  LIKE(CFC_RECT)
rcWork                  LIKE(CFC_RECT)

hMenuBKBrush            ULONG
hTmpBrush               ULONG

loc:hFont               ULONG
loc:hPrevFont           ULONG

 CODE
 PARENT.OnDrawItem(CurrItem,hWnd,lParam)

 CFC_memcpy(ADDRESS(loc:dis),lParam,SIZE(CFC_DRAWITEMSTRUCT))
 CFC_memcpy(ADDRESS(rcInfo),ADDRESS(loc:dis.rcItem),SIZE(CFC_RECT))

 ! save the item rect
 CurrItem.rcItem = rcInfo 

 ! draw the border around the window
 IF NOT CurrItem.FlagTopLevel
    SELF.DrawFlatWindow(CurrItem,CFC_WindowFromDC(loc:dis.hDC))
 END

 ! draw the background
 rcWork = rcInfo
 IF NOT CurrItem.FlagTopLevel
    hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENUBAR)
    IF NOT hMenuBKBrush THEN hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENU).
 ELSE
    IF CurrItem.Menu.BkrColor
       hMenuBKBrush = CFC_CreateSolidBrush(CurrItem.Menu.BkrColor)
    ELSE
       hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENUBAR)
       IF NOT hMenuBKBrush THEN hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENU).
    END
 END

 CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hMenuBKBrush)

 IF NOT CurrItem.FlagTopLevel
    hTmpBrush = CFC_CreateSolidBrush(SELF.Color:ItemBackground)
    rcWork.left += SELF.IconBarWidth
    CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
    Err# = CFC_DeleteObject(hTmpBrush)
 END

 ! draw the separator
 rcWork = rcInfo
 IF CurrItem.FlagSeparator
    rcWork.left += SELF.IconBarWidth + SELF.MenuItemTextOffset
    rcWork.top += 1
    rcWork.bottom -= 1
    hTmpBrush = CFC_CreateSolidBrush(SELF.Color:Separator)
    CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
    Err# = CFC_DeleteObject(hTmpBrush)
 END

 ! draw the selected item
 rcWork = rcInfo
 IF BAND(loc:dis.itemState,CFC_ODS_SELECTED) OR BAND(loc:dis.itemState,CFC_ODS_HOTLIGHT)
    IF BAND(loc:dis.itemState,CFC_ODS_GRAYED)
       hTmpBrush = CFC_CreateSolidBrush(SELF.Color:DisabledItemBackground)
       CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       Err# = CFC_DeleteObject(hTmpBrush)
    ELSE
       IF NOT (CurrItem.FlagSubmenuIsOpened AND CurrItem.FlagTopLevel)
          hTmpBrush = CFC_CreateSolidBrush(SELF.Color:SelectedItem)
          CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
          Err# = CFC_DeleteObject(hTmpBrush)
       ELSE
          CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hMenuBKBrush)
       END
    END
    IF NOT (CurrItem.FlagSubmenuIsOpened AND CurrItem.FlagTopLevel)
       hTmpBrush = CFC_CreateSolidBrush(SELF.Color:ItemBorder)
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       Err# = CFC_DeleteObject(hTmpBrush)
    ELSE
       hTmpBrush = CFC_CreateSolidBrush(SELF.Color:PopupWindowBorder)
       rcWork.right = rcWork.left + 1
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       rcWork = rcInfo
       rcWork.left = rcWork.right - 1
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       rcWork = rcInfo
       rcWork.bottom = rcWork.top + 1
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       Err# = CFC_DeleteObject(hTmpBrush)

       ! draw the simple shadow
       SELF.DrawShadow(rcInfo,loc:dis.hDC)
    END
 END

 ! draw the icon
 rcWork = rcInfo
 rcWork.top += INT((SELF.ItemHeight - 16)/2+0.5)
 rcWork.left += 2

 IF BAND(loc:dis.itemState,CFC_ODS_CHECKED)
    IF BAND(loc:dis.itemState,CFC_ODS_GRAYED)
       IF CurrItem.hCheckedIconDisabled
          CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hCheckedIconDisabled,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
       END
    ELSE
       IF CurrItem.hCheckedIcon
          CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hCheckedIcon,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
       END
    END
 ELSIF BAND(loc:dis.itemState,CFC_ODS_GRAYED)
    IF CurrItem.hIconDisabled
       CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hIconDisabled,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
    END
 ELSE
    IF CurrItem.hIcon
       Err# = CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hIcon,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
    END
 END

 ! set the color of menu item
 IF BAND(loc:dis.itemState,CFC_ODS_DISABLED) OR BAND(loc:dis.itemState,CFC_ODS_GRAYED)
    Err# = CFC_SetTextColor(loc:dis.hDC,COLOR:GRAY)
 ELSE
    Err# = CFC_SetTextColor(loc:dis.hDC,COLOR:BLACK)
 END

 ! draw the item text
 rcWork = rcInfo

 IF NOT CurrItem.FlagTopLevel
    rcWork.left += SELF.IconBarWidth + SELF.MenuItemTextOffset
 END

 loc:hFont = CurrItem.Menu.Comctrl.RetrieveSystemMenuFont()
 loc:hPrevFont = CFC_SelectObject(loc:dis.hDC,loc:hFont)

 SELF.DrawItemText(CurrItem,loc:dis.hDC,rcWork)

 IF loc:hPrevFont
    Err# = CFC_SelectObject(loc:dis.hDC,loc:hPrevFont)
 END

 Err# = CFC_DeleteObject(loc:hFont)
 Err# = CFC_DeleteObject(hMenuBkBrush)
CFCMenuItemDrawClass:XP.SetOwnerdraw         PROCEDURE(*CFCMenuItem CurrItem)
loc:mii           LIKE(CFC_MENUITEMINFO)
 CODE
 PARENT.SetOwnerdraw(CurrItem)

 CLEAR(loc:mii)
 loc:mii.cbSize = SIZE(CFC_MENUITEMINFO)
 loc:mii.fMask = CFC_MIIM_FTYPE
 IF CFC_GetMenuItemInfo(CurrItem.Menu.hMenu,CurrItem.ID,0,ADDRESS(loc:mii))
    loc:mii.fType = BOR(loc:mii.fType,CFC_MFT_OWNERDRAW)
    Err# = CFC_SetMenuItemInfo(CurrItem.Menu.hMenu,CurrItem.ID,0,ADDRESS(loc:mii))
 END
CFCMenuItemDrawClass:XP.DrawItemText PROCEDURE(*CFCMenuItem CurrItem,LONG hDC,CFC_RECT inRect)
hPrevBKMode             ULONG    !   
uTextFormat             ULONG    !    
cstrTmp                 &CSTRING !  
cstrTmpTab              CSTRING(20)
 CODE
 hPrevBKMode = CFC_SetBkMode(hDC,CFC_TRANSPARENT) !  

 IF NOT CurrItem.FlagSeparator
    CFC_SetTextCharacterExtra(hDC,0)
    uTextFormat = CFC_DT_SINGLELINE + CFC_DT_VCENTER + CFC_DT_EXPANDTABS
    IF CurrItem.FlagTopLevel
       uTextFormat += CFC_DT_CENTER
    END

    cstrTmp &= NEW CSTRING(LEN(CLIP(CurrItem.Text)) + 1)

    ! workaround hotkeys
    FlagFindTab# = FALSE
    LOOP i# = 1 TO LEN(CurrItem.Text)
       IF CurrItem.Text[i#] = '<9>'
          cstrTmp = SUB(CurrItem.Text,1,i#-1)
          FlagFindTab# = TRUE
          BREAK
       END
    END

    cstrTmpTab = ''
    IF FlagFindTab# !  
       LOOP i# = LEN(CLIP(CurrItem.Text)) TO 1 BY -1 !        -
          IF CurrItem.Text[i#] = '<9>'
             cstrTmpTab = CLIP(LEFT(SUB(CurrItem.Text,i#+1,LEN(CLIP(CurrItem.Text)))))
             BREAK
          END
       END
    ELSE
       cstrTmp = CLIP(CurrItem.Text)
    END

    !  
    CFC_DrawText(hDC,ADDRESS(cstrTmp),LEN(cstrTmp),ADDRESS(inRect),uTextFormat)

    IF LEN(CLIP(cstrTmpTab))
       ! if submenu exists
       IF CurrItem.Menu.IsSubMenusExists()
          inRect.Right -= SELF.SubMenuOffset
       ELSE
          inRect.Right -= SELF.MenuItemTextOffset
       END

       uTextFormat = CFC_DT_SINGLELINE + CFC_DT_VCENTER + CFC_DT_RIGHT
       CFC_DrawText(hDC,ADDRESS(cstrTmpTab),LEN(cstrTmpTab),ADDRESS(inRect),uTextFormat)
    END
    DISPOSE(cstrTmp)

 END

 IF hPrevBKMode
    CFC_SetBkMode(hDC,hPrevBKMode) ! 
 END
CFCMenuItemDrawClass:XP.DrawFlatWindow PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd)
loc:R             LIKE(CFC_RECT)
loc:origR         LIKE(CFC_RECT)
loc:hRgn          ULONG
loc:hDC           ULONG
loc:Brush         ULONG
 CODE
 IF CFC_GetWindowRect(hWnd,ADDRESS(loc:R))
    loc:origR :=: loc:R
    loc:hRgn = CFC_CreateRectRgn(loc:R.left,loc:R.top,loc:R.right,loc:R.bottom)
    IF loc:hRgn
       loc:hDC = CFC_GetDCEx(hWnd,loc:hRgn,1 + 2 + 080h + 010h)
       IF loc:hDC
          loc:Brush = CFC_CreateSolidBrush(SELF.Color:PopupWindowBorder)
          loc:R.right = loc:R.right - loc:R.left
          loc:R.bottom = loc:R.bottom - loc:R.top
          loc:R.left = 0
          loc:R.top = 0
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)
          Err# = CFC_DeleteObject(loc:Brush)

          loc:R.right -= 1 !
          loc:R.bottom - = 1
          loc:R.left += 1
          loc:R.top += 1
          loc:Brush = CFC_CreateSolidBrush(SELF.Color:ItemBackground)
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.top += 1
          loc:R.bottom = loc:R.top
          loc:R.left += SELF.IconBarWidth + 2
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.bottom = loc:origR.bottom - loc:origR.top - 2
          loc:R.top = loc:R.bottom
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.right -= 1
          loc:R.left = loc:R.right
          loc:R.top = 0
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)
          Err# = CFC_DeleteObject(loc:Brush)

          loc:R.left  = 2
          loc:R.right = 2
          loc:R.top = 1
          loc:R.bottom += 1
          loc:Brush = CFC_GetSysColorBrush(CFC_COLOR_MENUBAR)
          if NOT loc:Brush then loc:Brush = CFC_GetSysColorBrush(CFC_COLOR_MENU).
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.top  = 2
          loc:R.bottom = loc:R.top 
          loc:R.left  = 1 
          loc:R.right = SELF.IconBarWidth + 3
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.top  = loc:origR.bottom - loc:origR.top - 2
          loc:R.bottom = loc:R.top 
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)
          Err# = CFC_DeleteObject(loc:Brush)

       END
       CFC_ReleaseDC(hWnd,loc:hDC)
    END
 END
CFCMenuItemDrawClass:XP.DrawTopLevelItem PROCEDURE(*CFCMenuItem CurrItem)
loc:dis                 LIKE(CFC_DRAWITEMSTRUCT)
loc:WM_DRAWITEM         EQUATE(02Bh)
 CODE
 IF SELF.FlagDoNotDrawTopLevel THEN RETURN.

 PARENT.DrawTopLevelItem(CurrItem)

 IF CurrItem.FlagTopLevel
    CLEAR(loc:dis)
    loc:dis.CtlType = CFC_ODT_MENU
    loc:dis.itemID = CurrItem.ID
    loc:dis.itemAction = CFC_ODA_DRAWENTIRE
    loc:dis.itemState = CFC_ODS_HOTLIGHT
    loc:dis.hwndItem = CurrItem.Menu.hMenu
    loc:dis.hDC = CFC_GetWindowDC(CurrItem.Menu.hWnd)

    loc:dis.rcItem = CurrItem.rcItem

    SELF.OnDrawItem(CurrItem,CurrItem.Menu.hWnd,ADDRESS(loc:dis))

    CFC_ReleaseDC(CurrItem.Menu.hWnd,loc:dis.hDC)
 END
CFCMenuItemDrawClass:XP.DrawShadow PROCEDURE(CFC_RECT rcInfo,ULONG hDC)
rcWork     LIKE(CFC_RECT)
hTmpBrush  ULONG
 CODE
 ! draw the simple shadow
 rcWork = rcInfo
 hTmpBrush = CFC_CreateSolidBrush(SELF.Color:Shadow:1)
 rcWork.right + = 1
 rcWork.left = rcWork.right - 1
 rcWork.top += 2
 CFC_FrameRect(hDC,ADDRESS(rcWork),hTmpBrush)
 Err# = CFC_DeleteObject(hTmpBrush)

 hTmpBrush = CFC_CreateSolidBrush(SELF.Color:Shadow:2)
 rcWork.right + = 1
 rcWork.left = rcWork.right - 1
 rcWork.top += 2
 CFC_FrameRect(hDC,ADDRESS(rcWork),hTmpBrush)
 Err# = CFC_DeleteObject(hTmpBrush)
!**************************************************************************************************************
CFCMenuItemDrawClass:2003.Construct            PROCEDURE
 CODE
 SELF.Color:PopupWindowBorder = 0962D00H
 SELF.Color:IconBarGradientFrom = 0FFEFE3H
 SELF.Color:IconBarGradientTo = 0E4AD87H
 SELF.Color:Separator = 0CB8C6Ah
 SELF.Color:SelectedItem = 0C2EEFFh
 SELF.Color:TopLevelItemGradientFrom = 0CCF4FFh
 SELF.Color:TopLevelItemGradientTo = 09AD6FFh
 SELF.Color:Shadow:1 = 0A33C02h
 SELF.Color:Shadow:2 = 0CB8C6Ah
 SELF.Color:OpenedTopLevelItemGradientFrom = 0FFEFE3H
 SELF.Color:OpenedTopLevelItemGradientTo = 0E4AD87H



CFCMenuItemDrawClass:2003.Destruct             PROCEDURE
 CODE
CFCMenuItemDrawClass:2003.DrawFlatWindow              PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd)
loc:R             LIKE(CFC_RECT)
loc:origR         LIKE(CFC_RECT)
loc:hRgn          ULONG
loc:hDC           ULONG
loc:Brush         ULONG

loc:Vertex        LIKE(CFC_TRIVERTEX),DIM(2)
loc:G_RECT        LIKE(CFC_GRADIENT_RECT)
 CODE
 IF CFC_GetWindowRect(hWnd,ADDRESS(loc:R))
    loc:origR :=: loc:R
    loc:hRgn = CFC_CreateRectRgn(loc:R.left,loc:R.top,loc:R.right,loc:R.bottom)
    IF loc:hRgn
       loc:hDC = CFC_GetDCEx(hWnd,loc:hRgn,1 + 2 + 080h + 010h)
       IF loc:hDC
          loc:Brush = CFC_CreateSolidBrush(SELF.Color:PopupWindowBorder)
          loc:R.right = loc:R.right - loc:R.left
          loc:R.bottom = loc:R.bottom - loc:R.top
          loc:R.left = 0
          loc:R.top = 0
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)
          Err# = CFC_DeleteObject(loc:Brush)

          loc:R.right -= 1
          loc:R.bottom - = 1
          loc:R.left += 1
          loc:R.top += 1
          loc:Brush = CFC_CreateSolidBrush(SELF.Color:ItemBackground)
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)
          Err# = CFC_DeleteObject(loc:Brush)

          loc:R.top += 1
          loc:R.bottom = loc:R.top
          loc:R.left += SELF.IconBarWidth + 2
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.bottom = loc:origR.bottom - loc:origR.top - 2
          loc:R.top = loc:R.bottom
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)

          loc:R.right -= 1
          loc:R.left = loc:R.right
          loc:R.top = 0
          Err# = CFC_FrameRect(loc:hDC,ADDRESS(loc:R),loc:Brush)
          Err# = CFC_DeleteObject(loc:Brush)

          ! drawing the gradient lines
          ! the upper line
          loc:Vertex[1] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:IconBarGradientFrom)
          loc:Vertex[2] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:IconBarGradientTo)

          loc:Vertex[1].x = 2
          loc:Vertex[1].y = 1

          loc:Vertex[2].x = SELF.IconBarWidth + 3
          loc:Vertex[2].y = 3

          loc:G_RECT.UpperLeft = 0
          loc:G_RECT.LowerRight = 1

          IF NOT CurrItem.Menu.Comctrl &= NULL
             IF CurrItem.Menu.Comctrl._CFC_GradientFill_
                Err# = CFC_GradientFill(loc:hDC,ADDRESS(loc:Vertex),2,ADDRESS(loc:G_RECT),1,CFC_GRADIENT_FILL_RECT_H)
             END
          END

          ! the bottom line
          loc:Vertex[1].y = loc:origR.bottom - loc:origR.top - 3
          loc:Vertex[2].y = loc:origR.bottom - loc:origR.top - 1

          IF NOT CurrItem.Menu.Comctrl &= NULL
             IF CurrItem.Menu.Comctrl._CFC_GradientFill_
                Err# = CFC_GradientFill(loc:hDC,ADDRESS(loc:Vertex),2,ADDRESS(loc:G_RECT),1,CFC_GRADIENT_FILL_RECT_H)
             END
          END

          ! the left line
          loc:Vertex[1] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:IconBarGradientFrom)
          loc:Vertex[2] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:IconBarGradientFrom)

          loc:Vertex[1].x = 1
          loc:Vertex[1].y = 1

          loc:Vertex[2].x = 3
          loc:Vertex[2].y = loc:origR.bottom - loc:origR.top - 1

          IF NOT CurrItem.Menu.Comctrl &= NULL
             IF CurrItem.Menu.Comctrl._CFC_GradientFill_
                Err# = CFC_GradientFill(loc:hDC,ADDRESS(loc:Vertex),2,ADDRESS(loc:G_RECT),1,CFC_GRADIENT_FILL_RECT_H)
             END
          END
       END
       CFC_ReleaseDC(hWnd,loc:hDC)
       Err# = CFC_DeleteObject(loc:hRgn)
    END
 END


CFCMenuItemDrawClass:2003.OnDrawItem                  PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam)
loc:dis                 LIKE(CFC_DRAWITEMSTRUCT)

rcInfo                  LIKE(CFC_RECT)
rcWork                  LIKE(CFC_RECT)

hMenuBKBrush            ULONG
hTmpBrush               ULONG

loc:hFont               ULONG
loc:hPrevFont           ULONG

loc:Vertex              LIKE(CFC_TRIVERTEX),DIM(2)
loc:G_RECT              LIKE(CFC_GRADIENT_RECT)
 CODE
 PARENT.OnDrawItem(CurrItem,hWnd,lParam)

 CFC_memcpy(ADDRESS(loc:dis),lParam,SIZE(CFC_DRAWITEMSTRUCT))
 CFC_memcpy(ADDRESS(rcInfo),ADDRESS(loc:dis.rcItem),SIZE(CFC_RECT))

 ! draw the border around the window
 IF NOT CurrItem.FlagTopLevel
    SELF.DrawFlatWindow(CurrItem,CFC_WindowFromDC(loc:dis.hDC))
 END

 ! draw the background
 rcWork = rcInfo
 IF NOT CurrItem.FlagTopLevel
    hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENUBAR)
    IF NOT hMenuBKBrush THEN hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENU).
 ELSE
    IF CurrItem.Menu.BkrColor
       hMenuBKBrush = CFC_CreateSolidBrush(CurrItem.Menu.BkrColor)
    ELSE
       hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENUBAR)
       IF NOT hMenuBKBrush THEN hMenuBKBrush = CFC_GetSysColorBrush(CFC_COLOR_MENU).
    END
 END
 CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hMenuBKBrush)

 IF NOT CurrItem.FlagTopLevel
    hTmpBrush = CFC_CreateSolidBrush(SELF.Color:ItemBackground)
    rcWork.left += SELF.IconBarWidth
    CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
    Err# = CFC_DeleteObject(hTmpBrush)

    ! draw the gradient icon bar
    loc:Vertex[1] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:IconBarGradientFrom)
    loc:Vertex[2] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:IconBarGradientTo)

    loc:Vertex[1].x = 0
    loc:Vertex[1].y = rcWork.top

    loc:Vertex[2].x = SELF.IconBarWidth
    loc:Vertex[2].y = rcWork.bottom

    loc:G_RECT.UpperLeft = 0
    loc:G_RECT.LowerRight = 1

    IF NOT CurrItem.Menu.Comctrl &= NULL
       IF CurrItem.Menu.Comctrl._CFC_GradientFill_
          Err# = CFC_GradientFill(loc:dis.hDC,ADDRESS(loc:Vertex),2,ADDRESS(loc:G_RECT),1,CFC_GRADIENT_FILL_RECT_H)
       END
    END
 END

 ! draw the separator
 rcWork = rcInfo
 IF CurrItem.FlagSeparator
    rcWork.left += SELF.IconBarWidth + SELF.MenuItemTextOffset
    rcWork.top += 1
    rcWork.bottom -= 1
    hTmpBrush = CFC_CreateSolidBrush(SELF.Color:Separator)
    CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
    Err# = CFC_DeleteObject(hTmpBrush)
 END

 ! draw the selected item
 rcWork = rcInfo
 IF BAND(loc:dis.itemState,CFC_ODS_SELECTED) OR BAND(loc:dis.itemState,CFC_ODS_HOTLIGHT)
    IF BAND(loc:dis.itemState,CFC_ODS_GRAYED)
       hTmpBrush = CFC_CreateSolidBrush(SELF.Color:DisabledItemBackground)
       CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       Err# = CFC_DeleteObject(hTmpBrush)
    ELSE
       IF NOT (CurrItem.FlagSubmenuIsOpened AND CurrItem.FlagTopLevel)
          IF NOT CurrItem.FlagTopLevel
             hTmpBrush = CFC_CreateSolidBrush(SELF.Color:SelectedItem)
             CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
             Err# = CFC_DeleteObject(hTmpBrush)
          ELSE
             ! draw the gradient selected top level item
             loc:Vertex[1] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:TopLevelItemGradientFrom)
             loc:Vertex[2] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:TopLevelItemGradientTo)

             loc:Vertex[1].x = rcWork.left
             loc:Vertex[1].y = rcWork.top

             loc:Vertex[2].x = rcWork.right
             loc:Vertex[2].y = rcWork.bottom

             loc:G_RECT.UpperLeft = 0
             loc:G_RECT.LowerRight = 1

             IF NOT CurrItem.Menu.Comctrl &= NULL
                IF CurrItem.Menu.Comctrl._CFC_GradientFill_
                   Err# = CFC_GradientFill(loc:dis.hDC,ADDRESS(loc:Vertex),2,ADDRESS(loc:G_RECT),1,CFC_GRADIENT_FILL_RECT_V)
                END
             END
          END
       ELSE
          IF CurrItem.FlagTopLevel
             ! draw the gradient selected and opened top level item
             loc:Vertex[1] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:OpenedTopLevelItemGradientFrom)
             loc:Vertex[2] = CurrItem.Menu.GDI.CreateVertex(SELF.Color:OpenedTopLevelItemGradientTo)

             loc:Vertex[1].x = rcWork.left
             loc:Vertex[1].y = rcWork.top

             loc:Vertex[2].x = rcWork.right
             loc:Vertex[2].y = rcWork.bottom

             loc:G_RECT.UpperLeft = 0
             loc:G_RECT.LowerRight = 1

             IF NOT CurrItem.Menu.Comctrl &= NULL
                IF CurrItem.Menu.Comctrl._CFC_GradientFill_
                   Err# = CFC_GradientFill(loc:dis.hDC,ADDRESS(loc:Vertex),2,ADDRESS(loc:G_RECT),1,CFC_GRADIENT_FILL_RECT_V)
                END
             END
          ELSE
             CFC_FillRect(loc:dis.hDC,ADDRESS(rcWork),hMenuBKBrush)
          END
       END
    END
    IF NOT (CurrItem.FlagSubmenuIsOpened AND CurrItem.FlagTopLevel)
       hTmpBrush = CFC_CreateSolidBrush(SELF.Color:ItemBorder)
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       Err# = CFC_DeleteObject(hTmpBrush)
    ELSE
       hTmpBrush = CFC_CreateSolidBrush(SELF.Color:PopupWindowBorder)
       rcWork.right = rcWork.left + 1
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       rcWork = rcInfo
       rcWork.left = rcWork.right - 1
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       rcWork = rcInfo
       rcWork.bottom = rcWork.top + 1
       CFC_FrameRect(loc:dis.hDC,ADDRESS(rcWork),hTmpBrush)
       Err# = CFC_DeleteObject(hTmpBrush)

       ! draw the simple shadow
       SELF.DrawShadow(rcInfo,loc:dis.hDC)
    END
 END

 ! draw the icon
 rcWork = rcInfo
 rcWork.top += INT((SELF.ItemHeight - 16)/2+0.5)
 rcWork.left += 2

 IF BAND(loc:dis.itemState,CFC_ODS_CHECKED)
    IF BAND(loc:dis.itemState,CFC_ODS_GRAYED)
       IF CurrItem.hCheckedIconDisabled
          CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hCheckedIconDisabled,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
       END
    ELSE
       IF CurrItem.hCheckedIcon
          CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hCheckedIcon,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
       END
    END
 ELSIF BAND(loc:dis.itemState,CFC_ODS_GRAYED)
    IF CurrItem.hIconDisabled
       CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hIconDisabled,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
    END
 ELSE
    IF CurrItem.hIcon
       Err# = CFC_DrawIconEx(loc:dis.hDC,rcWork.left,rcWork.top,CurrItem.hIcon,CurrItem.IconWidth,CurrItem.IconHeight,0,0,CFC_DI_NORMAL)
    END
 END

 ! set the color of menu item
 IF BAND(loc:dis.itemState,CFC_ODS_DISABLED) OR BAND(loc:dis.itemState,CFC_ODS_GRAYED)
    Err# = CFC_SetTextColor(loc:dis.hDC,COLOR:GRAY)
 ELSE
    Err# = CFC_SetTextColor(loc:dis.hDC,COLOR:BLACK)
 END

 ! draw the item text
 rcWork = rcInfo

 IF NOT CurrItem.FlagTopLevel
    rcWork.left += SELF.IconBarWidth + SELF.MenuItemTextOffset
 END

 loc:hFont = CurrItem.Menu.Comctrl.RetrieveSystemMenuFont()
 loc:hPrevFont = CFC_SelectObject(loc:dis.hDC,loc:hFont)

 SELF.DrawItemText(CurrItem,loc:dis.hDC,rcWork)

 IF loc:hPrevFont
    Err# = CFC_SelectObject(loc:dis.hDC,loc:hPrevFont)
 END

 Err# = CFC_DeleteObject(loc:hFont)
 Err# = CFC_DeleteObject(hMenuBkBrush)
!**************************************************************************************************************
CFCMenuItemDrawClass:2003:Gray.Construct            PROCEDURE
 CODE
 ! gray
 SELF.Color:ItemBackground = COLOR:WHITE
 SELF.Color:SelectedItem = 0EED2C1h
 SELF.Color:DisabledItemBackground = COLOR:WHITE
 SELF.Color:ItemBorder = 0800000h
 SELF.Color:PopupWindowBorder = 07A868Ah
 SELF.Color:Separator = COLOR:GRAY
 SELF.Color:Shadow:1 = 0919C9Eh
 SELF.Color:Shadow:2 = 0B4C2C4h

 SELF.Color:IconBarGradientFrom = 0FBFEFEh
 SELF.Color:IconBarGradientTo = 0ACC3C4h

 SELF.Color:TopLevelItemGradientFrom = 0EED2C1h
 SELF.Color:TopLevelItemGradientTo =   0EED2C1h

 SELF.Color:OpenedTopLevelItemGradientFrom = 0F8FBFBh
 SELF.Color:OpenedTopLevelItemGradientTo = 0EFF5F7h


CFCMenuItemDrawClass:2003:Green.Construct            PROCEDURE
 CODE
 ! green
 SELF.Color:ItemBackground = COLOR:WHITE
 SELF.Color:SelectedItem = 08DC6B6h
 SELF.Color:DisabledItemBackground = COLOR:WHITE
 SELF.Color:ItemBorder =070A093h
 SELF.Color:PopupWindowBorder = 07A868Ah
 SELF.Color:Separator = COLOR:GRAY
 SELF.Color:Shadow:1 = 0919C9Eh
 SELF.Color:Shadow:2 = 0B4C2C4h

 SELF.Color:IconBarGradientFrom = 0FBFEFEh
 SELF.Color:IconBarGradientTo = 0ACC3C4h

 SELF.Color:TopLevelItemGradientFrom = 08DC6B6h
 SELF.Color:TopLevelItemGradientTo =   08DC6B6h

 SELF.Color:OpenedTopLevelItemGradientFrom = 0F8FBFBh
 SELF.Color:OpenedTopLevelItemGradientTo = 0EFF5F7h
CFCMenuItemDrawClass:2003:Silver.Construct            PROCEDURE
 CODE
 ! silver
 SELF.Color:ItemBackground = 0FFFAFDh
 SELF.Color:SelectedItem = 0C2EEFFh
 SELF.Color:DisabledItemBackground = 0FFFAFDh
 SELF.Color:ItemBorder = 06F4B4Bh
 SELF.Color:PopupWindowBorder = 0947C7Ch
 SELF.Color:Separator = 08F6D6Eh
 SELF.Color:Shadow:1 = 0919C9Eh
 SELF.Color:Shadow:2 = 0B4C2C4h

 SELF.Color:IconBarGradientFrom = 0FDF6F6h
 SELF.Color:IconBarGradientTo = 0B99D9Fh

 SELF.Color:TopLevelItemGradientFrom = 0CCF4FFh
 SELF.Color:TopLevelItemGradientTo =  09AD6FFh

 SELF.Color:OpenedTopLevelItemGradientFrom = 0F1E9E8h
 SELF.Color:OpenedTopLevelItemGradientTo = 0CDB9BAh
!**************************************************************************************************************
CFC_MenuEnumerateWindows         PROCEDURE(ULONG hWnd,LONG lParam)
CurrMng          &CFCMenuManager
cstrCaption      CSTRING(256)
cstrClassName    CSTRING(80)
 CODE
 IF CFC_GetClassName(hWnd,ADDRESS(cstrClassName),SIZE(cstrClassName))
    IF SUB(UPPER(CLIP(cstrClassName)),1,6) = 'CLAWIN'
       CurrMng &= (lParam)
       IF NOT CurrMng &= NULL
          wnd_style# = CFC_GetWindowLong(hWnd,-16)
          IF NOT BAND(wnd_style#,CFC_WS_DISABLED) = CFC_WS_DISABLED | ! if window is not disabled
                      AND BAND(wnd_style#,CFC_WS_VISIBLE) = CFC_WS_VISIBLE ! visible?
             IF CFC_GetWindowText(hWnd,ADDRESS(cstrCaption),256)
                CLEAR(CurrMng.MDIChildQ)
                CurrMng.MDIChildQ.Caption = cstrCaption
                CurrMng.MDIChildQ.hwnd = hWnd
                ADD(CurrMng.MDIChildQ)
             END
          END
       END
    END
 END
 RETURN TRUE




