!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCPreviewReport.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
 END
 INCLUDE('CFCPreviewReport.inc'),ONCE
 INCLUDE('PrnProp.clw'),ONCE


! ********************************************************************************************
CFCPreviewReport.Construct PROCEDURE
 code
 SELF.PreviewQueue &= NEW CFCTQPreview
 SELF.Copies = 1             !    
 SELF.PreviewUnits = CFC:MM  !   
 SELF.SearchDirection = 2
 SELF.HeaderBorder = 5       !  
 SELF.FooterBorder = 10      !  
 SELF.DatePicture = '@d06.b' !   
 SELF.TimePicture = '@t01'   !   
 SELF.HdrOnFirstPage = TRUE  !     
 SELF.Collate = TRUE         !   
 SELF.UseIconsOnContextMenu = TRUE
 SELF.OfficeXPToolbar = TRUE
 SELF.AllowExportToWMF = TRUE

 SELF.Translator &= NEW TranslatorClass
 SELF.Translator.Init()
 SELF.Translator.AddTranslation(TRN:PreviewReport)
 SELF.Papers &= NEW CFCTQPapers
 SELF.RulerH &= NEW CFCHRulerClass
 SELF.RulerV &= NEW CFCVRulerClass
 SELF.FS &= NEW CFCFullScreen
 SELF.SearchTxt &= NEW CFCSearchTxt
 SELF.Headers &= NEW CFCTQHeader
 SELF.HdrPreviewQueue &= NEW CFCTQPreview
 SELF.Ext &= NEW CFCTQExtensions
 SELF.PrnQueue &= NEW CFCTQPreview
 SELF.OrigPrnQueue &= NEW CFCTQPreview
! ********************************************************************************************

CFCPreviewReport.Destruct PROCEDURE
 code
 if NOT SELF.PreviewQueue &= NULL then dispose(SELF.PreviewQueue).
 SELF.Translator.Kill()
 if NOT SELF.Translator &= NULL then dispose(SELF.Translator).
 if NOT SELF.Papers &= NULL then dispose(SELF.Papers).
 if NOT SELF.RulerH &= NULL then dispose(SELF.RulerH).
 if NOT SELF.RulerV &= NULL then dispose(SELF.RulerV).
 if NOT SELF.FS &= NULL then dispose(SELF.FS).
 if NOT SELF.SearchTxt &= NULL then dispose(SELF.SearchTxt).
 if NOT SELF.Headers &= NULL
    SELF.RemoveHeaders()
    dispose(SELF.Headers)
 end
 if NOT SELF.HdrPreviewQueue &= NULL then dispose(SELF.HdrPreviewQueue).
 if NOT SELF.Ext &= NULL then dispose(SELF.Ext).
 if NOT SELF.PrnQueue &= NULL then dispose(SELF.PrnQueue).
 if NOT SELF.OrigPrnQueue &= NULL then dispose(SELF.OrigPrnQueue).
! ********************************************************************************************

CFCPreviewReport.SetComctrl PROCEDURE(*CFCComctrlClass inComctrl)
 CODE
 SELF.Comctrl &= inComctrl



CFCPreviewReport.SetOfficeXPToolbar PROCEDURE(BYTE inOnOff)
 CODE
 SELF.OfficeXPToolbar = inOnOff
! ********************************************************************************************
CFCPreviewReport.GetOfficeXPToolbar PROCEDURE
 CODE
 RETURN SELF.OfficeXPToolbar
! ********************************************************************************************
CFCPreviewReport.Kill PROCEDURE
 code
 !   
 !  
 loop j# = 1 to records(SELF.PreviewQueue)
    get(SELF.PreviewQueue,j#)
    remove(clip(SELF.PreviewQueue.WMF_Image_Path))
 end

 !   
 loop j# = 1 to records(SELF.PrnQueue)
    get(SELF.PrnQueue,j#)
    remove(clip(SELF.PrnQueue.WMF_Image_Path))
 end

 !  
 loop j# = 1 to records(SELF.HdrPreviewQueue)
    get(SELF.HdrPreviewQueue,j#)
    remove(clip(SELF.HdrPreviewQueue.WMF_Image_Path))
 end

 SELF.Translator.Kill()
CFCPreviewReport.ConfigureZoomRatio PROCEDURE()
loc:Rect           LIKE(CFC_RECT)
loc:W              LONG
loc:H              LONG
 code
 !    -
 SELF.PW{Prop:Vscroll} = FALSE
 SELF.PW{Prop:Hscroll} = FALSE
 !   ,     
 !     ,   ,     
 ! 4    2 
 if CFC_GetClientRect(SELF.PW{Prop:ClientHandle},address(loc:Rect))
    loc:W = loc:Rect.right - (SELF.RulerPanel{Prop:Xpos} + SELF.RulerPanel{Prop:Width} + 6)
    loc:H = loc:Rect.bottom - (SELF.RulerPanel{Prop:Ypos} + SELF.RulerPanel{Prop:Height} + 6)
 else
    loc:W = SELF.PW{Prop:Width} - (SELF.RulerPanel{Prop:Xpos} + SELF.RulerPanel{Prop:Width} + 6)
    loc:H = SELF.PW{Prop:Height} - (SELF.RulerPanel{Prop:Ypos} + SELF.RulerPanel{Prop:Height} + 6)
 end
 !   
 case SELF.ZoomType
    of CFC_Zoom:TilePage
       kW$ = loc:W / SELF.ImageWidth
       kH$ = loc:H / SELF.ImageHeight
       if  kW$ > kH$
          SELF.ZoomModifier = kH$
       else
          SELF.ZoomModifier = kW$
       end
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Fit page')
    of CFC_Zoom:PageWidth
       SELF.ZoomModifier = loc:W / SELF.ImageWidth
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Fit width')
    of CFC_Zoom:PageHeight
       SELF.ZoomModifier = loc:H / SELF.ImageHeight
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Fit height')
    of CFC_Zoom:50
       SELF.ZoomModifier = .5
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Zoom:')&' 50%'
    of CFC_Zoom:75
       SELF.ZoomModifier = .75
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Zoom:')&' 75%'
    of CFC_Zoom:100
       SELF.ZoomModifier = 1
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Zoom:')&' 100%'
    of CFC_Zoom:200
       SELF.ZoomModifier = 2
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Zoom:')&' 200%'
    of CFC_Zoom:300
       SELF.ZoomModifier = 3
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Zoom:')&' 300%'
    of CFC_Zoom:Custom
       SELF.PW{Prop:StatusText,3} = SELF.Translator.TranslateString('Zoom:')& int(SELF.ZoomModifier*100) &' %'
 end
 !  
 SELF.PW{Prop:Vscroll} = TRUE
 SELF.PW{Prop:Hscroll} = TRUE

! ********************************************************************************************
CFCPreviewReport.RefreshDisplay PROCEDURE
 code
 SELF.ConfigureZoomRatio()

 SELF.Box{Prop:Xpos} = SELF.RulerPanel{Prop:Xpos} + SELF.RulerPanel{Prop:Width} + 4
 SELF.Box{Prop:Ypos} = SELF.RulerPanel{Prop:Ypos} + SELF.RulerPanel{Prop:Height} + 4
 SELF.Box{Prop:Height} = SELF.ImageHeight * SELF.ZoomModifier
 SELF.Box{Prop:Width} = SELF.ImageWidth * SELF.ZoomModifier

 case SELF.ZoomType !        
    of CFC_Zoom:PageWidth
       if SELF.IsVScrollVisible()
          SELF.Box{Prop:Width} = SELF.Box{Prop:Width} - CFC_GetSystemMetrics(CFC_SM_CXVSCROLL)
       end
    of CFC_Zoom:PageHeight
       if SELF.IsHScrollVisible()
          SELF.Box{Prop:Height} = SELF.Box{Prop:Height} - CFC_GetSystemMetrics(CFC_SM_CYHSCROLL)
       end
 end

 get(SELF.PreviewQueue,SELF.CurrentPage)
 SELF.Image{Prop:Text} = SELF.PreviewQueue.WMF_Image_Path

 SELF.Image{Prop:Xpos} = SELF.Box{Prop:Xpos}
 SELF.Image{Prop:Ypos} = SELF.Box{Prop:Ypos}

 SELF.Image{Prop:Width} = SELF.Box{Prop:Width}
 SELF.Image{Prop:Height} =  SELF.Box{Prop:Height}

 SELF.HeaderImage{Prop:Xpos} = SELF.Box{Prop:Xpos}
 SELF.HeaderImage{Prop:Ypos} = SELF.Box{Prop:Ypos}
 SELF.HeaderImage{Prop:Width} = SELF.Box{Prop:Width}
 SELF.HeaderImage{Prop:Height} =  SELF.Box{Prop:Height}

 SELF.PW{Prop:StatusText,2} = SELF.Translator.TranslateString('Page')&' '& SELF.CurrentPage &' '& SELF.Translator.TranslateString('of') &' '& SELF.ImageCount

 if not SELF.ImageCount = 1
    if SELF.CurrentPage = 1
       disable(SELF.TBR:Back)
       enable(SELF.TBR:Forward)
    elsif SELF.CurrentPage = SELF.ImageCount
       disable(SELF.TBR:Forward)
       enable(SELF.TBR:Back)
    else
       enable(SELF.TBR:Forward)
       enable(SELF.TBR:Back)
    end
 end
! ********************************************************************************************
 
CFCPreviewReport.PageChanged PROCEDURE()
 code
 if records(SELF.Headers) !   ,  
    get(SELF.HdrPreviewQueue,SELF.CurrentPage)
    if not errorcode()
       SELF.HeaderImage{Prop:Text} = clip(SELF.HdrPreviewQueue.WMF_Image_Path)
    else
       SELF.HeaderImage{Prop:Text} = ''
    end
 end
CFCPreviewReport.DisplayZoomPopup PROCEDURE(<LONG Xpos>,<LONG Ypos>)
loc:SelectedString STRING(50)
loc:RetValue       BYTE
 code
 SELF.ZoomPopup &= NEW PopupClass
 if NOT SELF.ZoomPopup &= NULL
    SELF.ZoomPopup.Init()
    SELF.ZoomPopup.AddItem('50%','Zoom50')
    SELF.ZoomPopup.AddItem('75%','Zoom75')
    SELF.ZoomPopup.AddItem('100%','Zoom100')
    SELF.ZoomPopup.AddItem('200%','Zoom200')
    SELF.ZoomPopup.AddItem('300%','Zoom300')
    SELF.ZoomPopup.AddItem('-','Sep1')
    SELF.ZoomPopup.AddItem(SELF.Translator.TranslateString('Fit width'),'ZoomPageWidth')
    SELF.ZoomPopup.AddItem(SELF.Translator.TranslateString('Fit height'),'ZoomPageHeight')
    SELF.ZoomPopup.AddItem(SELF.Translator.TranslateString('Fit page'),'ZoomFitPage')
    case SELF.ZoomType
       of CFC_Zoom:TilePage
          SELF.ZoomPopup.SetItemCheck('ZoomFitPage',TRUE)
       of CFC_Zoom:PageWidth
          SELF.ZoomPopup.SetItemCheck('ZoomPageWidth',TRUE)
       of CFC_Zoom:PageHeight
          SELF.ZoomPopup.SetItemCheck('ZoomPageHeight',TRUE)
       of CFC_Zoom:50
          SELF.ZoomPopup.SetItemCheck('Zoom50',TRUE)
       of CFC_Zoom:75
          SELF.ZoomPopup.SetItemCheck('Zoom75',TRUE)
       of CFC_Zoom:100
          SELF.ZoomPopup.SetItemCheck('Zoom100',TRUE)
       of CFC_Zoom:200
          SELF.ZoomPopup.SetItemCheck('Zoom200',TRUE)
       of CFC_Zoom:300
          SELF.ZoomPopup.SetItemCheck('Zoom300',TRUE)
    end
    if OMITTED(2) and OMITTED(3)
       loc:SelectedString = SELF.ZoomPopup.Ask()
    else
       loc:SelectedString = SELF.ZoomPopup.Ask(Xpos,Ypos)
    end
    loc:RetValue = TRUE !   
    case loc:SelectedString
       of 'ZoomFitPage'
          SELF.ZoomType = CFC_Zoom:TilePage
       of 'ZoomPageWidth'
          SELF.ZoomType = CFC_Zoom:PageWidth
       of 'ZoomPageHeight'
          SELF.ZoomType = CFC_Zoom:PageHeight
       of 'Zoom50'
          SELF.ZoomType = CFC_Zoom:50
       of 'Zoom75'
          SELF.ZoomType = CFC_Zoom:75
       of 'Zoom100'
          SELF.ZoomType = CFC_Zoom:100
       of 'Zoom200'
          SELF.ZoomType = CFC_Zoom:200
       of 'Zoom300'
          SELF.ZoomType = CFC_Zoom:300
       else
          loc:RetValue = FALSE !   
    end
    SELF.ZoomPopup.Kill()
    dispose(SELF.ZoomPopup)
 end
 return loc:RetValue
! ********************************************************************************************
!CFCPreviewReport.ConfigurePrint PROCEDURE
!loc:Pages        BYTE       ! 
!loc:StartPage    LONG       ! ,    
!loc:EndPage      LONG       !    
!loc:Copies       LONG       !  
!loc:Orientation  BYTE       !  
!loc:Collate      BYTE       !   
!
!EnumPrn          CFCEnumPrinters !     
!
!loc:Printers     QUEUE(CFCTQ_Printers),PRE(P).
!
!CFCCfg:Window WINDOW('Print setup'),AT(,,227,201),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:CYRILLIC), |
!         GRAY,DOUBLE
!       BUTTON('Print'),AT(132,182,45,14),USE(?ButtonPrint),DEFAULT
!       BUTTON('Cancel'),AT(180,182,45,14),USE(?ButtonClose),STD(STD:Close)
!       GROUP('Printer'),AT(2,2,223,62),USE(?Group1),BOXED
!         STRING('Name'),AT(8,12),USE(?String5)
!         LIST,AT(48,10,121,12),USE(?ListPrinters),VSCROLL,FORMAT('255L(2)|M'),DROP(10),FROM(loc:Printers)
!         BUTTON('Properties...'),AT(172,9,50,14),USE(?ButtonPrnProp)
!         STRING('Driver'),AT(8,26),USE(?String6)
!         STRING(@s255),AT(48,38,152,10),USE(P:PortName)
!         STRING(@s255),AT(48,50,152,10),USE(P:Comment)
!         STRING('Comments'),AT(8,50),USE(?StringComments)
!         STRING('Where'),AT(8,38),USE(?StringWhere)
!         STRING(@s255),AT(48,26,152,10),USE(P:DriverName)
!       END
!       OPTION('Orientation'),AT(2,66,104,48),USE(loc:Orientation),BOXED
!         RADIO('Portrait'),AT(6,76,45,34),USE(?Option2:Radio1),FLAT,ICON('CFCPortrait.ico'),VALUE('1')
!         RADIO('Landscape'),AT(54,76,48,34),USE(?Option2:Radio2),FLAT,ICON('CFCLandscape.ico'),VALUE('2')
!       END
!       OPTION('Pages'),AT(2,116,223,59),USE(loc:Pages),BOXED
!         RADIO('All'),AT(8,128),USE(?All),VALUE('1')
!         RADIO('Pages'),AT(8,142),USE(?Pages),TRN,VALUE('2')
!       END
!       IMAGE('CFCCollate.gif'),AT(148,130,71,22),USE(?Image),CENTERED
!       SPIN(@n3b),AT(72,141,28,12),USE(loc:StartPage),RANGE(1,1),STEP(1)
!       SPIN(@n3b),AT(114,141,30,12),USE(loc:EndPage),RANGE(1,1)
!       STRING('Number of copies'),AT(10,157),USE(?String4)
!       SPIN(@n3b),AT(72,156,28,12),USE(loc:Copies),RANGE(1,999),STEP(1)
!       CHECK('collate copies'),AT(150,157),USE(loc:Collate),VALUE('1','0')
!       STRING('to'),AT(104,142),USE(?String3),CENTER
!       STRING('from'),AT(54,142,15,10),USE(?String2),TRN,RIGHT
!     END
!
! code
! if NOT EnumPrn.Enum() then return. !       
! free(loc:Printers)
! loop j# = 1 to records(EnumPrn.QPrns)
!    get(EnumPrn.QPrns,j#)
!    loc:Printers :=: EnumPrn.QPrns
!    add(loc:Printers)
! end
!
! open(CFCCfg:Window)
! self.Translator.TranslateWindow(CFCCfg:Window)       ! 
! ?ListPrinters{Prop:LineHeight} = 10
! get(loc:Printers,1) !    (/) 
! select(?ListPrinters,1)
! 
! 
! loc:Pages = 1                    !  
! loc:StartPage = 1                !    
! loc:EndPage = SELF.ImageCount
! loc:Copies = SELF.Copies         !  
! loc:Collate = SELF.Collate       !   
! if loc:Collate                   ! 
!    ?Image{Prop:Text} = '~CFCCollate.gif'
! else
!    ?Image{Prop:Text} = '~CFCNoCollate.gif'
! end
! if SELF.ReportLandscape          !  
!    loc:Orientation = 2           ! 
! else
!    loc:Orientation = 1           ! 
! end
! ?loc:StartPage{Prop:RangeHigh} = SELF.ImageCount
! ?loc:EndPage{Prop:RangeHigh} = SELF.ImageCount
! disable(?loc:StartPage)
! disable(?loc:EndPage)
!
! SELF.OpenPrintSetupWindow(CFCCfg:Window)
!
! display()
! 
! ACCEPT
!    CASE EVENT()
!       OF EVENT:Accepted
!          CASE FIELD()
!             OF ?loc:Pages
!                if loc:Pages = 1
!                   disable(?loc:StartPage)
!                   disable(?loc:EndPage)
!                else
!                   enable(?loc:StartPage)
!                   enable(?loc:EndPage)
!                end
!             OF ?ListPrinters
!                get(loc:Printers,choice(?ListPrinters))
!                display()
!             OF ?ButtonPrnProp
!                GET(loc:Printers,choice(?ListPrinters))
!                EnumPrn.PrnProperties(CFCCfg:Window{Prop:Handle},clip(loc:Printers.PrinterName))
!             OF ?loc:Collate
!                if loc:Collate
!                   ?Image{Prop:Text} = '~CFCCollate.gif'
!                else
!                   ?Image{Prop:Text} = '~CFCNoCollate.gif'
!                end
!             OF ?ButtonPrint
!                get(loc:Printers,choice(?ListPrinters))
!                if not errorcode()
!                   PRINTER{PROPPRINT:Device} = loc:Printers.PrinterName
!                   if loc:Orientation = 2
!                      SELF.ReportLandscape = TRUE
!                   end
!                   SELF.Collate = loc:Collate
!                   SELF.Copies = loc:Copies
!                   CASE loc:Pages
!                   OF 1
!                      SELF.PrintReport(TRUE)
!                   OF 2
!                      SELF.PrintReport(TRUE,loc:StartPage,loc:EndPage)
!                   END
!                END
!                BREAK
!          END
!    END
! END
! close(CFCCfg:Window)
!! ********************************************************************************************
! 
CFCPreviewReport.ConfigurePrint PROCEDURE
loc:StartPage    LONG       ! ,    
loc:EndPage      LONG       !    

 CODE
! SELF.OpenPrintSetupWindow(CFCCfg:Window)

 PRINTER{PROPPRINT:FromMin} = 1
 PRINTER{PROPPRINT:ToMax} = SELF.ImageCount

 IF NOT PRINTERDIALOG(,0) THEN RETURN END

 SELF.Collate = 1
 SELF.Copies = PRINTER{PROPPRINT:Copies}

 IF PRINTER{PROPPRINT:FromPage} = -1
    loc:StartPage = 1
 ELSE
    loc:StartPage = PRINTER{PROPPRINT:FromPage}
 END
 IF PRINTER{PROPPRINT:ToPage} = -1
    loc:EndPage = SELF.ImageCount
 ELSE
    loc:EndPage = PRINTER{PROPPRINT:ToPage}
 END

 !    ,    
 PRINTER{PROPPRINT:FromPage} = -1
 PRINTER{PROPPRINT:ToPage} = -1
 PRINTER{PROPPRINT:Copies} = 1
 SELF.PrintReport(TRUE,loc:StartPage,loc:EndPage)

! ********************************************************************************************
CFCPreviewReport.Localize PROCEDURE(TranslatorGroup inTG)
 code
 SELF.Translator.AddTranslation(inTG)
 
 

CFCPreviewReport.Prepare PROCEDURE()
 code
 !   
 loop j# = 1 to records(SELF.PreviewQueue)
    get(SELF.PreviewQueue,j#)
    copy(clip(SELF.PreviewQueue.WMF_Image_Path),sub(clip(SELF.PreviewQueue.WMF_Image_Path),1,len(clip(SELF.PreviewQueue.WMF_Image_Path))-4) & '_orig.wmf')
    SELF.PreviewQueue.WMF_Image_Path = sub(clip(SELF.PreviewQueue.WMF_Image_Path),1,len(clip(SELF.PreviewQueue.WMF_Image_Path))-4) & '_orig.wmf'
    put(SELF.PreviewQueue)
 end
CFCPreviewReport.Show PROCEDURE
ref               &CFCPreviewReport
loc:CurrentPage   LONG
loc:Zoom50        BYTE
loc:Zoom75        BYTE
loc:Zoom100       BYTE
loc:Zoom200       BYTE
loc:Zoom300       BYTE
loc:FitWidth      BYTE
loc:FitHeight     BYTE
loc:FitPage       BYTE
loc:Rect          LIKE(CFC_RECT)
loc:FileName      STRING(260)

btn:Print         CLASS(CFCButton)
TakeAccepted         PROCEDURE(),VIRTUAL,DERIVED
                  END
bnt:PrintCurrent  CLASS(CFCButton)
TakeAccepted         PROCEDURE(),VIRTUAL,DERIVED
                  END
btn:Save          CLASS(CFCButton)
TakeAccepted         PROCEDURE(),VIRTUAL,DERIVED
                  END
btn:Search        CLASS(CFCButton)
TakeAccepted         PROCEDURE(),VIRTUAL,DERIVED
                  END
btn:Back          CLASS(CFCSplitButton)
TakeAccepted         PROCEDURE(LONG Xpos,LONG Ypos,BYTE SplitPressed),VIRTUAL,DERIVED
                  END
btn:Forward       CLASS(CFCSplitButton)
TakeAccepted         PROCEDURE(LONG Xpos,LONG Ypos,BYTE SplitPressed),VIRTUAL,DERIVED
                  END
btn:Zoom          CLASS(CFCDropButton)
TakeAccepted         PROCEDURE(LONG Xpos,LONG Ypos),VIRTUAL,DERIVED
                  END

btn:ZoomIn        CFCButton
btn:ZoomOut       CFCButton
btn:FS            CFCButton


CFCPreview:Window WINDOW('Report preview'),AT(,,365,202),FONT('MS Sans Serif',8,,),CENTER,IMM,HVSCROLL, |
         ICON('CFCPreview.ico'),ALRT(PgUpKey),ALRT(PgDnKey),ALRT(CtrlHome),ALRT(CtrlEnd),ALRT(DownKey), |
         ALRT(UpKey),ALRT(RightKey),ALRT(LeftKey),ALRT(CtrlPgDn),ALRT(CtrlPgUp),ALRT(MouseRight),STATUS(-1,90,100), |
         TILED,SYSTEM,GRAY,MAX,RESIZE
       MENUBAR
         MENU('&File'),USE(?FileMenu)
           ITEM('Print'),USE(?Print)
           ITEM,SEPARATOR
           ITEM('Print setup...<9>Ctrl+P'),USE(?PrintSetup),KEY(CtrlP)
           ITEM('Page setup...'),USE(?Pagesetup)
           ITEM,SEPARATOR
           ITEM('Save as<9>Ctrl+S'),USE(?Save),KEY(CtrlS)
           ITEM('Save current page'),USE(?Savecurrentpage)
           ITEM('Save to My Documents'),USE(?SaveToMyDocuments)
           ITEM,SEPARATOR
           ITEM('Exit'),USE(?Exit)
         END
         MENU('&View'),USE(?ViewMenu)
           ITEM('Zoom in<9>Grey +'),USE(?Zoomin),KEY(PlusKey)
           ITEM('Zoom out<9>Grey -'),USE(?Zoomout),KEY(MinusKey)
           ITEM,SEPARATOR
           ITEM('50%<9>Alt+1'),USE(loc:Zoom50),CHECK,MSG('?Zoom50'),KEY(Alt1)
           ITEM('75%<9>Alt+2'),USE(loc:Zoom75),CHECK,KEY(Alt2)
           ITEM('100%<9>Alt+3'),USE(loc:Zoom100),CHECK,KEY(Alt3)
           ITEM('200%<9>Alt+4'),USE(loc:Zoom200),CHECK,KEY(Alt4)
           ITEM('300%<9>Alt+5'),USE(loc:Zoom300),CHECK,KEY(Alt5)
           ITEM,SEPARATOR
           ITEM('Fit width'),USE(loc:FitWidth),CHECK
           ITEM('Fit height'),USE(loc:FitHeight),CHECK
           ITEM('Fit page'),USE(loc:FitPage),CHECK
           ITEM,SEPARATOR
           ITEM('Full screen<9>F12'),USE(?Fullscreen),KEY(F12Key)
         END
         MENU('&Find'),USE(?FindMenu)
           ITEM('Search...<9>Ctrl+F'),USE(?Search),KEY(CtrlF)
           ITEM('Search next<9>F3'),USE(?SearchNext),KEY(F3Key)
         END
       END
       TOOLBAR,AT(0,0,308,18),USE(?PreviewToolbar)
         BUTTON('Print'),AT(2,2,50,14),USE(?ButtonPrint),LEFT,TIP('Print'),ICON('CFCprint.ico')
         BUTTON,AT(250,2,19,14),USE(?ButtonZoom),LEFT,TIP('Zoom'),ICON('CFCZoom.ico')
         BUTTON,AT(271,2,16,14),USE(?ButtonZoomIn),TIP('Zoom in Grey +'),ICON('CFCZoomIn.ico')
         BUTTON,AT(289,2,16,14),USE(?ButtonZoomOut),TIP('Zoom out Grey -'),ICON('CFCZoomOut.ico')
         PANEL,AT(307,2,1,14),USE(?Panel3),BEVEL(-1)
         BUTTON,AT(311,2,16,14),USE(?ButtonSearch),SKIP,TIP('Find Ctrl+F'),ICON('CFCsearch.ico')
         BUTTON,AT(329,2,16,14),USE(?ButtonSave),TIP('Save report Ctrl+S'),ICON('CFCSave.ico')
         BUTTON,AT(347,2,16,14),USE(?ButtonFS),TIP('Full screen F12'),ICON('CFCFullScreen.ico')
         PANEL,AT(246,2,1,14),USE(?Panel2),BEVEL(-1)
         SPIN(@n4),AT(110,3,30,12),USE(loc:CurrentPage),FONT('MS Sans Serif',8,,),RANGE(1,10),STEP(1)
         BUTTON('Back'),AT(142,2,50,14),USE(?ButtonBack),LEFT,ICON('CFCBack.ico')
         BUTTON('Forward'),AT(194,2,50,14),USE(?ButtonFwd),LEFT,ICON('CFCForward.ico')
         BUTTON,AT(54,2,16,14),USE(?ButtonPrint1),TIP('Print current page'),ICON('CFCprint1.ico')
         PANEL,AT(0,0,,1),USE(?Panel4),FULL,BEVEL(-1)
         PANEL,AT(72,2,1,14),USE(?Panel1),BEVEL(-1)
         STRING('Page'),AT(74,4,33,10),USE(?StringPage),TRN,CENTER,FONT('MS Sans Serif',8,,)
       END
       BOX,AT(28,16,109,148),USE(?Box),SCROLL,COLOR(COLOR:Black),FILL(COLOR:White)
       IMAGE,AT(146,20,101,141),USE(?HeaderImage),SCROLL
       IMAGE,AT(32,20,101,141),USE(?Image),SCROLL
       REGION,AT(2,14,10,62),USE(?RegionV)
       REGION,AT(14,2,67,9),USE(?RegionH)
       PANEL,AT(2,2,10,9),USE(?RulePanel),SCROLL,BEVEL(-1,1)
     END

 code
 SELF.Init()                  !  
 ref &= SELF                  !   ""   (routine)
 SELF.PW &= CFCPreview:Window
 open(SELF.PW)                !  
 SELF.FillPapers()            !   
 IF SELF.AllowExportToWMF
    SELF.AddExtension('Windows meta files *.wmf','*.wmf') !    WMF-
 END
 SELF.PW{Prop:Pixels} = TRUE  !    
 do EquateLabels              !   FEQ-   

 SELF.Box = SELF.PW $ ?Box{Prop:FEQ}
 SELF.Image = SELF.PW $ ?Image{Prop:FEQ}
 SELF.HeaderImage = SELF.PW $ ?HeaderImage{Prop:FEQ}
 SELF.Image{Prop:Alrt} = MouseLeft
 SELF.Image{Prop:Cursor} = '~CFCZoomIn.cur'     !Cursor:Zoom
 SELF.PW{Prop:MinWidth} = 315
 SELF.PW{Prop:MinHeight} = 200

 get(SELF.PreviewQueue,1)                       !    ""
 SELF.Image{Prop:Text} = SELF.PreviewQueue.WMF_Image_Path
 SELF.ImageWidth = SELF.Image{Prop:MaxWidth}
 SELF.ImageHeight = SELF.Image{Prop:MaxHeight}

 SELF.ImageCount = records(SELF.PreviewQueue) !  
 loc:CurrentPage = 1                          !      
 SELF.CurrentPage = 1                         !     
 SELF.ZoomType = CFC_Zoom:TilePage            !   " "

 SELF.SetHRuler()            !  
 SELF.SetVRuler()

 if records(SELF.Headers)                     !   
    SELF.CreateHeader()
    get(SELF.HdrPreviewQueue,SELF.CurrentPage)
    if not errorcode()
       SELF.HeaderImage{Prop:Text} = clip(SELF.HdrPreviewQueue.WMF_Image_Path)
    else
       SELF.HeaderImage{Prop:Text} = ''
    end
 end
   
 if SELF.WithoutPreviewFlag   !   
    SELF.PrintReport(TRUE)
    SELF.Kill()
    return
 end

 if SELF.ImageCount = 1
    disable(SELF.TBR:CurrentPageSpin)
    disable(SELF.TBR:PageStr)
    disable(SELF.TBR:Back)
    disable(SELF.TBR:Forward)
 else
    SELF.TBR:CurrentPageSpin{Prop:RangeHigh} = SELF.ImageCount
    SELF.TBR:CurrentPageSpin{Prop:Msg} = SELF.Translator.TranslateString('Enter page number from 1 to') & ' ' & SELF.ImageCount
 end
 
 SELF.Translator.TranslateWindow(SELF.PW)

 !   
 IF LEN(CLIP(SELF.CaptionText))
    CFCPreview:Window{PROP:Text} = CLIP(CFCPreview:Window{PROP:Text})&': '&CLIP(SELF.CaptionText)
 END

 SELF.RestoreFromIni()      !   

 !      Office XP
 btn:Print.Init(SELF.PW,SELF.TBR:Print,,1 - SELF.OfficeXPToolbar)
 bnt:PrintCurrent.Init(SELF.PW,SELF.TBR:PrintCurrent,,1 - SELF.OfficeXPToolbar)
 btn:ZoomIn.Init(SELF.PW,SELF.TBR:ZoomIn,,1 - SELF.OfficeXPToolbar)
 btn:ZoomOut.Init(SELF.PW,SELF.TBR:ZoomOut,,1 - SELF.OfficeXPToolbar)
 btn:Search.Init(SELF.PW,SELF.TBR:Search,,1 - SELF.OfficeXPToolbar)
 btn:Save.Init(SELF.PW,SELF.TBR:Save,,1 - SELF.OfficeXPToolbar)
 btn:FS.Init(SELF.PW,SELF.TBR:FS,,1 - SELF.OfficeXPToolbar)
 btn:Back.Init(SELF.PW,SELF.TBR:Back,,1 - SELF.OfficeXPToolbar)
 btn:Forward.Init(SELF.PW,SELF.TBR:Forward,,1 - SELF.OfficeXPToolbar)
 btn:Zoom.Init(SELF.PW,SELF.TBR:Zoom,,1 - SELF.OfficeXPToolbar)

 SELF.OpenWindow(SELF.PW)   !  
 SELF.RefreshDisplay()       !  
 do ToggleZoom               !  ""    (zoom-)

 ACCEPT
    btn:Back.TakeEvent()     !   
    btn:Print.TakeEvent()
    bnt:PrintCurrent.TakeEvent()
    btn:Forward.TakeEvent()
    btn:Zoom.TakeEvent()
    btn:Search.TakeEvent()
    btn:Save.TakeEvent()
    SELF.TakeEvent()         !    
    CASE EVENT()
       OF CFC_WM_ACTIVATE ! "  "   
          SELF.PW{Prop:Active} = TRUE
       OF Event:Sized
          SELF.RefreshDisplay()
          SELF.ResizeRuler()
       OF Event:NewSelection
          IF FIELD()= SELF.TBR:CurrentPageSpin
             SELF.CurrentPage = loc:CurrentPage
             SELF.PageChanged()
             SELF.RefreshDisplay()
          END
       OF Event:CloseWindow
          if keycode() = EscKey and SELF.FS.FlagFullScreen !    ,  Esc    
             SELF.FS.RemoveFS()
             cycle
          end
       OF Event:Rejected !        
          CASE REJECTCODE()
             OF Reject:RangeHigh
                CHANGE(FIELD(),FIELD(){Prop:RangeHigh})
             OF Reject:RangeLow
                CHANGE(FIELD(),FIELD(){Prop:RangeLow})
          END
          SELF.CurrentPage = loc:CurrentPage
          SELF.PageChanged()
          SELF.RefreshDisplay()
       OF Event:AlertKey
          CASE KEYCODE()
             OF MouseRight
                SELF.ContextMenu()
             OF DownKey
                if SELF.PW{Prop:VScroll}
                    CurrentPos# = SELF.PW{Prop:VScrollPos}
                    CurrentPos# += 10
                    if CurrentPos# > 255 then CurrentPos# = 255.
                    SELF.PW{Prop:VScrollPos} = CurrentPos#
                end
             OF UpKey
                if SELF.PW{Prop:VScroll}
                    CurrentPos# = SELF.PW{Prop:VScrollPos}
                    CurrentPos# -= 10
                    if CurrentPos# < 0 then CurrentPos# = 0.
                    SELF.PW{Prop:VScrollPos} = CurrentPos#
                end
             OF RightKey
                if SELF.PW{Prop:HScroll}
                    CurrentPos# = SELF.PW{Prop:HScrollPos}
                    CurrentPos# += 10
                    if CurrentPos# > 255 then CurrentPos# = 255.
                    SELF.PW{Prop:HScrollPos} = CurrentPos#
                end
             OF LeftKey
                if SELF.PW{Prop:HScroll}
                    CurrentPos# = SELF.PW{Prop:HScrollPos}
                    CurrentPos# -= 10
                    if CurrentPos# < 0 then CurrentPos# = 0.
                    SELF.PW{Prop:HScrollPos} = CurrentPos#
                end
             OF CtrlPgDn
                if SELF.PW{Prop:VScroll}
                   SELF.PW{Prop:VScrollPos} = 255
                end
             OF CtrlPgUp
                if SELF.PW{Prop:VScroll}
                   SELF.PW{Prop:VScrollPos} = 0
                end
             OF PgDnKey !  
                if loc:CurrentPage + 1 <= SELF.ImageCount
                   loc:CurrentPage += 1
                   SELF.CurrentPage = loc:CurrentPage
                   SELF.PageChanged()
                   SELF.RefreshDisplay()
                   display(SELF.TBR:CurrentPageSpin)
                end
             OF PgUpKey !  
                if loc:CurrentPage - 1 <> 0
                   loc:CurrentPage -= 1
                   SELF.CurrentPage = loc:CurrentPage
                   SELF.PageChanged()
                   SELF.RefreshDisplay()
                   display(SELF.TBR:CurrentPageSpin)
                end
             OF CtrlHome !   
                loc:CurrentPage = 1
                SELF.CurrentPage = loc:CurrentPage
                SELF.PageChanged()
                SELF.RefreshDisplay()
                display(SELF.TBR:CurrentPageSpin)
             OF CtrlEnd  !   
                loc:CurrentPage = SELF.ImageCount
                SELF.CurrentPage = loc:CurrentPage
                SELF.PageChanged()
                SELF.RefreshDisplay()
                display(SELF.TBR:CurrentPageSpin)
             OF MouseLeft !   / 
                if FIELD() = SELF.Image
                   if SELF.ZoomType = CFC_Zoom:TilePage
                      kW$ = SELF.PW{Prop:Width}/SELF.ImageWidth
                      kH$ = SELF.PW{Prop:Height}/SELF.ImageHeight
                      if  kW$ > kH$
                         SELF.ZoomType = CFC_Zoom:PageWidth
                      else
                         SELF.ZoomType = CFC_Zoom:PageHeight
                      end
                   else
                      SELF.ZoomType = CFC_Zoom:TilePage
                   end
                   SELF.RefreshDisplay()
                   SELF.ResizeRuler()
                   do ToggleZoom
                end
             END
       OF Event:Accepted
          CASE FIELD()
             OF SELF.MNU:PrintSetup !  
                SELF.ConfigurePrint()
             OF SELF.TBR:CurrentPageSpin
                SELF.CurrentPage = loc:CurrentPage
                SELF.PageChanged()
                SELF.RefreshDisplay()
             OF SELF.TBR:ZoomIn
                if SELF.ZoomModifier + 0.2 <= 10 !      1000%
                   SELF.ZoomModifier += 0.2
                   SELF.ZoomType = CFC_Zoom:Custom
                   SELF.RefreshDisplay()
                   SELF.ResizeRuler()
                   do ToggleZoom
                end
             OF SELF.TBR:ZoomOut
                if SELF.ZoomModifier - 0.2 >= 0.2 !      20%
                   SELF.ZoomModifier -= 0.2
                   SELF.ZoomType = CFC_Zoom:Custom
                   SELF.RefreshDisplay()
                   SELF.ResizeRuler()
                   do ToggleZoom
                end
             OF SELF.MNU:ZoomIn
                POST(Event:Accepted,SELF.TBR:ZoomIn)
             OF SELF.MNU:ZoomOut
                POST(Event:Accepted,SELF.TBR:ZoomOut)
             OF SELF.MNU:Zoom50
                SELF.ZoomType = CFC_Zoom:50
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:Zoom75
                SELF.ZoomType = CFC_Zoom:75
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:Zoom100
                SELF.ZoomType = CFC_Zoom:100
                do ToggleZoom
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
             OF SELF.MNU:Zoom200
                SELF.ZoomType = CFC_Zoom:200
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:Zoom300
                SELF.ZoomType = CFC_Zoom:300
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:FitWidth
                SELF.ZoomType = CFC_Zoom:PageWidth
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:FitHeight
                SELF.ZoomType = CFC_Zoom:PageHeight
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:FitPage
                SELF.ZoomType = CFC_Zoom:TilePage
                SELF.RefreshDisplay()
                SELF.ResizeRuler()
                do ToggleZoom
             OF SELF.MNU:FullScreen
                POST(Event:Accepted,SELF.TBR:FS)
             OF SELF.TBR:FS
                if SELF.FS.FlagFullScreen
                   SELF.FS.RemoveFS()
                else
                   SELF.FS.SetFS(SELF.PW)
                end
             OF SELF.MNU:Exit ! 
                break
             OF SELF.MNU:Search
                POST(EVENT:Accepted,SELF.TBR:Search)
             OF SELF.MNU:SearchNext
                Page# = ref.Search(TRUE)
                if Page#
                   if ref.CurrentPage <> Page#
                      loc:CurrentPage = Page#
                      ref.CurrentPage = loc:CurrentPage
                      SELF.PageChanged()
                      SELF.RefreshDisplay()
                      display(ref.TBR:CurrentPageSpin)
                   end
                end
             OF SELF.MNU:PageSetup
                IF SELF.PageSetup()
                   SELF.CreateHeader() !   
                   get(SELF.HdrPreviewQueue,SELF.CurrentPage)
                   if not errorcode()
                      SELF.HeaderImage{Prop:Text} = clip(SELF.HdrPreviewQueue.WMF_Image_Path)
                   else
                      SELF.HeaderImage{Prop:Text} = ''
                   end
                END
             OF SELF.MNU:Print
                POST(EVENT:Accepted,SELF.TBR:Print)
             OF SELF.MNU:SaveCurrentPage !   
                loc:FileName = ref.SaveAsDialog()
                if len(clip(loc:FileName))
                   ref.PrintReport(FALSE,SELF.CurrentPage,SELF.CurrentPage,TRUE) !   
                   ref.SaveAs(loc:FileName)
                end
             OF SELF.MNU:Save        ! 
                POST(Event:Accepted,SELF.TBR:Save)
             OF SELF.MNU:SaveToMyDocuments !    
                loc:FileName = ref.SaveToMyDocs()
                IF LEN(CLIP(loc:FileName))
                   ref.PrintReport(FALSE,,,TRUE) !    
                   ref.SaveAs(loc:FileName)
                END
          END
    END
 END
 SELF.SaveToIni()     !     ini
 btn:Print.Kill()
 bnt:PrintCurrent.Kill()
 btn:ZoomIn.Kill()
 btn:ZoomOut.Kill()
 btn:Search.Kill()
 btn:Save.Kill()
 btn:FS.Kill()
 btn:Back.Kill()
 btn:Forward.Kill()
 btn:Zoom.Kill()
 SELF.Kill()
 SELF.CloseWindow()
 CLOSE(SELF.PW)
! ********************************************************************************************
EquateLabels ROUTINE
 SELF.TBR:Print = SELF.PW $ ?ButtonPrint{Prop:FEQ}
 SELF.TBR:PrintCurrent = SELF.PW $ ?ButtonPrint1{Prop:FEQ}
 SELF.TBR:PageStr = SELF.PW $ ?StringPage{Prop:FEQ}
 SELF.TBR:CurrentPageSpin = SELF.PW $ ?loc:CurrentPage{Prop:FEQ}
 SELF.TBR:Back = SELF.PW $ ?ButtonBack{Prop:FEQ}
 SELF.TBR:Forward = SELF.PW $ ?ButtonFwd{Prop:FEQ}
 SELF.TBR:Zoom = SELF.PW $ ?ButtonZoom{Prop:FEQ}
 SELF.TBR:ZoomIn = SELF.PW $ ?ButtonZoomIn{Prop:FEQ}
 SELF.TBR:ZoomOut = SELF.PW $ ?ButtonZoomOut{Prop:FEQ}
 SELF.TBR:Search = SELF.PW $ ?ButtonSearch{Prop:FEQ}
 SELF.TBR:Save = SELF.PW $ ?ButtonSave{Prop:FEQ}
 SELF.TBR:FS = SELF.PW $ ?ButtonFS{Prop:FEQ}

 SELF.MNU:FileMenu = SELF.PW $ ?FileMenu{Prop:FEQ}
 SELF.MNU:Print = SELF.PW $ ?Print{Prop:FEQ}
 SELF.MNU:PrintSetup = SELF.PW $ ?PrintSetup{Prop:FEQ}
 SELF.MNU:PageSetup = SELF.PW $ ?PageSetup{Prop:FEQ}
 SELF.MNU:Save = SELF.PW $ ?Save{Prop:FEQ}
 SELF.MNU:SaveCurrentPage = SELF.PW $ ?SaveCurrentPage{Prop:FEQ}
 SELF.MNU:SaveToMyDocuments = SELF.PW $ ?SaveToMyDocuments{Prop:FEQ}
 SELF.MNU:Exit = SELF.PW $ ?Exit{Prop:FEQ}

 SELF.MNU:ViewMenu = SELF.PW $ ?ViewMenu{Prop:FEQ}
 SELF.MNU:ZoomIn = SELF.PW $ ?ZoomIn{Prop:FEQ}
 SELF.MNU:ZoomOut = SELF.PW $ ?ZoomOut{Prop:FEQ}
 SELF.MNU:Zoom50 = SELF.PW $ ?loc:Zoom50{Prop:FEQ}
 SELF.MNU:Zoom75 = SELF.PW $ ?loc:Zoom75{Prop:FEQ}
 SELF.MNU:Zoom100 = SELF.PW $ ?loc:Zoom100{Prop:FEQ}
 SELF.MNU:Zoom200 = SELF.PW $ ?loc:Zoom200{Prop:FEQ}
 SELF.MNU:Zoom300 = SELF.PW $ ?loc:Zoom300{Prop:FEQ}
 SELF.MNU:FitWidth = SELF.PW $ ?loc:FitWidth{Prop:FEQ}
 SELF.MNU:FitHeight = SELF.PW $ ?loc:FitHeight{Prop:FEQ}
 SELF.MNU:FitPage = SELF.PW $ ?loc:FitPage{Prop:FEQ}
 SELF.MNU:FullScreen = SELF.PW $ ?FullScreen{Prop:FEQ}

 SELF.MNU:FindMenu = SELF.PW $ ?FindMenu{Prop:FEQ}
 SELF.MNU:Search = SELF.PW $ ?Search{Prop:FEQ}
 SELF.MNU:SearchNext = SELF.PW $ ?SearchNext{Prop:FEQ}

 SELF.RulerPanel = SELF.PW $ ?RulePanel{Prop:FEQ}
 SELF.RegionHRuler = SELF.PW $ ?RegionH{Prop:FEQ}
 SELF.RegionVRuler = SELF.PW $ ?RegionV{Prop:FEQ}

ToggleZoom    routine
 loc:Zoom50 = 0
 loc:Zoom75 = 0
 loc:Zoom100 = 0
 loc:Zoom200 = 0
 loc:Zoom300 = 0
 loc:FitWidth = 0
 loc:FitHeight = 0
 loc:FitPage = 0

 case SELF.ZoomType
    of CFC_Zoom:TilePage
       loc:FitPage = 1
    of CFC_Zoom:PageWidth
       loc:FitWidth = 1
    of CFC_Zoom:PageHeight
       loc:FitHeight = 1
    of CFC_Zoom:50
       loc:Zoom50 = 1
    of CFC_Zoom:75
       loc:Zoom75 = 1
    of CFC_Zoom:100
       loc:Zoom100 = 1
    of CFC_Zoom:200
       loc:Zoom200 = 1
    of CFC_Zoom:300
       loc:Zoom300 = 1
    of CFC_Zoom:Custom
 end
 display(?loc:Zoom50)
 display(?loc:Zoom75)
 display(?loc:Zoom100)
 display(?loc:Zoom200)
 display(?loc:Zoom300)
 display(?loc:FitWidth)
 display(?loc:FitHeight)
 display(?loc:FitPage)
! ***************************************************************************************************************
btn:Back.TakeAccepted  PROCEDURE(LONG Xpos,LONG Ypos,BYTE SplitPressed)
P           PopupClass
 code
 if SplitPressed !    
    P.Init()
    P.AddItem(SELF.Translator.TranslateString('to the first page'),'ToTheFirstPage')
    if P.Ask(Xpos,Ypos) = 'ToTheFirstPage'
       loc:CurrentPage = 1
       display(?loc:CurrentPage)
       POST(Event:Accepted,?loc:CurrentPage)
    end
    P.Kill()
 else !    
    if loc:CurrentPage - 1 <> 0
       loc:CurrentPage -= 1
       display(?loc:CurrentPage)
       POST(Event:Accepted,?loc:CurrentPage)
    end
 end
! ***************************************************************************************************************
btn:Forward.TakeAccepted  PROCEDURE(LONG Xpos,LONG Ypos,BYTE SplitPressed)
P           PopupClass
 code
 if SplitPressed !    
    P.Init()
    P.AddItem(SELF.Translator.TranslateString('to the last page'),'ToTheLastPage')
    if P.Ask(Xpos,Ypos) = 'ToTheLastPage'
       loc:CurrentPage = ?loc:CurrentPage{Prop:RangeHigh}
       display(?loc:CurrentPage)
       POST(Event:Accepted,?loc:CurrentPage)
    end
    P.Kill()
 else !    
    if loc:CurrentPage + 1 <= ?loc:CurrentPage{Prop:RangeHigh}
       loc:CurrentPage += 1
       display(?loc:CurrentPage)
       POST(Event:Accepted,?loc:CurrentPage)
    end
 end
! ***************************************************************************************************************
btn:Zoom.TakeAccepted         PROCEDURE(LONG Xpos,LONG Ypos)
 code
 if ref.DisplayZoomPopup(Xpos,Ypos) !      
    ref.RefreshDisplay()            !  
    ref.ResizeRuler()
    do ToggleZoom
 end
! ***************************************************************************************************************
btn:Search.TakeAccepted         PROCEDURE()
 code
 Page# = ref.Search(FALSE)
 if Page# !  
    if ref.CurrentPage <> Page#
       loc:CurrentPage = Page#
       ref.CurrentPage = loc:CurrentPage
       ref.PageChanged()
       ref.RefreshDisplay()
       display(ref.TBR:CurrentPageSpin)
    end
 end
! ***************************************************************************************************************
btn:Print.TakeAccepted         PROCEDURE()
 code
 ref.PrintReport(TRUE)   !  
 POST(EVENT:CloseWindow) !     
! ***************************************************************************************************************
bnt:PrintCurrent.TakeAccepted         PROCEDURE()
 code
 ref.PrintReport(TRUE,ref.CurrentPage,ref.CurrentPage,TRUE) !    
! ***************************************************************************************************************
btn:Save.TakeAccepted         PROCEDURE()
 code
 loc:FileName = ref.SaveAsDialog()
 if len(clip(loc:FileName))
    ref.PrintReport(FALSE,,,TRUE) !    
    ref.SaveAs(loc:FileName)
 end
CFCPreviewReport.FillPapers PROCEDURE
 code
 SELF.Papers.Description = 'Letter'
 SELF.Papers.Paper = PAPER:LETTER
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(11)
 add(SELF.Papers)

 SELF.Papers.Description = 'Letter Small'
 SELF.Papers.Paper = PAPER:LETTERSMALL
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(11)
 add(SELF.Papers)

 SELF.Papers.Description = 'Tabloid'
 SELF.Papers.Paper = PAPER:TABLOID
 SELF.Papers.Width = SELF.Inch2MM(11)
 SELF.Papers.Height = SELF.Inch2MM(17)
 add(SELF.Papers)

 SELF.Papers.Description = 'Ledger'
 SELF.Papers.Paper = PAPER:LEDGER
 SELF.Papers.Width = SELF.Inch2MM(17)
 SELF.Papers.Height = SELF.Inch2MM(11)
 add(SELF.Papers)

 SELF.Papers.Description = 'Legal'
 SELF.Papers.Paper = PAPER:LEGAL
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(14)
 add(SELF.Papers)

 SELF.Papers.Description = 'Statement'
 SELF.Papers.Paper = PAPER:STATEMENT
 SELF.Papers.Width = SELF.Inch2MM(5.5)
 SELF.Papers.Height = SELF.Inch2MM(8.5)
 add(SELF.Papers)

 SELF.Papers.Description = 'Executive'
 SELF.Papers.Paper = PAPER:EXECUTIVE
 SELF.Papers.Width = SELF.Inch2MM(7.25)
 SELF.Papers.Height = SELF.Inch2MM(10.5)
 add(SELF.Papers)

 SELF.Papers.Description = 'A3'
 SELF.Papers.Paper = PAPER:A3
 SELF.Papers.Width = 297
 SELF.Papers.Height = 420
 add(SELF.Papers)

 SELF.Papers.Description = 'A4'
 SELF.Papers.Paper = PAPER:A4
 SELF.Papers.Width = 210
 SELF.Papers.Height = 297
 add(SELF.Papers)

 SELF.Papers.Description = 'A4 Small'
 SELF.Papers.Paper = PAPER:A4SMALL
 SELF.Papers.Width = 210
 SELF.Papers.Height = 297
 add(SELF.Papers)

 SELF.Papers.Description = 'A5'
 SELF.Papers.Paper = PAPER:A5
 SELF.Papers.Width = 148
 SELF.Papers.Height = 210
 add(SELF.Papers)

 SELF.Papers.Description = 'B4'
 SELF.Papers.Paper = PAPER:B4
 SELF.Papers.Width = 250
 SELF.Papers.Height = 354
 add(SELF.Papers)

 SELF.Papers.Description = 'B5'
 SELF.Papers.Paper = PAPER:B5
 SELF.Papers.Width = 182
 SELF.Papers.Height = 257
 add(SELF.Papers)

 SELF.Papers.Description = 'Folio'
 SELF.Papers.Paper = PAPER:FOLIO
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(13)
 add(SELF.Papers)

 SELF.Papers.Description = 'Quarto'
 SELF.Papers.Paper = PAPER:QUARTO
 SELF.Papers.Width = 215
 SELF.Papers.Height = 275
 add(SELF.Papers)

 SELF.Papers.Description = '10x14 in'
 SELF.Papers.Paper = PAPER:10X14
 SELF.Papers.Width = SELF.Inch2MM(10)
 SELF.Papers.Height = SELF.Inch2MM(14)
 add(SELF.Papers)

 SELF.Papers.Description = '11x17 in'
 SELF.Papers.Paper = PAPER:11X17
 SELF.Papers.Width = SELF.Inch2MM(11)
 SELF.Papers.Height = SELF.Inch2MM(17)
 add(SELF.Papers)

 SELF.Papers.Description = 'Note'
 SELF.Papers.Paper = PAPER:NOTE
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(11)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope #9'
 SELF.Papers.Paper = PAPER:ENV_9
 SELF.Papers.Width = SELF.Inch2MM(3.875)
 SELF.Papers.Height = SELF.Inch2MM(8.875)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope #10'
 SELF.Papers.Paper = PAPER:ENV_10
 SELF.Papers.Width = SELF.Inch2MM(4.125)
 SELF.Papers.Height = SELF.Inch2MM(9.5)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope #11'
 SELF.Papers.Paper = PAPER:ENV_11
 SELF.Papers.Width = SELF.Inch2MM(4.5)
 SELF.Papers.Height = SELF.Inch2MM(10.375)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope #12'
 SELF.Papers.Paper = PAPER:ENV_12
 SELF.Papers.Width = SELF.Inch2MM(4.276)
 SELF.Papers.Height = SELF.Inch2MM(11)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope #14'
 SELF.Papers.Paper = PAPER:ENV_14
 SELF.Papers.Width = SELF.Inch2MM(5)
 SELF.Papers.Height = SELF.Inch2MM(11.5)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope DL'
 SELF.Papers.Paper = PAPER:ENV_DL
 SELF.Papers.Width = 110
 SELF.Papers.Height = 220
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope C5'
 SELF.Papers.Paper = PAPER:ENV_C5
 SELF.Papers.Width = 162
 SELF.Papers.Height = 229
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope C3'
 SELF.Papers.Paper = PAPER:ENV_C3
 SELF.Papers.Width = 324
 SELF.Papers.Height = 458
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope C4'
 SELF.Papers.Paper = PAPER:ENV_C4
 SELF.Papers.Width = 229
 SELF.Papers.Height = 324
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope C6'
 SELF.Papers.Paper = PAPER:ENV_C6
 SELF.Papers.Width = 114
 SELF.Papers.Height = 162
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope C65'
 SELF.Papers.Paper = PAPER:ENV_C65
 SELF.Papers.Width = 114
 SELF.Papers.Height = 229
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope B4'
 SELF.Papers.Paper = PAPER:ENV_B4
 SELF.Papers.Width = 250
 SELF.Papers.Height = 353
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope B5'
 SELF.Papers.Paper = PAPER:ENV_B5
 SELF.Papers.Width = 176
 SELF.Papers.Height = 250
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope B6'
 SELF.Papers.Paper = PAPER:ENV_B6
 SELF.Papers.Width = 176
 SELF.Papers.Height = 125
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope'
 SELF.Papers.Paper = PAPER:ENV_ITALY
 SELF.Papers.Width = 110
 SELF.Papers.Height = 230
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope Monarch'
 SELF.Papers.Paper = PAPER:ENV_MONARCH
 SELF.Papers.Width = SELF.Inch2MM(3.875)
 SELF.Papers.Height = SELF.Inch2MM(7.5)
 add(SELF.Papers)

 SELF.Papers.Description = 'Envelope Personal'
 SELF.Papers.Paper = PAPER:ENV_PERSONAL
 SELF.Papers.Width = SELF.Inch2MM(3.625)
 SELF.Papers.Height = SELF.Inch2MM(6.5)
 add(SELF.Papers)

 SELF.Papers.Description = 'US Std Fanfold'
 SELF.Papers.Paper = PAPER:FANFOLD_US
 SELF.Papers.Width = SELF.Inch2MM(14.875)
 SELF.Papers.Height = SELF.Inch2MM(11)
 add(SELF.Papers)

 SELF.Papers.Description = 'German Std Fanfold'
 SELF.Papers.Paper = PAPER:FANFOLD_STD_GERMAN
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(12)
 add(SELF.Papers)

 SELF.Papers.Description = 'German Legal Fanfold'
 SELF.Papers.Paper = PAPER:FANFOLD_LGL_GERMAN
 SELF.Papers.Width = SELF.Inch2MM(8.5)
 SELF.Papers.Height = SELF.Inch2MM(13)
 add(SELF.Papers)

 SELF.Papers.Description = 'C size sheet'
 SELF.Papers.Paper = PAPER:CSHEET
 SELF.Papers.Width = 254
 SELF.Papers.Height = 254
 add(SELF.Papers)

 SELF.Papers.Description = 'D size sheet'
 SELF.Papers.Paper = PAPER:DSHEET
 SELF.Papers.Width = 254
 SELF.Papers.Height = 254
 add(SELF.Papers)

 SELF.Papers.Description = 'E size sheet'
 SELF.Papers.Paper = PAPER:ESHEET
 SELF.Papers.Width = 254
 SELF.Papers.Height = 254
 add(SELF.Papers)

 if SELF.ReportLandscape !   ,   "" 
    loop j# = 1 to records(SELF.Papers)
       get(SELF.Papers,j#)
       Tmp# = SELF.Papers.Width
       SELF.Papers.Width = SELF.Papers.Height
       SELF.Papers.Height = Tmp#
       put(SELF.Papers)
    end
 end
CFCPreviewReport.Inch2MM PROCEDURE(REAL inch)
 code
 return inch*25.40 !    


CFCPreviewReport.MM2Inch PROCEDURE(REAL mm)
 code
 return mm*1000/25.40 !    1/1000- 
CFCPreviewReport.SetHRuler PROCEDURE()
 code
 SELF.RulerH.Init(SELF.PW,SELF.RegionHRuler)
 SELF.RulerH.OffsetChangeEnbl = FALSE
 SELF.RulerH.Xpos = SELF.RulerPanel{Prop:Xpos} + SELF.RulerPanel{Prop:Width} + 4
 SELF.RulerH.Ypos = SELF.RulerPanel{Prop:Ypos}
 SELF.RulerH.LengthPx = SELF.Image{Prop:Width}
 SELF.RulerH.ThickPx = 14
 SELF.RulerH.MaxPointsPerUnit = 4

 SELF.RulerH.FontFace = 'Tahoma'
 SELF.RulerH.FontSize = 7

 if not SELF.ReportPaper = PAPER:User
    SELF.Papers.Paper = SELF.ReportPaper
    get(SELF.Papers,SELF.Papers.Paper)
    if not errorcode()
       SELF.RulerH.LengthU = SELF.Papers.Width
    end
 else
    if SELF.ReportLandscape
       SELF.RulerH.LengthU = SELF.ReportPaperH
    else
       SELF.RulerH.LengthU = SELF.ReportPaperW
    end
 end

 case SELF.PreviewUnits !     
    of CFC:MM
       SELF.RulerH.UnitRate = 10
       case SELF.ReportUnits
          of CFC:Thous
             SELF.ReportXpos = SELF.Inch2MM(SELF.ReportXpos)/1000
             SELF.ReportWidth = SELF.Inch2MM(SELF.ReportWidth)/1000
          of CFC:Points
             SELF.ReportXpos = SELF.Inch2MM(SELF.ReportXpos/72)
             SELF.ReportWidth = SELF.Inch2MM(SELF.ReportWidth/72)
       end
    of CFC:Thous
       SELF.RulerH.UnitRate = 1000
       SELF.RulerH.LengthU = SELF.MM2Inch(SELF.RulerH.LengthU)
       SELF.HeaderBorder = SELF.MM2Inch(SELF.HeaderBorder)
       SELF.FooterBorder = SELF.MM2Inch(SELF.FooterBorder)

       loop k# = 1 to records(SELF.Headers)
          get(SELF.Headers,k#)
          SELF.Headers.H.LeftOffset = SELF.MM2Inch(SELF.Headers.H.LeftOffset)
          SELF.Headers.H.RightOffset = SELF.MM2Inch(SELF.Headers.H.RightOffset)
       end

       case SELF.ReportUnits
          of CFC:MM
             SELF.ReportXpos = SELF.MM2Inch(SELF.ReportXpos)
             SELF.ReportWidth = SELF.MM2Inch(SELF.ReportWidth)
          of CFC:Points
             SELF.ReportXpos = SELF.ReportXpos*1000/72
             SELF.ReportWidth = SELF.ReportWidth*1000/72
       end
    of CFC:Points
       SELF.RulerH.UnitRate = 100
       SELF.RulerH.LengthU = SELF.MM2Inch(SELF.RulerH.LengthU)*72/1000
       SELF.HeaderBorder = SELF.MM2Inch(SELF.HeaderBorder)*72/1000
       SELF.FooterBorder = SELF.MM2Inch(SELF.FooterBorder)*72/1000

       loop k# = 1 to records(SELF.Headers)
          get(SELF.Headers,k#)
          SELF.Headers.H.LeftOffset = SELF.MM2Inch(SELF.Headers.H.LeftOffset)*72/1000
          SELF.Headers.H.RightOffset = SELF.MM2Inch(SELF.Headers.H.RightOffset)*72/1000
       end

       case SELF.ReportUnits
          of CFC:MM
             SELF.ReportXpos = SELF.MM2Inch(SELF.ReportXpos)*72/1000
             SELF.ReportWidth = SELF.MM2Inch(SELF.ReportWidth)*72/1000
          of CFC:Thous
             SELF.ReportXpos = SELF.ReportXpos*72/1000
             SELF.ReportWidth = SELF.ReportWidth*72/1000
       end
 end

 SELF.RulerH.StartOffset = SELF.ReportXpos
 if SELF.RulerH.StartOffset < 0 then SELF.RulerH.StartOffset = 0.
 SELF.RulerH.EndOffset = SELF.RulerH.LengthU - SELF.ReportWidth - SELF.ReportXpos
 if SELF.RulerH.EndOffset < 0 then SELF.RulerH.EndOffset = 0.

 SELF.RulerH.SetRegionSize()
 SELF.RulerH.Draw()
CFCPreviewReport.SetVRuler PROCEDURE()
 code
 SELF.RulerV.Init(SELF.PW,SELF.RegionVRuler)
 SELF.RulerV.OffsetChangeEnbl = FALSE
 SELF.RulerV.Xpos = SELF.RulerPanel{Prop:Xpos}
 SELF.RulerV.Ypos = SELF.RulerPanel{Prop:Ypos} + SELF.RulerPanel{Prop:Height} + 4
 SELF.RulerV.LengthPx = SELF.Image{Prop:Height}
 SELF.RulerV.ThickPx = 14
 SELF.RulerV.MaxPointsPerUnit = 4
 
 SELF.RulerV.FontFace = 'Tahoma'
 SELF.RulerV.FontSize = 7

 if not SELF.ReportPaper = PAPER:User
    SELF.Papers.Paper = SELF.ReportPaper
    get(SELF.Papers,SELF.Papers.Paper)
    if not errorcode()
       SELF.RulerV.LengthU = SELF.Papers.Height
    end
 else
    if SELF.ReportLandscape
       SELF.RulerH.LengthU = SELF.ReportPaperW
    else
       SELF.RulerH.LengthU = SELF.ReportPaperH
    end
 end

 if SELF.HeaderYpos !       page header-
    SELF.ReportYpos = SELF.HeaderYpos
 end

 case SELF.PreviewUnits !     
    of CFC:MM
       SELF.RulerV.UnitRate = 10
       case SELF.ReportUnits
          of CFC:Thous
             SELF.ReportYpos = SELF.Inch2MM(SELF.ReportYpos)/1000
             SELF.ReportHeight = SELF.Inch2MM(SELF.ReportHeight)/1000
             SELF.FooterYpos = SELF.Inch2MM(SELF.FooterYpos)/1000
             SELF.FooterHeight = SELF.Inch2MM(SELF.FooterHeight)/1000
          of CFC:Points
             SELF.ReportYpos = SELF.Inch2MM(SELF.ReportYpos/72)
             SELF.ReportHeight = SELF.Inch2MM(SELF.ReportHeight/72)
             SELF.FooterYpos = SELF.Inch2MM(SELF.FooterYpos/72)
             SELF.FooterHeight = SELF.Inch2MM(SELF.FooterHeight/72)
       end
    of CFC:Thous
       SELF.RulerV.UnitRate = 1000
       SELF.RulerV.LengthU = SELF.MM2Inch(SELF.RulerV.LengthU)
       case SELF.ReportUnits
          of CFC:MM
             SELF.ReportYpos = SELF.MM2Inch(SELF.ReportYpos)
             SELF.ReportHeight = SELF.MM2Inch(SELF.ReportHeight)
             SELF.FooterYpos = SELF.MM2Inch(SELF.FooterYpos)
             SELF.FooterHeight = SELF.MM2Inch(SELF.FooterHeight)
          of CFC:Points
             SELF.ReportYpos = SELF.ReportYpos*1000/72
             SELF.ReportHeight = SELF.ReportHeight*1000/72
             SELF.FooterYpos = SELF.FooterYpos*1000/72
             SELF.FooterHeight = SELF.FooterHeight*1000/72
       end
    of CFC:Points
       SELF.RulerV.UnitRate = 100
       SELF.RulerV.LengthU = SELF.MM2Inch(SELF.RulerV.LengthU)*72/1000
       case SELF.ReportUnits
          of CFC:MM
             SELF.ReportYpos = SELF.MM2Inch(SELF.ReportYpos)*72/1000
             SELF.ReportHeight = SELF.MM2Inch(SELF.ReportHeight)*72/1000
             SELF.FooterYpos = SELF.MM2Inch(SELF.FooterYpos)*72/1000
             SELF.FooterHeight = SELF.MM2Inch(SELF.FooterHeight)*72/1000
          of CFC:Thous
             SELF.ReportYpos = SELF.ReportYpos*72/1000
             SELF.ReportHeight = SELF.ReportHeight*72/1000
             SELF.FooterYpos = SELF.FooterYpos*72/1000
             SELF.FooterHeight = SELF.FooterHeight*72/1000
       end
 end

 SELF.RulerV.StartOffset = SELF.ReportYpos
 if SELF.RulerV.StartOffset < 0 then SELF.RulerV.StartOffset = 0.

 if SELF.FooterYpos and SELF.FooterHeight
    SELF.RulerV.EndOffset = SELF.RulerV.LengthU - SELF.FooterYpos - SELF.FooterHeight
 else
    SELF.RulerV.EndOffset = SELF.RulerV.LengthU - SELF.ReportHeight - SELF.ReportYpos
 end
 if SELF.RulerV.EndOffset < 0 then SELF.RulerV.EndOffset = 0.

 SELF.RulerV.SetRegionSize()
 SELF.RulerV.Draw()
CFCPreviewReport.ResizeRuler PROCEDURE
 code
 SELF.RulerH.Erase()
 SELF.RulerH.LengthPx = SELF.Image{Prop:Width}
 SELF.RulerH.SetRegionSize() !    Draw,    WM_PAINT   

 SELF.RulerV.Erase()
 SELF.RulerV.LengthPx = SELF.Image{Prop:Height}
 SELF.RulerV.SetRegionSize()

CFCPreviewReport.IsVScrollVisible     PROCEDURE()
loc:ReturnValue BYTE
 code
 if BAND(CFC_GetWindowLong(self.PW{Prop:ClientHandle},CFC_GWL_STYLE),CFC_WS_VSCROLL) = CFC_WS_VSCROLL
    loc:ReturnValue = TRUE
 end

 return loc:ReturnValue


CFCPreviewReport.IsHScrollVisible     PROCEDURE()
loc:ReturnValue BYTE
 code
 if BAND(CFC_GetWindowLong(self.PW{Prop:ClientHandle},CFC_GWL_STYLE),CFC_WS_HSCROLL) = CFC_WS_HSCROLL
    loc:ReturnValue = TRUE
 end

 return loc:ReturnValue
CFCPreviewReport.RestoreFromIni         PROCEDURE
loc:localPath STRING(260)
 CODE

 IF NOT SELF.Comctrl &= NULL
    loc:localPath = SELF.Comctrl.GetLocalPath()
 END
 IF LEN(CLIP(loc:localPath))
    loc:localPath = CLIP(loc:localPath) & '\CFCPreviewer.ini'
 ELSE
    loc:localPath = 'CFCPreviewer.ini'
 END

 Xpos# = GETINI('CFCPreviewer','Xpos',,CLIP(loc:localPath))
 Ypos# = GETINI('CFCPreviewer','Ypos',,CLIP(loc:localPath))
 Width# = GETINI('CFCPreviewer','Width',,CLIP(loc:localPath))
 Height# = GETINI('CFCPreviewer','Height',,CLIP(loc:localPath))
 Maximize# = GETINI('CFCPreviewer','Max',,CLIP(loc:localPath))

 IF Xpos# > CFC_GetSystemMetrics(CFC_SM_CXSCREEN) THEN Xpos# = 1 END
 IF Ypos# > CFC_GetSystemMetrics(CFC_SM_CYSCREEN) THEN Ypos# = 1 END

 IF Maximize#
    SELF.PW{Prop:Maximize} = 1
 ELSE
    IF Xpos# > 0 THEN SELF.PW{Prop:Xpos} = Xpos# END
    IF Ypos# > 0 THEN SELF.PW{Prop:Ypos} = Ypos# END
    IF Width# THEN SELF.PW{Prop:Width} = Width# END
    IF Height# THEN SELF.PW{Prop:Height} = Height# END
 END



CFCPreviewReport.SaveToIni         PROCEDURE
loc:localPath STRING(260)
 CODE

 IF NOT SELF.Comctrl &= NULL
    loc:localPath = SELF.Comctrl.GetLocalPath()
 END
 IF LEN(CLIP(loc:localPath))
    loc:localPath = CLIP(loc:localPath) & '\CFCPreviewer.ini'
 ELSE
    loc:localPath = 'CFCPreviewer.ini'
 END

 IF NOT SELF.PW{PROP:Iconize}
    PUTINI('CFCPreviewer','Xpos',SELF.PW{Prop:Xpos},CLIP(loc:localPath))
    PUTINI('CFCPreviewer','Ypos',SELF.PW{Prop:Ypos},CLIP(loc:localPath))
    PUTINI('CFCPreviewer','Max',SELF.PW{Prop:Maximize},CLIP(loc:localPath))
 END
 IF NOT SELF.PW{Prop:Maximize}
    PUTINI('CFCPreviewer','Width',SELF.PW{Prop:Width},CLIP(loc:localPath))
    PUTINI('CFCPreviewer','Height',SELF.PW{Prop:Height},CLIP(loc:localPath))
 END
CFCPreviewReport.Search  PROCEDURE(BYTE inSearchNext)
loc:Entry       STRING(256)
loc:Direction   BYTE
loc:RetValue    LONG
loc:Start       LONG
loc:End         LONG
loc:Step        LONG
CFCWindowSearch WINDOW('Find...'),AT(,,210,69),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY,DOUBLE
       STRING('Find what'),AT(2,6),USE(?String1)
       ENTRY(@s200),AT(40,4,167,12),USE(loc:Entry),REQ
       OPTION('Option 1'),AT(56,20,97,15),USE(loc:Direction)
         RADIO('Up'),AT(58,22),USE(?Option1:Radio1),VALUE('1')
         RADIO('Down'),AT(106,22,35,10),USE(?Option1:Radio2),VALUE('2')
       END
       BUTTON('Find on next page'),AT(2,51,82,14),USE(?ButtonNext)
       STRING('Direction'),AT(2,22),USE(?String2)
       BUTTON('Find'),AT(114,50,45,14),USE(?ButtonFind),DEFAULT,REQ
       BUTTON('Cancel'),AT(162,50,45,14),USE(?ButtonCancel),STD(STD:Close)
     END
 code
 open(CFCWindowSearch)
 self.Translator.TranslateWindow(CFCWindowSearch)       ! 
 loc:Direction = 2
 loc:Entry = SELF.LastSearch
 if SELF.SearchDirection
    loc:Direction = SELF.SearchDirection
 end

 IF inSearchNext !  " "   ,  
    IF LEN(CLIP(SELF.LastSearch))
       CASE SELF.SearchDirection
          OF 1
             loc:Start = SELF.CurrentPage - 1
             if loc:Start <= 1 then loc:Start = 1.
             loc:End = 1
             loc:Step = -1
          OF 2
             loc:Start = SELF.CurrentPage + 1
             if loc:Start >= records(SELF.PreviewQueue) then loc:Start = records(SELF.PreviewQueue).
             loc:End = records(SELF.PreviewQueue)
             loc:Step = 1
       END
       DO SearchR
       IF NOT loc:RetValue !    
          MESSAGE(SELF.Translator.TranslateString('No occurences of: ') & clip(loc:Entry) & SELF.Translator.TranslateString(' were found in the report!'),|
                  SELF.Translator.TranslateString('Find...'),ICON:Exclamation)
       END
       RETURN loc:RetValue
    END
 END

 DO ChangeBNextText !   ?ButtonNext

 SELF.OpenSearchWindow(CFCWindowSearch)

 ACCEPT
     CASE EVENT()
        OF EVENT:Accepted
           CASE FIELD()
              OF ?ButtonFind
                 SELF.LastSearch = loc:Entry
                 SELF.SearchDirection = loc:Direction
                 CASE loc:Direction
                    OF 1
                       loc:Start = SELF.CurrentPage
                       loc:End = 1
                       loc:Step = -1
                    OF 2
                       loc:Start = SELF.CurrentPage
                       loc:End = records(SELF.PreviewQueue)
                       loc:Step = 1
                 END
                 DO SearchR
                 IF loc:RetValue
                    BREAK
                 ELSE
                    MESSAGE(SELF.Translator.TranslateString('No occurences of: ') & clip(loc:Entry) & SELF.Translator.TranslateString(' were found in the report!'),|
                            SELF.Translator.TranslateString('Find...'),ICON:Exclamation)
                 END
              OF ?ButtonNext
                 IF LEN(CLIP(loc:Entry))
                    SELF.LastSearch = loc:Entry
                    SELF.SearchDirection = loc:Direction
                    CASE loc:Direction
                       OF 1
                          loc:Start = SELF.CurrentPage - 1
                          if loc:Start <= 1 then loc:Start = 1.
                          loc:End = 1
                          loc:Step = -1
                       OF 2
                          loc:Start = SELF.CurrentPage + 1
                          if loc:Start >= records(SELF.PreviewQueue) then loc:Start = records(SELF.PreviewQueue).
                          loc:End = records(SELF.PreviewQueue)
                          loc:Step = 1
                    END
                    DO SearchR
                    IF loc:RetValue
                       BREAK
                    ELSE
                       MESSAGE(SELF.Translator.TranslateString('No occurences of: ') & clip(loc:Entry) & SELF.Translator.TranslateString(' were found in the report!'),|
                               SELF.Translator.TranslateString('Find...'),ICON:Exclamation)
                    END
                 END
              OF ?loc:Direction
                 DO ChangeBNextText
           END
     END
 END
 close(CFCWindowSearch)
 return loc:RetValue

SearchR ROUTINE
 SETCURSOR(CURSOR:Wait)
 loop j# = loc:Start to loc:End by loc:Step
   get(SELF.PreviewQueue,j#)
   YIELD
   if SELF.SearchTxt.Run(clip(SELF.PreviewQueue.WMF_Image_Path),clip(loc:Entry))
      loc:RetValue = j#
      break
   end
 end
 SETCURSOR()

ChangeBNextText ROUTINE
 CASE loc:Direction
   OF 1
      ?ButtonNext{Prop:Text} = SELF.Translator.TranslateString('Find on previous page')
   OF 2
      ?ButtonNext{Prop:Text} = SELF.Translator.TranslateString('Find on next page')
 END
CFCPreviewReport.PageSetup  PROCEDURE()

PasteStrClass         CLASS
Run                      PROCEDURE(*STRING inData,STRING inPaste,LONG inFEQ)
                      END

loc:RetValue          BYTE
loc:Left              DECIMAL(15,2)
loc:Right             DECIMAL(15,2)
loc:Bottom            DECIMAL(15,2)
loc:Top               DECIMAL(15,2)
loc:MU                STRING(15)
loc:HeaderBorder      DECIMAL(15,2)
loc:FooterBorder      DECIMAL(15,2)
loc:PHL               STRING(1024)
loc:PHC               STRING(1024)
loc:PHR               STRING(1024)
loc:PFL               STRING(1024)
loc:PFC               STRING(1024)
loc:PFR               STRING(1024)
loc:PHL:LeftOffset    LONG
loc:PHC:LeftOffset    LONG
loc:PHR:LeftOffset    LONG
loc:PFL:LeftOffset    LONG
loc:PFC:LeftOffset    LONG
loc:PFR:LeftOffset    LONG
loc:PHL:RightOffset   LONG
loc:PHC:RightOffset   LONG
loc:PHR:RightOffset   LONG
loc:PFL:RightOffset   LONG
loc:PFC:RightOffset   LONG
loc:PFR:RightOffset   LONG

loc:HeaderType        BYTE
loc:Location          BYTE
loc:Typeface          STRING(31)
loc:FontSize          LONG
loc:FontColor         LONG
loc:FontStyle         LONG
loc:HdrOnFirstPage    BYTE
loc:Orientation       BYTE       !  

loc:H                 QUEUE(CFCTQHeader).

loc:Str               STRING(20)

btn:Font              CLASS(CFCButton)
TakeAccepted             PROCEDURE(),VIRTUAL,DERIVED
                      END
btn:Time              CFCButton
btn:Date              CFCButton
btn:Page              CFCButton
btn:Pages             CFCButton

btn:HeaderType1       CLASS(CFCOptionBox)
TakeAccepted             PROCEDURE(),VIRTUAL,DERIVED
                      END
btn:HeaderType2       CLASS(CFCOptionBox)
TakeAccepted             PROCEDURE(),VIRTUAL,DERIVED
                      END
btn:HeaderLocation    CLASS(CFCDropButton)
TakeAccepted             PROCEDURE(LONG Xpos,LONG Ypos),VIRTUAL,DERIVED
                      END


CFCPageSetup WINDOW('Page setup'),AT(,,242,222),FONT('MS Sans Serif',8,,FONT:regular),GRAY,DOUBLE
       SHEET,AT(2,2,239,202),USE(?Sheet1)
         TAB('Borders'),USE(?Tab1)
           STRING('Top:'),AT(48,18,61,10),USE(?String1),CENTER
           STRING('Bottom:'),AT(48,116,61,10),USE(?String2),TRN,CENTER
           STRING('Left:'),AT(6,62,40,10),USE(?String3),CENTER
           STRING('Right:'),AT(112,62,40,10),USE(?String4),CENTER
           STRING(@s6),AT(6,72,40,10),USE(loc:Left),CENTER
           STRING(@s6),AT(112,72,40,10),USE(loc:Right),CENTER
           STRING(@s10),AT(48,124,61,10),USE(loc:Bottom),TRN,CENTER
           STRING(@s15),AT(56,132),USE(loc:MU),TRN
           CHECK('Print on first page'),AT(134,132),USE(loc:HdrOnFirstPage),LEFT,VALUE('1','0')
           STRING(@s10),AT(48,28,61,10),USE(loc:Top),TRN,CENTER
           IMAGE('CFCBorders.gif'),AT(48,38),USE(?Image)
           STRING('Measure unit:'),AT(10,132),USE(?String5)
           STRING('Header'),AT(152,26),USE(?String6)
           STRING('Footer'),AT(152,90),USE(?String7)
           SPIN(@n7b),AT(152,38,41,12),USE(loc:HeaderBorder)
           SPIN(@n7b),AT(152,103,41,12),USE(loc:FooterBorder)
           OPTION('Orientation'),AT(10,152,104,48),USE(loc:Orientation),BOXED
             RADIO('Portrait'),AT(14,162,45,34),USE(?Option2:Radio1),FLAT,ICON('CFCPortrait.ico'),VALUE('1')
             RADIO('Landscape'),AT(62,162,48,34),USE(?Option2:Radio2),FLAT,ICON('CFCLandscape.ico'),VALUE('2')
           END
         END
         TAB('Header/footer'),USE(?Tab2)
           SHEET,AT(4,34,233,109),USE(?Sheet),BELOW
             TAB('HL'),USE(?Tab3)
               TEXT,AT(6,36,229,72),USE(loc:PHL),VSCROLL,FONT('MS Sans Serif',8,,)
               STRING('Left offset'),AT(8,114),USE(?String13)
               SPIN(@n7b),AT(58,112,41,12),USE(loc:PHL:LeftOffset)
               STRING('Right offset'),AT(138,114),USE(?String14)
               SPIN(@n7b),AT(192,112,41,12),USE(loc:PHL:RightOffset)
             END
             TAB('HC'),USE(?Tab4)
               TEXT,AT(6,36,229,72),USE(loc:PHC),VSCROLL,FONT('MS Sans Serif',8,,)
               STRING('Left offset'),AT(8,114),USE(?String13:1)
               SPIN(@n7b),AT(58,112,41,12),USE(loc:PHC:LeftOffset)
               STRING('Right offset'),AT(138,114),USE(?String14:1)
               SPIN(@n7b),AT(192,112,41,12),USE(loc:PHC:RightOffset)
             END
             TAB('HR'),USE(?Tab5)
               TEXT,AT(6,36,229,72),USE(loc:PHR),VSCROLL,FONT('MS Sans Serif',8,,)
               STRING('Left offset'),AT(8,114),USE(?String13:2)
               SPIN(@n7b),AT(58,112,41,12),USE(loc:PHR:LeftOffset)
               STRING('Right offset'),AT(138,114),USE(?String14:2)
               SPIN(@n7b),AT(192,112,41,12),USE(loc:PHR:RightOffset)
             END
             TAB('FL'),USE(?Tab6)
               TEXT,AT(6,36,229,72),USE(loc:PFL),VSCROLL,FONT('MS Sans Serif',8,,)
               STRING('Left offset'),AT(8,114),USE(?String13:3)
               SPIN(@n7b),AT(58,112,41,12),USE(loc:PFL:LeftOffset)
               STRING('Right offset'),AT(138,114),USE(?String14:3)
               SPIN(@n7b),AT(192,112,41,12),USE(loc:PFL:RightOffset)
             END
             TAB('FC'),USE(?Tab7)
               TEXT,AT(6,36,229,72),USE(loc:PFC),VSCROLL,FONT('MS Sans Serif',8,,)
               STRING('Left offset'),AT(8,114),USE(?String13:4)
               SPIN(@n7b),AT(58,112,41,12),USE(loc:PFC:LeftOffset)
               STRING('Right offset'),AT(138,114),USE(?String14:4)
               SPIN(@n7b),AT(192,112,41,12),USE(loc:PFC:RightOffset)
             END
             TAB('FR'),USE(?Tab8),FONT('Courier New',10,,)
               TEXT,AT(6,36,229,72),USE(loc:PFR),VSCROLL,FONT('MS Sans Serif',8,,)
               STRING('Left offset'),AT(8,114),USE(?String13:5)
               SPIN(@n7b),AT(58,112,41,12),USE(loc:PFR:LeftOffset)
               STRING('Right offset'),AT(138,114),USE(?String14:5)
               SPIN(@n7b),AT(192,112,41,12),USE(loc:PFR:RightOffset)
             END
           END
           OPTION,AT(4,18,116,14),USE(loc:HeaderType),SKIP
             RADIO('page header'),AT(6,18,,12),USE(?loc:HeaderType:Radio1),SKIP,FLAT,VALUE('1')
             RADIO('page footer'),AT(64,18,56,12),USE(?loc:HeaderType:Radio2),SKIP,FLAT,VALUE('2')
           END
           PANEL,AT(6,32,230,1),USE(?Panel1),BEVEL(-1)
           BUTTON,AT(220,17,16,14),USE(?ButtonFont),SKIP,TIP('Set header/footer font'),ICON('CFCFont.ico')
           BUTTON,AT(202,17,16,14),USE(?ButtonTime),SKIP,TIP('Insert [Time]'),ICON('CFCTime.ico')
           BUTTON,AT(184,17,16,14),USE(?ButtonDate),SKIP,TIP('Insert [Date]'),ICON('CFCDate.ico')
           BUTTON,AT(148,17,16,14),USE(?ButtonPage),SKIP,TIP('Insert [Page]'),ICON('CFCPage.ico')
           BUTTON,AT(166,17,16,14),USE(?ButtonPages),SKIP,TIP('Insert [Pages]'),ICON('CFCPages.ico')
           PANEL,AT(144,18,1,14),USE(?Panel2),BEVEL(-1)
           BUTTON,AT(122,17,19,14),USE(?ButtonLocation),SKIP,LEFT,TIP('Set header/footer location'),ICON('CFCAlignLeft.ico')
         END
       END
       BUTTON('OK'),AT(146,206,45,14),USE(?ButtonOK),DEFAULT
       BUTTON('Cancel'),AT(194,206,45,14),USE(?ButtonCancel),STD(STD:Close)
     END

 code
 loc:HeaderType = 1 !    
 loc:Location = 1   !    
 loc:HdrOnFirstPage = SELF.HdrOnFirstPage !    

 IF SELF.ReportLandscape          !  
    loc:Orientation = 2           ! 
 ELSE
    loc:Orientation = 1           ! 
 END

 OPEN(CFCPageSetup)

 ?Sheet{Prop:Wizard} = TRUE
 ?Sheet{Prop:NoSheet} = TRUE

 SELF.OpenPageSetupWindow(CFCPageSetup)

 DO SelectTab           !   
 DO InitHeaders         !    
 DO SavePreviousHeaders !   
 SELECT(?Tab1)

 !    " "
 btn:HeaderType1.Init(CFCPageSetup,?loc:HeaderType:Radio1,,1 - SELF.OfficeXPToolbar)
 btn:HeaderType1.SetVar(loc:HeaderType)
 btn:HeaderType2.Init(CFCPageSetup,?loc:HeaderType:Radio2,,1 - SELF.OfficeXPToolbar)
 btn:HeaderType2.SetVar(loc:HeaderType)
 btn:HeaderLocation.Init(CFCPageSetup,?ButtonLocation,,1 - SELF.OfficeXPToolbar)

 btn:Font.Init(CFCPageSetup,?ButtonFont,,1 - SELF.OfficeXPToolbar)
 btn:Time.Init(CFCPageSetup,?ButtonTime,,1 - SELF.OfficeXPToolbar)
 btn:Date.Init(CFCPageSetup,?ButtonDate,,1 - SELF.OfficeXPToolbar)
 btn:Page.Init(CFCPageSetup,?ButtonPage,,1 - SELF.OfficeXPToolbar)
 btn:Pages.Init(CFCPageSetup,?ButtonPages,,1 - SELF.OfficeXPToolbar)

 ! 
 self.Translator.TranslateWindow(CFCPageSetup)

 !    
 loc:Left = SELF.RulerH.StartOffset
 loc:Right = SELF.RulerH.EndOffset
 loc:Top = SELF.RulerV.StartOffset
 loc:Bottom = SELF.RulerV.EndOffset
 loc:HeaderBorder = SELF.HeaderBorder
 loc:FooterBorder = SELF.FooterBorder

 !  ,    
 case SELF.PreviewUnits
    of CFC:MM
       loc:MU = SELF.Translator.TranslateString('mm')
    of CFC:Thous
       loc:MU = SELF.Translator.TranslateString('1/1000 inch')
    of CFC:Points
       loc:MU = SELF.Translator.TranslateString('points')
 end


 ACCEPT
    btn:HeaderLocation.TakeEvent()
    btn:HeaderType1.TakeEvent()
    btn:HeaderType2.TakeEvent()
    btn:Font.TakeEvent()
    CASE EVENT()
       OF EVENT:Accepted
          CASE FIELD()
             OF ?ButtonPage
                loc:Str = '[Page]'
                DO PasteStr
             OF ?ButtonPages
                loc:Str = '[Pages]'
                DO PasteStr
             OF ?ButtonDate
                loc:Str = '[Date]'
                DO PasteStr
             OF ?ButtonTime
                loc:Str = '[Time]'
                DO PasteStr
             OF ?ButtonOK
                DO AddHeaders          !    
                DO IsBordersChanged    !    
                DO IsHeadersChange     !    :   
                SELF.HdrOnFirstPage = loc:HdrOnFirstPage !    
                break
          END
    END
 END

 IF loc:Orientation = 2
    SELF.ReportLandscape = TRUE
 END

 !  
 btn:HeaderType1.Kill()
 btn:HeaderType2.Kill()
 btn:HeaderLocation.Kill()
 btn:Font.Kill()
 btn:Time.Kill()
 btn:Date.Kill()
 btn:Page.Kill()
 btn:Pages.Kill()

 DO DisposeSavedHeaders

 return loc:RetValue
! **************************************************************************************************
IsBordersChanged ROUTINE
 if records(SELF.Headers)
    if loc:HeaderBorder <> SELF.HeaderBorder or loc:FooterBorder <> SELF.FooterBorder
       loc:RetValue = TRUE
    end
 end
 SELF.HeaderBorder = loc:HeaderBorder
 SELF.FooterBorder = loc:FooterBorder
! **************************************************************************************************
InitHeaders ROUTINE   !   TEXT-       
 loop k# = 1 to records(SELF.Headers)
    get(SELF.Headers,k#)
    case SELF.Headers.H.Type
       of 1
          case SELF.Headers.H.Location
             of 1
                loc:PHL = SELF.Headers.H.Content
                loc:PHL:LeftOffset = SELF.Headers.H.LeftOffset
                loc:PHL:RightOffset = SELF.Headers.H.RightOffset
                SETFONT(?loc:PHL,SELF.Headers.H.Fontface,SELF.Headers.H.FontSize,SELF.Headers.H.FontColor,SELF.Headers.H.FontStyle)
             of 2
                loc:PHC = SELF.Headers.H.Content
                loc:PHC:LeftOffset = SELF.Headers.H.LeftOffset
                loc:PHC:RightOffset = SELF.Headers.H.RightOffset
                SETFONT(?loc:PHC,SELF.Headers.H.Fontface,SELF.Headers.H.FontSize,SELF.Headers.H.FontColor,SELF.Headers.H.FontStyle)
             of 3
                loc:PHR = SELF.Headers.H.Content
                loc:PHR:LeftOffset = SELF.Headers.H.LeftOffset
                loc:PHR:RightOffset = SELF.Headers.H.RightOffset
                SETFONT(?loc:PHR,SELF.Headers.H.Fontface,SELF.Headers.H.FontSize,SELF.Headers.H.FontColor,SELF.Headers.H.FontStyle)
          end
       of 2
          case SELF.Headers.H.Location
             of 1
                loc:PFL = SELF.Headers.H.Content
                loc:PFL:LeftOffset = SELF.Headers.H.LeftOffset
                loc:PFL:RightOffset = SELF.Headers.H.RightOffset
                SETFONT(?loc:PFL,SELF.Headers.H.Fontface,SELF.Headers.H.FontSize,SELF.Headers.H.FontColor,SELF.Headers.H.FontStyle)
             of 2
                loc:PFC = SELF.Headers.H.Content
                loc:PFC:LeftOffset = SELF.Headers.H.LeftOffset
                loc:PFC:RightOffset = SELF.Headers.H.RightOffset
                SETFONT(?loc:PFC,SELF.Headers.H.Fontface,SELF.Headers.H.FontSize,SELF.Headers.H.FontColor,SELF.Headers.H.FontStyle)
             of 3
                loc:PFR = SELF.Headers.H.Content
                loc:PFR:LeftOffset = SELF.Headers.H.LeftOffset
                loc:PFR:RightOffset = SELF.Headers.H.RightOffset
                SETFONT(?loc:PFR,SELF.Headers.H.Fontface,SELF.Headers.H.FontSize,SELF.Headers.H.FontColor,SELF.Headers.H.FontStyle)
          end
    end
 end
! **************************************************************************************************
IsHeadersChange ROUTINE  !   :  ( )  
  if records(loc:H) <> records(SELF.Headers)
     loc:RetValue = TRUE
     EXIT
  end

  if loc:HdrOnFirstPage <> SELF.HdrOnFirstPage
     loc:RetValue = TRUE
     EXIT
  end

  loop j# = 1 to records(loc:H)
     get(loc:H,j#)
     FlagFind# = FALSE
     loop k# = 1 to records(SELF.Headers)
        get(SELF.Headers,k#)
        if SELF.Headers.H.Type = loc:H.H.Type and SELF.Headers.H.Location = loc:H.H.Location
           FlagFind# = TRUE
           break
        end
     end
     if NOT FlagFind#
        loc:RetValue = TRUE
        break
     else
        if NOT loc:H.H.IsObjectsEqual(address(SELF.Headers.H))
           loc:RetValue = TRUE
           break
        end
     end
  end
! **************************************************************************************************
AddHeaders ROUTINE     !         
 SELF.RemoveHeaders()  !    
 if len(clip(loc:PHL)) !   ,  
    SELF.AddHeader(1,1,?loc:PHL{Prop:FontName},?loc:PHL{Prop:FontSize},?loc:PHL{Prop:FontColor},?loc:PHL{Prop:FontStyle},clip(loc:PHL),loc:PHL:LeftOffset,loc:PHL:RightOffset)
 end
 if len(clip(loc:PHC))
    SELF.AddHeader(1,2,?loc:PHC{Prop:FontName},?loc:PHC{Prop:FontSize},?loc:PHC{Prop:FontColor},?loc:PHC{Prop:FontStyle},clip(loc:PHC),loc:PHC:LeftOffset,loc:PHC:RightOffset)
 end
 if len(clip(loc:PHR))
    SELF.AddHeader(1,3,?loc:PHR{Prop:FontName},?loc:PHR{Prop:FontSize},?loc:PHR{Prop:FontColor},?loc:PHR{Prop:FontStyle},clip(loc:PHR),loc:PHR:LeftOffset,loc:PHR:RightOffset)
 end

 if len(clip(loc:PFL))
    SELF.AddHeader(2,1,?loc:PFL{Prop:FontName},?loc:PFL{Prop:FontSize},?loc:PFL{Prop:FontColor},?loc:PFL{Prop:FontStyle},clip(loc:PFL),loc:PFL:LeftOffset,loc:PFL:RightOffset)
 end
 if len(clip(loc:PFC))
    SELF.AddHeader(2,2,?loc:PFC{Prop:FontName},?loc:PFC{Prop:FontSize},?loc:PFC{Prop:FontColor},?loc:PFC{Prop:FontStyle},clip(loc:PFC),loc:PFC:LeftOffset,loc:PFC:RightOffset)
 end
 if len(clip(loc:PFR))
    SELF.AddHeader(2,3,?loc:PFR{Prop:FontName},?loc:PFR{Prop:FontSize},?loc:PFR{Prop:FontColor},?loc:PFR{Prop:FontStyle},clip(loc:PFR),loc:PFR:LeftOffset,loc:PFR:RightOffset)
 end
! **************************************************************************************************
SetTabFont ROUTINE      !      
 case loc:HeaderType
    of 1 ! header
       case loc:Location
          of 1
             SETFONT(?loc:PHL,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 2
             SETFONT(?loc:PHC,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 3
             SETFONT(?loc:PHR,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
       end
    of 2 ! footer
       case loc:Location
          of 1
             SETFONT(?loc:PFL,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 2
             SETFONT(?loc:PFC,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 3
             SETFONT(?loc:PFR,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
       end
 end
 display()
! **************************************************************************************************
GetTabFont ROUTINE      !      
 case loc:HeaderType
    of 1 ! header
       case loc:Location
          of 1
             GETFONT(?loc:PHL,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 2
             GETFONT(?loc:PHC,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 3
             GETFONT(?loc:PHR,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
       end
    of 2 ! footer
       case loc:Location
          of 1
             GETFONT(?loc:PFL,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 2
             GETFONT(?loc:PFC,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
          of 3
             GETFONT(?loc:PFR,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
       end
 end
! **************************************************************************************************
PasteStr ROUTINE !  ""   
 case loc:HeaderType
    of 1 ! header
       case loc:Location
          of 1
             PasteStrClass.Run(loc:PHL,loc:Str,?loc:PHL)
          of 2
             PasteStrClass.Run(loc:PHC,loc:Str,?loc:PHC)
          of 3
             PasteStrClass.Run(loc:PHR,loc:Str,?loc:PHR)
       end
    of 2 ! footer
       case loc:Location
          of 1
             PasteStrClass.Run(loc:PFL,loc:Str,?loc:PFL)
          of 2
             PasteStrClass.Run(loc:PFC,loc:Str,?loc:PFC)
          of 3
             PasteStrClass.Run(loc:PFR,loc:Str,?loc:PFR)
       end
 end
 display()
! **************************************************************************************************
SelectTab ROUTINE  !   
 case loc:HeaderType
    of 1 ! header
       case loc:Location
          of 1
             select(?Tab3)
          of 2
             select(?Tab4)
          of 3
             select(?Tab5)
       end
    of 2 ! footer
       case loc:Location
          of 1
             select(?Tab6)
          of 2
             select(?Tab7)
          of 3
             select(?Tab8)
       end
 end
! **************************************************************************************************
SavePreviousHeaders ROUTINE           !  
 free(loc:H)                          !    -
 loop j# = 1 to records(SELF.Headers) !    
    get(SELF.Headers,j#)
    loc:H.H &= SELF.Headers.H.Clone() !    
    add(loc:H)                        !      
 end
! **************************************************************************************************
DisposeSavedHeaders ROUTINE          !    
 loop j# = 1 to records(loc:H)
    get(loc:H,j#)
    if NOT loc:H.H &= NULL
       dispose(loc:H.H)
    end
 end
 free(loc:H)
! **************************************************************************************************
btn:HeaderLocation.TakeAccepted PROCEDURE(LONG Xpos,LONG Ypos)
P           PopupClass
 code
 P.Init()
 P.AddItem(SELF.Translator.TranslateString('left'),'left')
 P.AddItem(SELF.Translator.TranslateString('center'),'center')
 P.AddItem(SELF.Translator.TranslateString('right'),'right')
 case loc:Location
    of 1 ! 
       P.SetItemCheck('left',TRUE)
    of 2 !  
       P.SetItemCheck('center',TRUE)
    of 3 ! 
       P.SetItemCheck('right',TRUE)
 end

 case P.Ask(Xpos,Ypos)
    of 'left'
       loc:Location = 1
       CFCPageSetup $ ?ButtonLocation{Prop:Icon} = 'CFCAlignLeft.ico'
    of 'center'
       loc:Location = 2
       CFCPageSetup $ ?ButtonLocation{Prop:Icon} = 'CFCAlignCenter.ico'
    of 'right'
       loc:Location = 3
       CFCPageSetup $ ?ButtonLocation{Prop:Icon} = 'CFCAlignRight.ico'
 end
 P.Kill()
 SELF.IconName = CFCPageSetup $ ?ButtonLocation{Prop:Icon}
 do SelectTab
! **************************************************************************************************
btn:HeaderType1.TakeAccepted             PROCEDURE()
 code
 DO SelectTab

btn:HeaderType2.TakeAccepted             PROCEDURE()
 code
 DO SelectTab
! **************************************************************************************************
btn:Font.TakeAccepted    PROCEDURE()
 code
 do GetTabFont
 if FONTDIALOG(,loc:Typeface,loc:FontSize,loc:FontColor,loc:FontStyle)
    DO SetTabFont
 end

! **************************************************************************************************
PasteStrClass.Run PROCEDURE(*STRING inData,STRING inPaste,LONG inFEQ)
loc:StartPos   LONG
loc:EndPos     LONG
 code
 loc:StartPos = inFEQ{Prop:SelStart}
 loc:EndPos = inFEQ{Prop:SelEnd}
 if loc:EndPos<>0
    inData = sub(inData,1,loc:StartPos-1) & clip(inPaste) & sub(inData,loc:EndPos+1, len(clip(inData)))
 else
    inData = sub(inData,1,loc:StartPos-1) & clip(inPaste) & sub(inData,loc:StartPos, len(clip(inData)))
 end
 display(inFEQ)
 select(inFEQ,loc:StartPos + len(clip(inPaste)))
CFCPreviewReport.AddHeader  PROCEDURE(BYTE inType,BYTE Location, STRING Fontface,LONG FontSize,LONG FontColor,LONG FontStyle,STRING Content,<LONG LeftOffset>,<LONG RightOffset>)
 code
 SELF.Headers.H &= NEW CFCHeader
 SELF.Headers.H.Type = inType
 SELF.Headers.H.Location = Location
 SELF.Headers.H.Fontface = Fontface
 SELF.Headers.H.FontSize = FontSize
 SELF.Headers.H.FontColor = FontColor
 SELF.Headers.H.FontStyle = FontStyle
 SELF.Headers.H.Content = Content
 SELF.Headers.H.LeftOffset = LeftOffset
 SELF.Headers.H.RightOffset = RightOffset
 add(SELF.Headers)
CFCPreviewReport.RemoveHeaders  PROCEDURE()
 code
 loop j# = 1 to records(SELF.Headers)
    get(SELF.Headers,j#)
    if NOT SELF.Headers.H &= NULL then dispose(SELF.Headers.H).
 end
 free(SELF.Headers)
CFCPreviewReport.CreateHeader  PROCEDURE()
!  
! :           
!    ,    wmf- (   )
!   

loc:PHL               STRING(1024)
loc:PHC               STRING(1024)
loc:PHR               STRING(1024)
loc:PFL               STRING(1024)
loc:PFC               STRING(1024)
loc:PFR               STRING(1024)

loc:PQ                QUEUE(CFCTQPreview).

Report REPORT,AT(1000,2000,6250,7688),PAPER(PAPER:A4),PRE(RPT),FONT('Arial',10,,FONT:regular,CHARSET:ANSI), |
         PREVIEW(loc:PQ),THOUS
Detail DETAIL,AT(,,,135),USE(?Detail)
         TEXT,AT(4740,0,1458,156),USE(loc:PHR),TRN,RIGHT
         TEXT,AT(2396,0,1458,156),USE(loc:PHC),TRN,CENTER,RESIZE
         TEXT,AT(52,0,1458,156),USE(loc:PHL),TRN,LEFT,RESIZE
       END
       FOOTER,AT(1000,9000,6250,156),USE(?Footer)
         TEXT,AT(2396,0,1458,156),USE(loc:PFC),TRN,CENTER,RESIZE
         TEXT,AT(4740,0,1458,156),USE(loc:PFR),TRN,RIGHT,RESIZE
         TEXT,AT(52,0,1458,156),USE(loc:PFL),TRN,LEFT,RESIZE
       END
     END
 code
 !     ,   wmf-,    
 !   
 loop j# = 1 to records(SELF.HdrPreviewQueue)
    get(SELF.HdrPreviewQueue,j#)
    remove(clip(SELF.HdrPreviewQueue.WMF_Image_Path))
 end
 free(SELF.HdrPreviewQueue)  

 open(Report)
 !      ,    
 SELF.Papers.Paper = SELF.ReportPaper      !          
 get(SELF.Papers,SELF.Papers.Paper)        !    ( )

 if SELF.ReportPaper = PAPER:User          !     ,    
    case SELF.ReportUnits                  !     
       of CFC:Thous
          SELF.Papers.Height = SELF.Inch2MM(SELF.Papers.Height)/1000
       of CFC:MM
          SELF.Papers.Height = SELF.ReportPaperH
       of CFC:Points
          SELF.Papers.Height = SELF.Inch2MM(SELF.Papers.Height/72)
    end
    if NOT SELF.ReportLandscape
       Report{PropPrint:PaperWidth} = SELF.ReportPaperW
       Report{PropPrint:PaperHeight} = SELF.ReportPaperH
    else
       Report{PropPrint:PaperWidth} = SELF.ReportPaperH
       Report{PropPrint:PaperHeight} = SELF.ReportPaperW
    end
 end

 case SELF.PreviewUnits                    !      
    of CFC:Thous
       Report{Prop:Thous} = TRUE
       PapersHeight# = SELF.MM2Inch(SELF.Papers.Height)
    of CFC:MM
       Report{Prop:MM} = TRUE
       PapersHeight# = SELF.Papers.Height
    of CFC:Points
       Report{Prop:Points} = TRUE
       PapersHeight# = SELF.MM2Inch(SELF.Papers.Height)*72/1000
 end

 !   
 Report{Prop:Xpos} = SELF.ReportXpos
 Report{Prop:Ypos} = SELF.HeaderBorder
 Report{Prop:Width} = SELF.ReportWidth
 Report{Prop:Height} = PapersHeight# - SELF.HeaderBorder
 Report{Prop:Landscape} = SELF.ReportLandscape
 Report{PropPrint:Paper} = SELF.ReportPaper
 Report $ ?Detail{Prop:Width} = SELF.ReportWidth
 Report $ ?Detail{Prop:Height} = PapersHeight# - SELF.HeaderBorder - SELF.FooterBorder

 Report $ ?Footer{Prop:Xpos} = SELF.ReportXpos
 Report $ ?Footer{Prop:Ypos} = PapersHeight# - SELF.HeaderBorder - SELF.FooterBorder
 Report $ ?Footer{Prop:Width} = SELF.ReportWidth
 Report $ ?Footer{Prop:Height} = SELF.FooterBorder

 !   - :  
 Report $ ?loc:PHL{Prop:Xpos} = 0
 Report $ ?loc:PHL{Prop:Ypos} = 0
 Report $ ?loc:PHL{Prop:Width} = SELF.ReportWidth

 Report $ ?loc:PHC{Prop:Xpos} = Report $ ?loc:PHL{Prop:Xpos}
 Report $ ?loc:PHC{Prop:Ypos} = Report $ ?loc:PHL{Prop:Ypos}
 Report $ ?loc:PHC{Prop:Width} = Report $ ?loc:PHL{Prop:Width}

 Report $ ?loc:PHR{Prop:Xpos} = Report $ ?loc:PHL{Prop:Xpos}
 Report $ ?loc:PHR{Prop:Ypos} = Report $ ?loc:PHL{Prop:Ypos}
 Report $ ?loc:PHR{Prop:Width} = Report $ ?loc:PHL{Prop:Width}

 !   - :  
 Report $ ?loc:PFL{Prop:Xpos} = 0
 Report $ ?loc:PFL{Prop:Ypos} = 0
 Report $ ?loc:PFL{Prop:Width} = SELF.ReportWidth

 Report $ ?loc:PFC{Prop:Xpos} = Report $ ?loc:PFL{Prop:Xpos}
 Report $ ?loc:PFC{Prop:Ypos} = Report $ ?loc:PFL{Prop:Ypos}
 Report $ ?loc:PFC{Prop:Width} = Report $ ?loc:PFL{Prop:Width}

 Report $ ?loc:PFR{Prop:Xpos} = Report $ ?loc:PFL{Prop:Xpos}
 Report $ ?loc:PFR{Prop:Ypos} = Report $ ?loc:PFL{Prop:Ypos}
 Report $ ?loc:PFR{Prop:Width} = Report $ ?loc:PFL{Prop:Width}

 !    
 loop j# = 1 to records(SELF.Headers)
    get(SELF.Headers,j#)
    case SELF.Headers.H.Type
       of 1
          case SELF.Headers.H.Location
             of 1
                loc:PHL = SELF.ParseHeader(SELF.Headers.H.Content)
                Report $ ?loc:PHL{Prop:Xpos} = Report $ ?loc:PHL{Prop:Xpos} + SELF.Headers.H.LeftOffset
                Report $ ?loc:PHL{Prop:Width} = Report $ ?loc:PHL{Prop:Width} - SELF.Headers.H.RightOffset - SELF.Headers.H.LeftOffset
                Report $ ?loc:PHL {Prop:FontName} = SELF.Headers.H.Fontface
                Report $ ?loc:PHL {Prop:FontSize} = SELF.Headers.H.FontSize
                Report $ ?loc:PHL {Prop:FontColor} = SELF.Headers.H.FontColor
                Report $ ?loc:PHL {Prop:FontStyle} = SELF.Headers.H.FontStyle
             of 2
                loc:PHC = SELF.ParseHeader(SELF.Headers.H.Content)
                Report $ ?loc:PHC{Prop:Xpos} = Report $ ?loc:PHC{Prop:Xpos} + SELF.Headers.H.LeftOffset
                Report $ ?loc:PHC{Prop:Width} = Report $ ?loc:PHC{Prop:Width} - SELF.Headers.H.RightOffset - SELF.Headers.H.LeftOffset
                Report $ ?loc:PHC {Prop:FontName} = SELF.Headers.H.Fontface
                Report $ ?loc:PHC {Prop:FontSize} = SELF.Headers.H.FontSize
                Report $ ?loc:PHC {Prop:FontColor} = SELF.Headers.H.FontColor
                Report $ ?loc:PHC {Prop:FontStyle} = SELF.Headers.H.FontStyle
             of 3
                loc:PHR = SELF.ParseHeader(SELF.Headers.H.Content)
                Report $ ?loc:PHR{Prop:Xpos} = Report $ ?loc:PHR{Prop:Xpos} + SELF.Headers.H.LeftOffset
                Report $ ?loc:PHR{Prop:Width} = Report $ ?loc:PHR{Prop:Width} - SELF.Headers.H.RightOffset - SELF.Headers.H.LeftOffset
                Report $ ?loc:PHR {Prop:FontName} = SELF.Headers.H.Fontface
                Report $ ?loc:PHR {Prop:FontSize} = SELF.Headers.H.FontSize
                Report $ ?loc:PHR {Prop:FontColor} = SELF.Headers.H.FontColor
                Report $ ?loc:PHR {Prop:FontStyle} = SELF.Headers.H.FontStyle
          end
       of 2
          case SELF.Headers.H.Location
             of 1
                loc:PFL = SELF.ParseHeader(SELF.Headers.H.Content)
                Report $ ?loc:PFL{Prop:Xpos} = Report $ ?loc:PFL{Prop:Xpos} + SELF.Headers.H.LeftOffset
                Report $ ?loc:PFL{Prop:Width} = Report $ ?loc:PFL{Prop:Width} - SELF.Headers.H.RightOffset - SELF.Headers.H.LeftOffset
                Report $ ?loc:PFL {Prop:FontName} = SELF.Headers.H.Fontface
                Report $ ?loc:PFL {Prop:FontSize} = SELF.Headers.H.FontSize
                Report $ ?loc:PFL {Prop:FontColor} = SELF.Headers.H.FontColor
                Report $ ?loc:PFL {Prop:FontStyle} = SELF.Headers.H.FontStyle
             of 2
                loc:PFC = SELF.ParseHeader(SELF.Headers.H.Content)
                Report $ ?loc:PFC{Prop:Xpos} = Report $ ?loc:PFC{Prop:Xpos} + SELF.Headers.H.LeftOffset
                Report $ ?loc:PFC{Prop:Width} = Report $ ?loc:PFC{Prop:Width} - SELF.Headers.H.RightOffset - SELF.Headers.H.LeftOffset
                Report $ ?loc:PFC {Prop:FontName} = SELF.Headers.H.Fontface
                Report $ ?loc:PFC {Prop:FontSize} = SELF.Headers.H.FontSize
                Report $ ?loc:PFC {Prop:FontColor} = SELF.Headers.H.FontColor
                Report $ ?loc:PFC {Prop:FontStyle} = SELF.Headers.H.FontStyle
             of 3
                loc:PFR = SELF.ParseHeader(SELF.Headers.H.Content)
                Report $ ?loc:PFR{Prop:Xpos} = Report $ ?loc:PFR{Prop:Xpos} + SELF.Headers.H.LeftOffset
                Report $ ?loc:PFR{Prop:Width} = Report $ ?loc:PFR{Prop:Width} - SELF.Headers.H.RightOffset - SELF.Headers.H.LeftOffset
                Report $ ?loc:PFR {Prop:FontName} = SELF.Headers.H.Fontface
                Report $ ?loc:PFR {Prop:FontSize} = SELF.Headers.H.FontSize
                Report $ ?loc:PFR {Prop:FontColor} = SELF.Headers.H.FontColor
                Report $ ?loc:PFR {Prop:FontStyle} = SELF.Headers.H.FontStyle
          end
    end
 end

 SavedPage# = SELF.CurrentPage  !   
 loop j# = 1 to SELF.ImageCount !  ,   ,     
    SELF.CurrentPage = j#
    loop k# = 1 to records(SELF.Headers) !  
       get(SELF.Headers,k#)

       case SELF.Headers.H.Type
          of 1
             case SELF.Headers.H.Location
                of 1
                   loc:PHL = SELF.ParseHeader(SELF.Headers.H.Content)
                of 2
                   loc:PHC = SELF.ParseHeader(SELF.Headers.H.Content)
                of 3
                   loc:PHR = SELF.ParseHeader(SELF.Headers.H.Content)
             end
          of 2
             case SELF.Headers.H.Location
                of 1
                   loc:PFL = SELF.ParseHeader(SELF.Headers.H.Content)
                of 2
                   loc:PFC = SELF.ParseHeader(SELF.Headers.H.Content)
                of 3
                   loc:PFR = SELF.ParseHeader(SELF.Headers.H.Content)
             end
       end
       if NOT SELF.HdrOnFirstPage and j# = 1!     
          loc:PHL = ''
          loc:PHC = ''
          loc:PHR = ''
          loc:PFL = ''
          loc:PFC = ''
          loc:PFR = ''
       end
    end
    print(RPT:Detail) !  
 end
 endpage(Report)
 SELF.CurrentPage = SavedPage#

 !    WMF
 loop k# = 1 to records(loc:PQ)
    get(loc:PQ,k#)
    SELF.HdrPreviewQueue.WMF_Image_Path = sub(clip(loc:PQ.WMF_Image_Path),1,len(clip(loc:PQ.WMF_Image_Path))-4) & '_hdr.wmf'
    copy(clip(loc:PQ.WMF_Image_Path),clip(SELF.HdrPreviewQueue.WMF_Image_Path))
    add(SELF.HdrPreviewQueue)
 end
 close(Report)
CFCPreviewReport.ParseHeader  PROCEDURE(STRING inStr)
!      "" [Date] [Time] [Page] [Pages]
!      
loc:TmpStr    STRING(1024)
loc:MacroStr  STRING(20)
loc:ParseQ    QUEUE
MacroStr         STRING(20)
Pos              LONG
              END
 code
 loc:TmpStr = inStr
 inStr = UPPER(inStr)

 free(loc:ParseQ)
 loc:MacroStr = '[DATE]'
 do FillParseQ
 loc:MacroStr = '[TIME]'
 do FillParseQ
 loc:MacroStr = '[PAGE]'
 do FillParseQ
 loc:MacroStr = '[PAGES]'
 do FillParseQ

 sort(loc:ParseQ, - loc:ParseQ.Pos)

 loop j# = 1 to records(loc:ParseQ)
    get(loc:ParseQ,j#)
    case clip(loc:ParseQ.MacroStr)
       of '[DATE]'
          loc:TmpStr = sub(loc:TmpStr,1,loc:ParseQ.Pos-1) & format(today(),clip(SELF.DatePicture)) & sub(loc:TmpStr,loc:ParseQ.Pos + len('[DATA]'),len(clip(loc:TmpStr)))
       of '[TIME]'
          loc:TmpStr = sub(loc:TmpStr,1,loc:ParseQ.Pos-1) & format(clock(),clip(SELF.TimePicture)) & sub(loc:TmpStr,loc:ParseQ.Pos + len('[TIME]'),len(clip(loc:TmpStr)))
       of '[PAGE]'
          loc:TmpStr = sub(loc:TmpStr,1,loc:ParseQ.Pos-1) & SELF.CurrentPage & sub(loc:TmpStr,loc:ParseQ.Pos + len('[PAGE]'),len(clip(loc:TmpStr)))
       of '[PAGES]'
          loc:TmpStr = sub(loc:TmpStr,1,loc:ParseQ.Pos-1) & SELF.ImageCount & sub(loc:TmpStr,loc:ParseQ.Pos + len('[PAGES]'),len(clip(loc:TmpStr)))
    end
 end

 RETURN loc:TmpStr
! ******************************************************************************************************
!      , ..        
FillParseQ ROUTINE 
 start_pos# = 1
 loop
    pos# = instring(clip(loc:MacroStr),inStr,1,start_pos#)
    if not pos# then break.
    loc:ParseQ.MacroStr = clip(loc:MacroStr)
    loc:ParseQ.Pos = pos#
    add(loc:ParseQ)
    start_pos# = pos# + len(clip(loc:MacroStr))
 end
CFCPreviewReport.PrintReport PROCEDURE(<BYTE toPrinter>,<LONG inStartPage>,<LONG inEndPage>,<BYTE inSinglePage>)
loc:PQ                QUEUE(CFCTQPreview).
loc:StartPage         LONG
loc:EndPage           LONG
loc:Copies            LONG

Report REPORT,AT(0,0),PAPER(PAPER:A4),PRE(RPT),FONT('Arial',10,,FONT:regular,CHARSET:ANSI),PREVIEW(loc:PQ), |
         THOUS
Detail DETAIL,USE(?Detail)
         IMAGE,AT(0,0),USE(?DataImage)
         IMAGE,AT(0,0),USE(?HdrImage)
       END
     END

 code
 !   
 if omitted(3)
    loc:StartPage = 1
 else
    loc:StartPage = inStartPage
 end
 if omitted(4)
    loc:EndPage = SELF.ImageCount
 else
    loc:EndPage = inEndPage
 end
 if omitted(5)
    loc:Copies = SELF.Copies
 else
    if inSinglePage
       loc:Copies = 1
    else
       loc:Copies = SELF.Copies
    end
 end

 open(Report)

 SELF.Papers.Paper = SELF.ReportPaper
 get(SELF.Papers,SELF.Papers.Paper)
 Report{Prop:Landscape} = SELF.ReportLandscape
 Report{PropPrint:Paper} = SELF.ReportPaper

 FREE(SELF.OrigPrnQueue)
 if SELF.Collate !   
    loop loc:Copies times
       loop j# = loc:StartPage to loc:EndPage
          get(SELF.PreviewQueue,j#)
          SELF.OrigPrnQueue :=: SELF.PreviewQueue !     ,   PrnQueue,    
          add(SELF.OrigPrnQueue)                  ! ..   wmf-
          Report $ ?DataImage{Prop:Text} = clip(SELF.PreviewQueue.WMF_Image_Path)
          get(SELF.HdrPreviewQueue,j#)
          if not errorcode()
             Report $ ?HdrImage{Prop:Text} = clip(SELF.HdrPreviewQueue.WMF_Image_Path)
          end
          print(RPT:Detail)
       end
    end
 else
    LOOP j# = loc:StartPage to loc:EndPage
       GET(SELF.PreviewQueue,j#)
       SELF.OrigPrnQueue :=: SELF.PreviewQueue
       ADD(SELF.OrigPrnQueue)
       Report $ ?DataImage{Prop:Text} = CLIP(SELF.PreviewQueue.WMF_Image_Path)
       get(SELF.HdrPreviewQueue,j#)
       if not errorcode()
          Report $ ?HdrImage{Prop:Text} = clip(SELF.HdrPreviewQueue.WMF_Image_Path)
       end
       loop loc:Copies times
          print(RPT:Detail)
       end
    end
 end
 ENDPAGE(Report)

 loop j# = 1 to records(SELF.PrnQueue)
    get(SELF.PrnQueue,j#)
    remove(clip(SELF.PrnQueue.WMF_Image_Path))
 end
 free(SELF.PrnQueue) !    
 loop j# = 1 to records(loc:PQ)
    get(loc:PQ,j#)
    copy(clip(loc:PQ.WMF_Image_Path),sub(clip(loc:PQ.WMF_Image_Path),1,len(clip(loc:PQ.WMF_Image_Path))-4) & '_prn.wmf')
    loc:PQ.WMF_Image_Path = sub(clip(loc:PQ.WMF_Image_Path),1,len(clip(loc:PQ.WMF_Image_Path))-4) & '_prn.wmf'
    put(loc:PQ)
    SELF.PrnQueue.WMF_Image_Path = loc:PQ.WMF_Image_Path
    add(SELF.PrnQueue)
 end

 if not omitted(2)
    if toPrinter !  
       SELF.BeforeFlushPreview()
       Report{Prop:FlushPreview} = TRUE
       SELF.AfterFlushPreview()
    end
 end
 close(Report)

CFCPreviewReport.AddExtension PROCEDURE(STRING inDesc,STRING inExt)
 code
 SELF.Ext.Extension = inExt
 get(SELF.Ext,SELF.Ext.Extension)
 if errorcode()
    SELF.Ext.Extension = inExt
    SELF.Ext.Description = inDesc
    add(SELF.Ext)
 else
    SELF.Ext.Description = inDesc
    put(SELF.Ext)
 end
CFCPreviewReport.SaveAsDialog PROCEDURE()
loc:ReturnValue STRING(260)
loc:Extensions  STRING(1024)
loc:Comctrl     CFCComctrlClass
 code
 loop j# = 1 to records(SELF.Ext)
    get(SELF.Ext,j#)
    if j# = 1
       loc:Extensions = clip(SELF.Ext.Description)&'|'&clip(SELF.Ext.Extension)
    else
       loc:Extensions = clip(loc:Extensions) & '|' &clip(SELF.Ext.Description)&'|'&clip(SELF.Ext.Extension)
    end
 end
 ! FILEDIALOG(,loc:ReturnValue,clip(loc:Extensions),FILE:Save+FILE:KeepDir+FILE:LongName+128) ! +FILE:AddExtension
 IF NOT loc:Comctrl.SaveAsDialogWin32(loc:ReturnValue,,loc:Extensions) ! change to api
    loc:ReturnValue = ''
 END
 return loc:ReturnValue
CFCPreviewReport.SaveToMyDocs           PROCEDURE() ! ,STRING,VIRTUAL                        !      " "
loc:ReturnValue STRING(260)
loc:Entry       STRING(256)

CFCSaveToMyDocsDialog WINDOW('Save to My Documents'),AT(,,259,69),FONT('MS Sans Serif',8,,FONT:regular), |
         CENTER,GRAY,DOUBLE
       STRING('Enter file name'),AT(10,20),USE(?String1)
       ENTRY(@s200),AT(78,19,167,12),USE(loc:Entry),REQ
       BUTTON('Save'),AT(152,50,45,14),USE(?ButtonSave),DEFAULT,REQ
       BUTTON('Cancel'),AT(200,50,45,14),USE(?ButtonCancel),STD(STD:Close)
     END

 CODE
 OPEN(CFCSaveToMyDocsDialog)
 SELF.Translator.TranslateWindow(CFCSaveToMyDocsDialog)       ! 
 IF LEN(CLIP(SELF.CaptionText))
    loc:Entry = SELF.CaptionText
 END

 ACCEPT
    CASE EVENT()
    OF EVENT:Accepted
       CASE FIELD()
       OF ?ButtonSave
          !loc:ReturnValue = CLIP(loc:Comctrl.GetMyDocumentsPath()) & '\' & CLIP(loc:Entry) & '.wmf'
          IF NOT SELF.Comctrl &= NULL
             loc:ReturnValue = CLIP(SELF.Comctrl.GetMyDocumentsPath()) & '\' & CLIP(loc:Entry) & '.wmf'
          END
          BREAK
       END
    END
 END
 CLOSE(CFCSaveToMyDocsDialog)
 RETURN loc:ReturnValue

CFCPreviewReport.SaveAs PROCEDURE(STRING inFileName)
loc:Ext       STRING(10)
 code
 if len(clip(inFileName))
    !  
    loop k# = len(clip(inFileName)) to 1 by -1
       if inFileName[k#] = '.'
          loc:Ext = clip(sub(clip(inFileName),k#+1,len(clip(inFileName))))
          break
       end
    end

    SELF.SaveByExtension(loc:Ext,inFileName)
 end

 
CFCPreviewReport.SaveByExtension PROCEDURE(STRING inExt,STRING inFileName)
 code
 CASE UPPER(inExt)
    OF 'WMF'
       SELF.SaveToWmf(inFileName)
 END
CFCPreviewReport.SaveToWMF PROCEDURE(STRING inFirstFileName)
loc:FileName      STRING(260)
 code
 !    - 
 pow# = 2
 TmpNum# = SELF.ImageCount
 loop
    if int(TmpNum#/10) < 10 then break.
    pow# +=1
    TmpNum# = TmpNum#/10
 end

 records# = records(SELF.PrnQueue)
 loop j# = 1 to records#
    get(SELF.PrnQueue,j#)
    if  records# = 1
       copy(clip(SELF.PrnQueue.WMF_Image_Path),clip(inFirstFileName))
    else
       copy(clip(SELF.PrnQueue.WMF_Image_Path),sub(clip(inFirstFileName),1,len(clip(inFirstFileName))-4) &'_'&format(j#,'@n0'&pow#)& '.wmf')
    end
 end
 
 message(self.Translator.TranslateString('Report succesfully saved!'),self.Translator.TranslateString('Save report'),ICON:Asterisk)
! ********************************************************************************************
CFCPreviewReport.OpenWindow  PROCEDURE(WINDOW W)
 code
 
CFCPreviewReport.CloseWindow    PROCEDURE()
 code
 
CFCPreviewReport.OpenPrintSetupWindow   PROCEDURE(WINDOW W)
 code

CFCPreviewReport.OpenPageSetupWindow   PROCEDURE(WINDOW W)
 code
CFCPreviewReport.OpenSearchWindow   PROCEDURE(WINDOW W)
 code
CFCPreviewReport.Init  PROCEDURE()
 code
 
CFCPreviewReport.TakeEvent PROCEDURE()
 code
CFCPreviewReport.ContextMenu PROCEDURE()
P  PopupClass
 code
 P.Init()
 P.SetTranslator(SELF.Translator)

 P.AddItem('Previous page','p_page')
 P.AddItem('Next page','n_page')
 P.AddItem('-','sep1')
 P.AddItem('Zoom in','z_in')
 P.AddItem('Zoom out','z_out')
 P.AddItem('-','sep11')
 P.AddItem('Fit page','fit_page')
 P.AddItem('Fit width','fit_width')
 P.AddItem('Fit height','fit_height')
 P.AddItem('-','sep2')
 P.AddItem('Print','print')
 P.AddItem('Print current page','print_current')
 P.AddItem('-','sep3')
 P.AddItem('Save','save')
 P.AddItem('Save current page','save_current')
 P.AddItem('-','sep4')
 if SELF.FS.FlagFullScreen
    P.AddItem('Exit fullscreen','Fullscreen')
 else
    P.AddItem('Fullscreen','Fullscreen')
 end

 ! 
 if SELF.UseIconsOnContextMenu
    P.SetIcon('p_page','~CFCBack.ico')
    P.SetIcon('n_page','~CFCForward.ico')
    P.SetIcon('z_in','~CFCZoomIn.ico')
    P.SetIcon('z_out','~CFCZoomOut.ico')
    P.SetIcon('print','~CFCprint.ico')
    P.SetIcon('print_current','~CFCprint1.ico')
    P.SetIcon('save','~CFCSave.ico')
    P.SetIcon('save_current','~CFCSave.ico')
    P.SetIcon('Fullscreen','~CFCFullScreen.ico')
 end

 if SELF.CurrentPage = 1
    P.SetItemEnable('p_page',FALSE)
 end
 if SELF.CurrentPage = SELF.ImageCount
    P.SetItemEnable('n_page',FALSE)
 end

 CASE P.Ask()
    OF 'p_page'
       POST(Event:Accepted,SELF.TBR:Back)
    OF  'n_page'
       POST(Event:Accepted,SELF.TBR:Forward)
    OF  'z_in'
       POST(Event:Accepted,SELF.TBR:ZoomIn)
    OF  'z_out'
       POST(Event:Accepted,SELF.TBR:ZoomOut)
    OF  'fit_page'
       POST(Event:Accepted,SELF.MNU:FitPage)
    OF  'fit_width'
       POST(Event:Accepted,SELF.MNU:FitWidth)
    OF  'fit_height'
       POST(Event:Accepted,SELF.MNU:FitHeight)
    OF  'print'
       POST(Event:Accepted,SELF.TBR:Print)
    OF  'print_current'
       POST(Event:Accepted,SELF.TBR:PrintCurrent)
    OF  'save'
       POST(Event:Accepted,SELF.TBR:Save)
    OF  'save_current'
       POST(Event:Accepted,SELF.MNU:SaveCurrentPage)
    OF  'Fullscreen'
       POST(Event:Accepted,SELF.TBR:FS)
 END
 P.Kill()
CFCPreviewReport.Run   PROCEDURE(<BYTE FlagSameThread>)
 code
 if FlagSameThread = 0 !    
    SELF.T = start(CFCReportPreview,25000,address(SELF))
 elsif FlagSameThread = 1 !     
    CFCReportPreview(address(SELF))
 end
CFCPreviewReport.BeforeFlushPreview     PROCEDURE()
 code

CFCPreviewReport.AfterFlushPreview      PROCEDURE()
 code
! **********************************************************************************************
CFCReportPreview PROCEDURE(STRING inAddr)
ref                   &CFCPreviewReport

DummyWindow WINDOW('Dummy window'),AT(,,224,64),FONT('MS Sans Serif',8,,FONT:regular),GRAY
     END

 code
 open(DummyWindow)
 DummyWindow{Prop:Hide} = TRUE

 ref &= (inAddr)

 CFC_sleep(200)                    !  ,      ,
                                   !      

 if records(ref.PreviewQueue)      !    
    ref.Show()                     !   
 end

 dispose(ref)
! **********************************************************************************************
CFCHeader.Clone  PROCEDURE()
ref          &CFCHeader
 code
 ref &= NEW CFCHeader
 ref.Type = SELF.Type
 ref.Location = SELF.Location
 ref.Fontface = SELF.Fontface
 ref.FontSize = SELF.FontSize
 ref.FontColor = SELF.FontColor
 ref.FontStyle = SELF.FontStyle
 ref.Content = SELF.Content
 ref.LeftOffset = SELF.LeftOffset
 ref.RightOffset = SELF.RightOffset

 return address(ref)


CFCHeader.IsObjectsEqual PROCEDURE(LONG inRef)
ref           &CFCHeader
loc:RetValue  BYTE
 code
 ref &= (inRef)
 if ref.Fontface = SELF.Fontface and |
    ref.FontSize = SELF.FontSize and |
    ref.FontColor = SELF.FontColor and |
    ref.FontStyle = SELF.FontStyle and |
    ref.Content = SELF.Content and |
    ref.LeftOffset = SELF.LeftOffset and |
    ref.RightOffset = SELF.RightOffset

    loc:RetValue = TRUE
 end

 RETURN loc:RetValue



