!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCQLocator.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
 END
 INCLUDE('CFCQLocator.inc'),ONCE
CFCQueueLocatorClass.Construct PROCEDURE
 CODE
 SELF.TimerID = 129
 SELF.ClearTime = 200
CFCQueueLocatorClass.Kill PROCEDURE
 code
 SELF.RemoveCallBack()                                                    ! remove the subclassing
 CFC_KillTimer(SELF.ListBoxFeq{Prop:Handle},SELF.TimerID)                 ! kill the timer
 IF NOT SELF.QueueField &= NULL THEN SELF.QueueField &= NULL.             ! free the ANY variables
 IF NOT SELF.LocatorVariable &= NULL THEN SELF.LocatorVariable &= NULL.
! ************************************************************************************************
CFCQueueLocatorClass.Init PROCEDURE(*QUEUE inLocatorQueue,LONG inListBoxFeq,<*ANY inLocatorVariable>,<LONG inLocatorFeq>)
 CODE
 SELF.LocatorQueue &= inLocatorQueue
 SELF.ListBoxFeq = inListBoxFeq

 IF NOT OMITTED(4)
    SELF.LocatorVariable &= inLocatorVariable
 END

 IF NOT OMITTED(5)
    SELF.LocatorFeq = inLocatorFeq
    REGISTEREVENT(EVENT:Accepted,ADDRESS(SELF.TakeAccepted),ADDRESS(SELF),,SELF.LocatorFeq)
 END
 
 Err# = CFC_SetTimer(SELF.ListBoxFeq{Prop:Handle},SELF.TimerID,100,0) ! set the timer
 SELF.SetCallBack(SELF.ListBoxFeq{Prop:Handle},SELF.ListBoxFeq)       ! set the subclassing
! ************************************************************************************************
CFCQueueLocatorClass.SetActiveLocator PROCEDURE(*ANY inQueueField)
loc:Picture  STRING(32)
loc:ColumnNo LONG
 code
 SELF.FlagUseLocator = TRUE
 SELF.QueueField &= inQueueField

 IF SELF.LocatorFeq                                      ! if we have the control for the locator
    LOOP j# = 1 TO SELF.ListBoxFeq{PROPLIST:Exists,0}    ! find the column with locator
       IF SELF.ListBoxFeq{PROPLIST:FieldNo,j#} = WHERE(SELF.LocatorQueue,SELF.QueueField)
          loc:ColumnNo = j#
          BREAK
       END
    END
    IF loc:ColumnNo
       loc:Picture = SELF.ListBoxFeq{PROPLIST:Picture,loc:ColumnNo}
       IF LEN(CLIP(loc:Picture))
          SELF.LocatorFeq{Prop:Text} = CLIP(loc:Picture) ! make the control picture like the column picture
       END
    END
 END
! ************************************************************************************************
CFCQueueLocatorClass.RemoveLocator         PROCEDURE
 CODE
 SELF.FlagUseLocator = FALSE
 SELF.ClearLocator()
! ************************************************************************************************
CFCQueueLocatorClass.ClearLocator PROCEDURE
 CODE
 SELF.cstrLocatorVariable = ''
 IF NOT SELF.LocatorVariable &= NULL
    SELF.LocatorVariable = SELF.cstrLocatorVariable
    DISPLAY()
 END
! ************************************************************************************************
CFCQueueLocatorClass.TakeAccepted PROCEDURE
 CODE
 IF NOT SELF.LocatorVariable &= NULL
    SELF.cstrLocatorVariable = CLIP(SELF.LocatorVariable)
    SELF.NewSelection()
 END
! ************************************************************************************************
CFCQueueLocatorClass.NewSelection PROCEDURE
cstrTempVar CSTRING(1024)
 CODE
 FlagFind# = FALSE
 LOOP counter# = 1 TO RECORDS(SELF.LocatorQueue)
    GET(SELF.LocatorQueue,counter#)
    YIELD
    cstrTempVar = SELF.QueueField
    IF UPPER(SUB(cstrTempVar,1,LEN(SELF.cstrLocatorVariable))) = UPPER(SUB(SELF.cstrLocatorVariable,1,LEN(SELF.cstrLocatorVariable)))
       FlagFind# = TRUE
       BREAK
    END
 END
 IF FlagFind# = TRUE
    SELECT(SELF.ListBoxFeq,counter#)
    POST(Event:NewSelection,SELF.ListBoxFeq)
 END
! ************************************************************************************************
CFCQueueLocatorClass.SetClearTime                        PROCEDURE(LONG inTime)
 CODE
 SELF.ClearTime = inTime
CFCQueueLocatorClass.CallBackProc                        PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:WM_CHAR             EQUATE(0102h)
loc:WM_KEYUP            EQUATE(0101h)
loc:WM_LBUTTONUP        EQUATE(0202h)
loc:WM_RBUTTONUP        EQUATE(0205h)
loc:WM_TIMER            EQUATE(0113h)
locRetAddr              LONG
 CODE
 IF SELF.FlagUseLocator = TRUE
    IF inMsg = loc:WM_CHAR
       locRetAddr = PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
       IF wParam = 8 ! BackspaceKey
          SELF.cstrLocatorVariable = SUB(SELF.cstrLocatorVariable,1,LEN(SELF.cstrLocatorVariable)-1)
       ELSE
          SELF.cstrLocatorVariable = SELF.cstrLocatorVariable & CHR(wParam)
       END
       IF NOT SELF.LocatorVariable &= NULL
          SELF.LocatorVariable = SELF.cstrLocatorVariable
          DISPLAY()
       END
       SELF.LastLetterTime = CLOCK() ! save the time when we pressed the key
       SELF.NewSelection()
       RETURN locRetAddr
    END
    IF inMsg = loc:WM_KEYUP ! clear the locator when we leave it
       CASE wParam
       OF DownKey OROF UpKey OROF HomeKey OROF PgDnKey OROF PgUpKey OROF EndKey OROF EnterKey OROF CtrlEnter |
          OROF CtrlHome OROF CtrlEnd OROF CtrlPgDn OROF CtrlPgUp
          SELF.ClearLocator() 
       END
    END
    IF inMsg = loc:WM_LBUTTONUP OR inMsg = loc:WM_RBUTTONUP  ! clear the locator by mouse click
       SELF.ClearLocator()
    END
    IF inMsg = loc:WM_TIMER AND wParam = SELF.TimerID
       IF CLOCK() - SELF.LastLetterTime >= SELF.ClearTime AND LEN(SELF.cstrLocatorVariable)
          SELF.ClearLocator()
       END
    END
 END

 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
! ************************************************************************************************


