!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCToolbar.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 INCLUDE('CFCToolbar.inc'),ONCE
!**************************************************************************************************************
CFCToolbar.Construct            PROCEDURE
 CODE
 SELF.tbrIpool &= NEW CFC_ToolbarImagePoolQ
 SELF.tbrB &= NEW CFC_ToolbarButtonsQ
 SELF.TT &= NEW CFCTooltipsClass
 SELF.tbrImageHeight = 16
 SELF.tbrImageWidth = 16
 

CFCToolbar.Destruct             PROCEDURE
 CODE
 ! free the bmp handles
 IF NOT SELF.tbrIpool &= NULL
    LOOP j# = 1 TO RECORDS(SELF.tbrIpool)
       GET(SELF.tbrIpool,j#)
       IF SELF.tbrIpool.hBitmap
          Err# = CFC_DeleteObject(SELF.tbrIpool.hBitmap)
       END
    END
 END

 IF NOT SELF.tbrIpool &= NULL THEN DISPOSE(SELF.tbrIpool).
 IF NOT SELF.tbrB &= NULL THEN DISPOSE(SELF.tbrB).
 SELF.TT.Kill()
 IF NOT SELF.TT &= NULL THEN DISPOSE(SELF.TT).
 IF NOT SELF.InitStateBuffer &= NULL THEN DISPOSE(SELF.InitStateBuffer).
 IF NOT SELF.RestoredStateBuffer &= NULL THEN DISPOSE(SELF.RestoredStateBuffer).
 


 
CFCToolbar.SetCommandCnt        PROCEDURE(*CFCCommandCnt inCnt)
 CODE
 SELF.Cnt &= inCnt
 SELF.TT.SetCommandCnt(inCnt)

CFCToolbar.CreateToolbar        PROCEDURE(ULONG inParentHWND,<LONG inStyle>,<LONG inTooltipStyle>)
cstrToolbarClassName CSTRING('ToolbarWindow32')
loc:TbrStyle         LONG
loc:TTStyle          LONG
 CODE
 loc:TbrStyle = 0
 loc:TTStyle = CFC_STD_TOOLTIP
 IF NOT OMITTED(3)
    loc:TbrStyle = inStyle
 END
 IF NOT OMITTED(4)
    loc:TTStyle = inTooltipStyle
 END

 SELF.ParentHWND = inParentHWND
 SELF.hWndTB = CFC_CreateWindowEx(CFC_WS_EX_TOOLWINDOW, | !
                                  ADDRESS(cstrToolbarClassName), |
                                  0, |
                                  CFC_WS_CHILD + CFC_WS_VISIBLE + CFC_WS_CLIPSIBLINGS + CFC_WS_CLIPCHILDREN + |
                                  CFC_CCS_ADJUSTABLE + |
                                  loc:TbrStyle, | !
                                  0,0,0,0, |
                                  SELF.ParentHWND, |
                                  0, |
                                  SYSTEM{Prop:AppInstance}, |
                                  0)

 IF SELF.hWndTB
    Err# = CFC_SendMessage(SELF.hwndTB, CFC_TB_BUTTONSTRUCTSIZE, SIZE(CFC_TBBUTTON), 0)
    Err# = CFC_SendMessage(SELF.hwndTB, CFC_TB_SETEXTENDEDSTYLE, 0, CFC_TBSTYLE_EX_DRAWDDARROWS)! CFC_TBSTYLE_EX_HIDECLIPPEDBUTTONS
  END

 IF SELF.hWndTB
    SELF.TT.Init(SELF.hWndTB)
    SELF.TT.CreateTooltip(loc:TTStyle)
 END

 RETURN SELF.hWndTB
CFCToolbar.AddIconToImagePool        PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>)
GDI                  CFCGDIClass
loc:hIcon            ULONG
loc:hBitmap          ULONG
loc:CFC_TBADDBITMAP  LIKE(CFC_TBADDBITMAP)
loc:Width            LONG
loc:Height           LONG
loc:RetValue         LONG
 CODE
 IF OMITTED(4)
    loc:Width = SELF.tbrImageWidth
 ELSE
    loc:Width = inWidth
 END
 IF OMITTED(5)
    loc:Height = SELF.tbrImageHeight
 ELSE
    loc:Height = inHeight
 END
 IF OMITTED(3)
    loc:hIcon = GDI.LoadIconFromDll(CLIP(inIconName),,loc:Width,loc:Height)
 ELSE
    loc:hIcon = GDI.LoadIconFromDll(CLIP(inIconName),inDllName,loc:Width,loc:Height)
 END
 IF loc:hIcon
    loc:hBitmap = GDI.ConvertIcoToBmp(loc:hIcon,,loc:Width,loc:Height)
    CFC_DestroyIcon(loc:hIcon)

    IF loc:hBitmap
       CLEAR(loc:CFC_TBADDBITMAP)
       loc:CFC_TBADDBITMAP.hInst = 0
       loc:CFC_TBADDBITMAP.nID = loc:hBitmap
       loc:RetValue = CFC_SendMessage(SELF.hWndTB,CFC_TB_ADDBITMAP,1,ADDRESS(loc:CFC_TBADDBITMAP))
       IF NOT loc:RetValue = -1
          CLEAR(SELF.tbrIpool)
          SELF.tbrIpool.IconName = inIconName
          SELF.tbrIpool.hBitmap = loc:hBitmap
          SELF.tbrIpool.ImageIdx = loc:RetValue
          SELF.tbrIpool.Width = loc:Width
          SELF.tbrIpool.Height = loc:Height
          ADD(SELF.tbrIpool)
       END
    ELSE
       loc:RetValue = -1 ! fatal error
    END
 ELSE
    loc:RetValue = -1 ! fatal error
 END
 RETURN loc:RetValue
 ! If the function succeeds, the return value is the image index, otherwise the return value is -1
 ! zero (0) is a valid image index
CFCToolbar.GetIconFromImagePool        PROCEDURE(STRING inIconName,<LONG inWidth>,<LONG inHeight>)
loc:RetValue         LONG
loc:Width            LONG
loc:Height           LONG
 CODE
 IF OMITTED(3)
    loc:Width = SELF.tbrImageWidth
 ELSE
    loc:Width = inWidth
 END
 IF OMITTED(4)
    loc:Height = SELF.tbrImageHeight
 ELSE
    loc:Height = inHeight
 END

 CLEAR(SELF.tbrIpool)
 SELF.tbrIpool.IconName = inIconName
 SELF.tbrIpool.Width = loc:Width
 SELF.tbrIpool.Height = loc:Height
 GET(SELF.tbrIpool,SELF.tbrIpool.IconName,SELF.tbrIpool.Width,SELF.tbrIpool.Height)
 IF NOT ERRORCODE()
    loc:RetValue = SELF.tbrIpool.ImageIdx
 ELSE
    loc:RetValue = -1
 END
 RETURN loc:RetValue

CFCToolbar.SetTbrImageSize PROCEDURE(SHORT inWidth,SHORT inHeight)
loc:lParamG          GROUP
low                     SHORT
high                    SHORT
                     END
loc:lParam           LONG,OVER(loc:lParamG)
 CODE
 loc:lParamG.low = inWidth
 loc:lParamG.high = inHeight

 SELF.tbrImageHeight = inHeight
 SELF.tbrImageWidth = inWidth

 Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_SETBITMAPSIZE,0,loc:lParam)
CFCToolbar.ButtonCount PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_BUTTONCOUNT ,0,0)
CFCToolbar.GetButtonByID PROCEDURE(LONG inButtonID)
loc:RetValue &CFCTbrButton
 CODE
 loc:RetValue &= NULL
 SELF.tbrB.ButtonID = inButtonID
 GET(SELF.tbrB,SELF.tbrB.ButtonID)
 IF NOT ERRORCODE()
    loc:RetValue &= SELF.tbrB.B
 END
 RETURN loc:RetValue
CFCToolbar.GetButtonIDByPos       PROCEDURE(LONG inPosIndex)
loc:RetValue LONG
 CODE
 loc:RetValue = -1
 LOOP j# = 1 TO RECORDS(SELF.tbrB)
    GET(SELF.tbrB,j#)
    IF SELF.tbrB.B.GetButtonIndex() = inPosIndex
       loc:RetValue = SELF.tbrB.B.ButtonID
       BREAK
    END
 END
 RETURN loc:RetValue
CFCToolbar.AddButton        PROCEDURE(*CFCTbrButton inB, <STRING inText>, LONG inStyle,LONG inPos,BYTE inFlagIcon)
 CODE

 CLEAR(SELF.tbrB)
 SELF.tbrB.ButtonID = SELF.Cnt.GetNextID()
 SELF.tbrB.B &= inB
 ADD(SELF.tbrB)

 CLEAR(SELF.tbrB.B.TBBUTTON)
 CASE inFlagIcon
 OF CFC_TBS_TEXTWITHICON
    SELF.tbrB.B.TBBUTTON.iBitmap = -1
 OF CFC_TBS_TEXTONLY
    SELF.tbrB.B.TBBUTTON.iBitmap = -2
 OF CFC_TBS_ICONONLY
    SELF.tbrB.B.TBBUTTON.iBitmap = -1
 END

 SELF.tbrB.B.TBBUTTON.idCommand = SELF.tbrB.ButtonID

 IF inB.CheckButtonAccess() = CFC_TBA_GRANTED
    SELF.tbrB.B.TBBUTTON.fsState = CFC_TBSTATE_ENABLED
 END
 
 SELF.tbrB.B.TBBUTTON.fsStyle = BOR(inStyle,CFC_TBSTYLE_AUTOSIZE)
 SELF.tbrB.B.TBBUTTON.iString = -1

 IF NOT OMITTED(3)
    IF NOT SELF.tbrB.B.cstrText &= NULL
       DISPOSE(SELF.tbrB.B.cstrText)
    END
    SELF.tbrB.B.cstrText &= NEW CSTRING (LEN(CLIP(inText)) + 2)
    SELF.tbrB.B.cstrText = CLIP(inText)&'<0><0>'
    SELF.tbrB.B.Text = inText
    IF NOT inFlagIcon = CFC_TBS_ICONONLY
       SELF.tbrB.B.TBBUTTON.iString = CFC_SendMessage(SELF.hWndTB,CFC_TB_ADDSTRINGA,0,ADDRESS(SELF.tbrB.B.cstrText))
    END
 END
 SELF.tbrB.B.Toolbar &= SELF
 SELF.tbrB.B.ButtonID = SELF.tbrB.ButtonID

 Err# =  CFC_SendMessage(SELF.hWndTB,CFC_TB_INSERTBUTTON,inPos,ADDRESS(SELF.tbrB.B.TBBUTTON))

 RETURN SELF.tbrB.ButtonID


CFCToolbar.AddButton        PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>)
loc:Pos                   LONG
loc:FlagIcon              BYTE
 CODE
 IF OMITTED(4)
    loc:Pos = SELF.ButtonCount()
 ELSE
    loc:Pos = inPos
 END
 IF OMITTED(5)
    loc:FlagIcon = 0
 ELSE
    loc:FlagIcon = inFlagIcon
 END
 IF OMITTED(3)
    RETURN SELF.AddButton(inB,,CFC_TBSTYLE_BUTTON,loc:Pos,loc:FlagIcon)
 ELSE
    RETURN SELF.AddButton(inB,inText,CFC_TBSTYLE_BUTTON,loc:Pos,loc:FlagIcon)
 END
CFCToolbar.AddCheckButton        PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>)
loc:Pos                   LONG
loc:FlagIcon              BYTE
 CODE
 IF OMITTED(4)
    loc:Pos = SELF.ButtonCount()
 ELSE
    loc:Pos = inPos
 END
 IF OMITTED(5)
    loc:FlagIcon = 0
 ELSE
    loc:FlagIcon = inFlagIcon
 END
 IF OMITTED(3)
    RETURN SELF.AddButton(inB,,CFC_TBSTYLE_CHECK,loc:Pos,loc:FlagIcon)
 ELSE
    RETURN SELF.AddButton(inB,inText,CFC_TBSTYLE_CHECK,loc:Pos,loc:FlagIcon)
 END

CFCToolbar.AddRadioButton        PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>)
loc:Pos                   LONG
loc:FlagIcon              BYTE
 CODE
 IF OMITTED(4)
    loc:Pos = SELF.ButtonCount()
 ELSE
    loc:Pos = inPos
 END
 IF OMITTED(5)
    loc:FlagIcon = 0
 ELSE
    loc:FlagIcon = inFlagIcon
 END
 IF OMITTED(3)
    RETURN SELF.AddButton(inB,,CFC_TBSTYLE_CHECK + CFC_TBSTYLE_GROUP,loc:Pos,loc:FlagIcon)
 ELSE
    RETURN SELF.AddButton(inB,inText,CFC_TBSTYLE_CHECK + CFC_TBSTYLE_GROUP,loc:Pos,loc:FlagIcon)
 END



CFCToolbar.AddDropDownButton        PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>)
loc:Pos                   LONG
loc:FlagIcon              BYTE
 CODE
 IF OMITTED(4)
    loc:Pos = SELF.ButtonCount()
 ELSE
    loc:Pos = inPos
 END
 IF OMITTED(5)
    loc:FlagIcon = 0
 ELSE
    loc:FlagIcon = inFlagIcon
 END
 IF OMITTED(3)
    RETURN SELF.AddButton(inB,,CFC_TBSTYLE_DROPDOWN,loc:Pos,loc:FlagIcon)
 ELSE
    RETURN SELF.AddButton(inB,inText,CFC_TBSTYLE_DROPDOWN,loc:Pos,loc:FlagIcon)
 END
CFCToolbar.AddWholeDropDownButton        PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>)
loc:Pos                   LONG
loc:FlagIcon              BYTE
 CODE
 IF OMITTED(4)
    loc:Pos = SELF.ButtonCount()
 ELSE
    loc:Pos = inPos
 END
 IF OMITTED(5)
    loc:FlagIcon = 0
 ELSE
    loc:FlagIcon = inFlagIcon
 END
 IF OMITTED(3)
    RETURN SELF.AddButton(inB,,CFC_BTNS_WHOLEDROPDOWN,loc:Pos,loc:FlagIcon)
 ELSE
    RETURN SELF.AddButton(inB,inText,CFC_BTNS_WHOLEDROPDOWN,loc:Pos,loc:FlagIcon)
 END
CFCToolbar.AddSeparator        PROCEDURE(<LONG inPos>)
loc:Pos                   LONG
loc:TBBUTTON              LIKE(CFC_TBBUTTON)
 CODE
 IF OMITTED(2)
    loc:Pos = SELF.ButtonCount()
 ELSE
    loc:Pos = inPos
 END

 loc:TBBUTTON.fsStyle = CFC_TBSTYLE_SEP
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_INSERTBUTTON,loc:Pos,ADDRESS(loc:TBBUTTON))



 

CFCToolbar.DeleteSeparatorByPos PROCEDURE(LONG inPos)
loc:TBBUTTON LIKE(CFC_TBBUTTON)
 CODE
 Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_GETBUTTON,inPos,ADDRESS(loc:TBBUTTON))
 IF BAND(loc:TBBUTTON.fsStyle,CFC_TBSTYLE_SEP) = CFC_TBSTYLE_SEP
    Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_DELETEBUTTON ,inPos,0)
 END
CFCToolbar.GetAnchorHighlight PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_GETANCHORHIGHLIGHT,0,0)
CFCToolbar.SetAnchorHighlight PROCEDURE(LONG inFlagAnchor)
 CODE
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_SETANCHORHIGHLIGHT,inFlagAnchor,0)
CFCToolbar.GetButtonSize PROCEDURE(*LONG outWidth,*LONG outHeight)
loc:Size             LONG
loc:SizeG            GROUP,OVER(loc:Size)
low                     SHORT
high                    SHORT
                     END
 CODE
 loc:Size = CFC_SendMessage(SELF.hWndTB,CFC_TB_GETBUTTONSIZE,0,0)
 outWidth = loc:SizeG.low
 outHeight = loc:SizeG.high
CFCToolbar.GetColorScheme PROCEDURE(*ULONG out_clrBtnHighlight,*ULONG out_clrBtnShadow)
loc:CFC_COLORSCHEME  LIKE(CFC_COLORSCHEME)
 CODE
 CLEAR(loc:CFC_COLORSCHEME)
 loc:CFC_COLORSCHEME.dwSize = SIZE(CFC_COLORSCHEME)
 IF NOT CFC_SendMessage(SELF.hWndTB,CFC_TB_GETCOLORSCHEME,0,ADDRESS(loc:CFC_COLORSCHEME))
    out_clrBtnHighlight = -1
    out_clrBtnShadow = -1
 ELSE
    out_clrBtnHighlight = loc:CFC_COLORSCHEME.clrBtnHighlight
    out_clrBtnShadow = loc:CFC_COLORSCHEME.clrBtnShadow
 END

CFCToolbar.SetColorScheme PROCEDURE(ULONG in_clrBtnHighlight,ULONG in_clrBtnShadow)
loc:CFC_COLORSCHEME  LIKE(CFC_COLORSCHEME)
 CODE
 CLEAR(loc:CFC_COLORSCHEME)
 loc:CFC_COLORSCHEME.dwSize = SIZE(CFC_COLORSCHEME)
 loc:CFC_COLORSCHEME.clrBtnHighlight = in_clrBtnHighlight
 loc:CFC_COLORSCHEME.clrBtnShadow = in_clrBtnShadow
 Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_SETCOLORSCHEME,0,ADDRESS(loc:CFC_COLORSCHEME))


CFCToolbar.GetHotItem PROCEDURE
loc:RetValue LONG
 CODE
 loc:RetValue = CFC_SendMessage(SELF.hWndTB,CFC_TB_GETHOTITEM,0,0)
 IF NOT loc:RetValue = -1
    loc:RetValue = SELF.GetButtonIDByPos(loc:RetValue)
 END
 RETURN loc:RetValue

! Returns the Button ID of the hot item, or -1 if no hot item is set.
! Toolbar controls that do not have the TBSTYLE_FLAT style do not have hot items.

CFCToolbar.GetPadding PROCEDURE(*SHORT outHoriz,*SHORT outVert)
loc:RetValue  LONG
loc:RetValueG GROUP,OVER(loc:RetValue)
low              SHORT
high             SHORT
              END
 CODE
 loc:RetValue = CFC_SendMessage(SELF.hwndTB,CFC_TB_GETPADDING,0,0)
 outHoriz = loc:RetValueG.low
 outVert = loc:RetValueG.high


CFCToolbar.SetPadding PROCEDURE(SHORT inHoriz,SHORT inVert)
loc:RetValueG GROUP
low              SHORT
high             SHORT
              END
loc:RetValue  LONG,OVER(loc:RetValueG)
 CODE
 loc:RetValueG.low = inHoriz
 loc:RetValueG.high = inVert
 Err# = CFC_SendMessage(SELF.hwndTB,CFC_TB_SETPADDING,0,loc:RetValue)
CFCToolbar.GetRows PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hwndTB,CFC_TB_GETROWS,0,0)
CFCToolbar.GetTextRows PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hwndTB,CFC_TB_GETTEXTROWS,0,0)

CFCToolbar.SetMaxTextRows PROCEDURE(LONG inRows)
 CODE
 RETURN CFC_SendMessage(SELF.hwndTB,CFC_TB_SETMAXTEXTROWS,inRows,0)
CFCToolbar.GetMaxSizeItem PROCEDURE(*LONG outCx,*LONG outCy)
loc:Size     LIKE(CFC_SIZE)
loc:RetValue LONG
 CODE
 IF NOT CFC_SendMessage(SELF.hwndTB,CFC_TB_GETMAXSIZE,0,ADDRESS(loc:Size))
    loc:RetValue = -1
 ELSE
    outCx = loc:Size.cx
    outCy = loc:Size.cy
 END
 RETURN loc:RetValue
CFCToolbar.AutoSize PROCEDURE
 CODE
 Err# = CFC_SendMessage(SELF.hwndTB,CFC_TB_AUTOSIZE,0,0)

CFCToolbar.RefreshTooltips PROCEDURE
rc     LIKE(CFC_RECT)
 CODE
 LOOP j# = 1 TO RECORDS(SELF.tbrB)
    GET(SELF.tbrB,j#)
    IF NOT SELF.tbrB.B &= NULL
       IF NOT SELF.tbrB.B.GetRect(rc)
          CLEAR(rc)
       END
       SELF.TT.SetNewToolRect(SELF.tbrB.B.ToolID,rc)
    END
 END
CFCToolbar.SetButtonSize PROCEDURE(SHORT dx,SHORT dy)
loc:lParamG          GROUP
low                     SHORT
high                    SHORT
                     END
loc:lParam           LONG,OVER(loc:lParamG)
 CODE
 loc:lParamG.low = dx
 loc:lParamG.high = dy

 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_SETBUTTONSIZE,0,loc:lParam)
CFCToolbar.SetButtonWidth PROCEDURE(SHORT minWidth,SHORT maxWidth)
loc:lParamG          GROUP
low                     SHORT
high                    SHORT
                     END
loc:lParam           LONG,OVER(loc:lParamG)
 CODE
 loc:lParamG.low = minWidth
 loc:lParamG.high = maxWidth

 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_SETBUTTONWIDTH,0,loc:lParam)


CFCToolbar.SetDrawTextFlags PROCEDURE(LONG inMask,LONG inFlags)
 CODE
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_SETDRAWTEXTFLAGS,inMask,inFlags)


CFCToolbar.Refresh PROCEDURE
loc:TextRows       LONG
loc:WM_SETREDRAW   EQUATE(00Bh)
 CODE
 loc:TextRows = SELF.GetTextRows()
 CFC_SendMessage(SELF.hWndTB,loc:WM_SETREDRAW,FALSE,0)
 SELF.SetMaxTextRows(loc:TextRows + 1)
 SELF.SetMaxTextRows(loc:TextRows)
 CFC_SendMessage(SELF.hWndTB,loc:WM_SETREDRAW,TRUE,0)
CFCToolbar.SaveState PROCEDURE
loc:TBBUTTON LIKE(CFC_TBBUTTON)
 CODE
 IF NOT SELF.InitStateBuffer &= NULL
    DISPOSE(SELF.InitStateBuffer)
 END
 SELF.InitStateBuffer &= NEW STRING(SIZE(CFC_TBBUTTON)*SELF.ButtonCount())
 IF NOT SELF.InitStateBuffer &= NULL
    LOOP j# = 0 TO SELF.ButtonCount()-1
       IF CFC_SendMessage(SELF.hWndTB,CFC_TB_GETBUTTON,j#,ADDRESS(loc:TBBUTTON))
          CFC_MEMCPY(ADDRESS(SELF.InitStateBuffer) + j#*SIZE(CFC_TBBUTTON),ADDRESS(loc:TBBUTTON),SIZE(CFC_TBBUTTON))
       END
    END
 END
 
 

CFCToolbar.SaveStateToFile PROCEDURE(STRING inFileName)
loc:cstrFileName     CSTRING(256)
loc:StateBuffer      &STRING
loc:BytesWritten     LONG
loc:TBBUTTON         LIKE(CFC_TBBUTTON)
loc:ReturnValue      LONG
loc:hFile            ULONG
 CODE
 ! fill the current state buffer
 loc:StateBuffer &= NEW STRING(SIZE(CFC_TBBUTTON)*SELF.ButtonCount())
 IF NOT loc:StateBuffer &= NULL
    LOOP j# = 0 TO SELF.ButtonCount()-1
       CLEAR(loc:TBBUTTON)
       IF CFC_SendMessage(SELF.hWndTB,CFC_TB_GETBUTTON,j#,ADDRESS(loc:TBBUTTON))
          CFC_MEMCPY(ADDRESS(loc:StateBuffer) + j#*SIZE(CFC_TBBUTTON),ADDRESS(loc:TBBUTTON),SIZE(CFC_TBBUTTON))
       END
    END
 END

 ! save buffer to file
 IF NOT loc:StateBuffer &= NULL
    loc:cstrFileName = clip(inFileName)
    loc:hFile = CFC_CreateFile(ADDRESS(loc:cstrFileName),CFC_GENERIC_WRITE,CFC_FILE_SHARE_WRITE,0,CFC_CREATE_ALWAYS,CFC_FILE_ATTRIBUTE_NORMAL,0)
    IF NOT loc:hFile = CFC_INVALID_HANDLE_VALUE
       loc:ReturnValue = CFC_WriteFile(loc:hFile,ADDRESS(loc:StateBuffer),SIZE(loc:StateBuffer),ADDRESS(loc:BytesWritten),0)
       Err# = CFC_CloseHandle(loc:hFile)
    END
 END
 IF NOT loc:StateBuffer &= NULL
    DISPOSE(loc:StateBuffer)
 END
 RETURN loc:ReturnValue
 ! If the function succeeds, the return value is nonzero.

CFCToolbar.RestoreStateFromFile PROCEDURE(STRING inFileName)
loc:cstrFileName     CSTRING(256)
loc:StateBuffer      &STRING
loc:BytesRead        LONG
loc:ReturnValue      LONG
loc:hFile            ULONG
loc:TBBUTTON         LIKE(CFC_TBBUTTON)
 CODE
 loc:ReturnValue = -1 ! error

 ! restore buffer from file
 loc:StateBuffer &= NEW STRING(65536) ! 64 k is good to be enough
 IF NOT loc:StateBuffer &= NULL
    loc:cstrFileName = clip(inFileName)
    loc:hFile = CFC_CreateFile(ADDRESS(loc:cstrFileName),CFC_GENERIC_READ,CFC_FILE_SHARE_READ,0,CFC_OPEN_EXISTING,CFC_FILE_ATTRIBUTE_NORMAL,0)
    IF NOT loc:hFile = CFC_INVALID_HANDLE_VALUE
       IF CFC_ReadFile(loc:hFile,ADDRESS(loc:StateBuffer),SIZE(loc:StateBuffer),ADDRESS(loc:BytesRead),0)
          IF NOT SELF.RestoredStateBuffer &= NULL
             DISPOSE(SELF.RestoredStateBuffer)
          END

          ! remove all objects from toolbar
          LOOP j# = SELF.ButtonCount()-1 TO 0 BY -1
             Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_DELETEBUTTON ,j#,0)
          END

          SELF.RestoredStateBuffer &= NEW STRING(loc:BytesRead)
          IF NOT SELF.RestoredStateBuffer &= NULL
             CFC_MEMCPY(ADDRESS(SELF.RestoredStateBuffer),ADDRESS(loc:StateBuffer),loc:BytesRead)
             ! the index of string resources can change from the last save
             ! that is why we must restore it
             LOOP m# = 0 TO loc:BytesRead/SIZE(CFC_TBBUTTON)-1
                CFC_MEMCPY(ADDRESS(loc:TBBUTTON),ADDRESS(SELF.RestoredStateBuffer) + m#*SIZE(CFC_TBBUTTON),SIZE(CFC_TBBUTTON))
                SELF.tbrB.ButtonID = loc:TBBUTTON.idCommand
                GET(SELF.tbrB,SELF.tbrB.ButtonID)
                IF NOT ERRORCODE()
                   IF NOT SELF.tbrB.B &= NULL
                      loc:TBBUTTON.iString = SELF.tbrB.B.TBBUTTON.iString
                      loc:TBBUTTON.iBitmap = SELF.tbrB.B.TBBUTTON.iBitmap
                      CFC_MEMCPY(ADDRESS(SELF.RestoredStateBuffer) + m#*SIZE(CFC_TBBUTTON),ADDRESS(loc:TBBUTTON),SIZE(CFC_TBBUTTON))
                   END
                END
             END
             
             IF CFC_SendMessage(SELF.hWndTB,CFC_TB_ADDBUTTONS ,SIZE(SELF.RestoredStateBuffer)/SIZE(CFC_TBBUTTON),ADDRESS(SELF.RestoredStateBuffer))
                loc:ReturnValue = 0 ! OK
             END
          END
       END
       Err# = CFC_CloseHandle(loc:hFile)
    END
    DISPOSE(loc:StateBuffer)
 END
 RETURN loc:ReturnValue
CFCToolbar.CustomizeDialog PROCEDURE
 CODE
 CFC_SendMessage(SELF.hWndTB,CFC_TB_CUSTOMIZE,0,0)
CFCToolbar.MoveButton PROCEDURE(LONG inOldPos, LONG inNewPos)
 CODE
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_MOVEBUTTON,inOldPos,inNewPos)
 ! Returns nonzero if successful, or zero otherwise.

CFCToolbar.PressButton PROCEDURE(*CFCTbrButton inB, BYTE inFlagPress)
loc:lParamG          GROUP
low                     SHORT
high                    SHORT
                     END
loc:lParam           LONG,OVER(loc:lParamG)
 CODE
 loc:lParamG.low = inFlagPress
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_PRESSBUTTON,inB.ButtonID,loc:lParam)
 ! Returns TRUE if successful, or FALSE otherwise.


 
 
CFCToolbar.SetIndent PROCEDURE(LONG inIndent)
 CODE
 RETURN CFC_SendMessage(SELF.hWndTB,CFC_TB_SETINDENT,inIndent,0)
 ! Returns nonzero if successful, or zero otherwise.




 
 
CFCToolbar.SetRows PROCEDURE(LONG inRows,BYTE inFlagLarge,*CFC_RECT outRC)
loc:wParamG          GROUP
low                     USHORT
high                    USHORT
                     END
loc:wParam           ULONG,OVER(loc:wParamG)
 CODE
 CFC_SendMessage(SELF.hwndTB,CFC_TB_SETROWS,loc:wParam,ADDRESS(outRC))

CFCToolbar.OnToolbarChange PROCEDURE
 CODE
 SELF.RefreshTooltips()
CFCToolbar.OnReset PROCEDURE
 CODE
 ! remove all objects from toolbar
 LOOP j# = SELF.ButtonCount()-1 TO 0 BY -1
    Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_DELETEBUTTON ,j#,0)
 END

 ! restore saved state
 IF NOT SELF.InitStateBuffer &= NULL
    Err# = CFC_SendMessage(SELF.hWndTB,CFC_TB_ADDBUTTONS ,SIZE(SELF.InitStateBuffer)/SIZE(CFC_TBBUTTON),ADDRESS(SELF.InitStateBuffer))
 END

 SELF.RefreshTooltips()
!**************************************************************************************************************
CFCTbrButton.Construct            PROCEDURE
 CODE
CFCTbrButton.Destruct             PROCEDURE
 CODE
 IF NOT SELF.cstrText &= NULL
    DISPOSE(SELF.cstrText)
 END

CFCTbrButton.SetIcon PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>)
loc:TBBUTTONINFO   LIKE(CFC_TBBUTTONINFO)
loc:Width          LONG
loc:Height         LONG
loc:RetValue       LONG
 CODE
 IF OMITTED(4)
    loc:Width = SELF.Toolbar.tbrImageWidth
 ELSE
    loc:Width = inWidth
 END
 IF OMITTED(5)
    loc:Height = SELF.Toolbar.tbrImageHeight
 ELSE
    loc:Height = inHeight
 END

 CLEAR(loc:TBBUTTONINFO)
 loc:TBBUTTONINFO.cbSize = SIZE(CFC_TBBUTTONINFO)
 loc:TBBUTTONINFO.dwMask = CFC_TBIF_IMAGE
 loc:TBBUTTONINFO.iImage = SELF.Toolbar.GetIconFromImagePool(inIconName,loc:Width,loc:Height)
 IF loc:TBBUTTONINFO.iImage = -1 ! did not find the icon in image list
    IF OMITTED(3)
       loc:TBBUTTONINFO.iImage = SELF.Toolbar.AddIconToImagePool(inIconName,,loc:Width,loc:Height)
    ELSE
       loc:TBBUTTONINFO.iImage = SELF.Toolbar.AddIconToImagePool(inIconName,inDllName,loc:Width,loc:Height)
    END
 END

 IF NOT loc:TBBUTTONINFO.iImage = -1
    IF NOT CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_SETBUTTONINFO,SELF.ButtonID,ADDRESS(loc:TBBUTTONINFO))
       loc:RetValue = -1 ! error
    ELSE
       SELF.TBBUTTON.iBitmap = loc:TBBUTTONINFO.iImage
    END
 ELSE
    loc:RetValue = -1
 END

 RETURN loc:RetValue
CFCTbrButton.SetText PROCEDURE(STRING inText)
loc:TBBUTTONINFO   LIKE(CFC_TBBUTTONINFO)
loc:RetValue       LONG
 CODE
 IF NOT SELF.cstrText &= NULL
    DISPOSE(SELF.cstrText)
 END

 SELF.cstrText &= NEW CSTRING(CLIP(LEN(inText)) + 2)
 SELF.cstrText = inText
 SELF.Text = inText

 CLEAR(loc:TBBUTTONINFO)
 loc:TBBUTTONINFO.cbSize = SIZE(CFC_TBBUTTONINFO)
 loc:TBBUTTONINFO.dwMask = CFC_TBIF_TEXT
 loc:TBBUTTONINFO.pszText = ADDRESS(SELF.cstrText)

 IF NOT CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_SETBUTTONINFO,SELF.ButtonID,ADDRESS(loc:TBBUTTONINFO))
    loc:RetValue = -1 ! error
 END

 RETURN loc:RetValue

 ! MSDN
 ! Text is commonly assigned to buttons when they are added to a toolbar by specifying the index of a string in the toolbar's string pool.
 ! If you use a TB_SETBUTTONINFO to assign new text to a button, it will permanently override the text from the string pool.
 ! You can change the text by calling TB_SETBUTTONINFO again, but you cannot reassign the string from the string pool.
CFCTbrButton.SetTooltip PROCEDURE(STRING inText)
rc          LIKE(CFC_RECT)
 CODE
 SELF.GetRect(rc)
 IF NOT SELF.Toolbar &= NULL
    SELF.ToolID = SELF.Toolbar.TT.AddTool(CLIP(inText),rc)
 END
CFCTbrButton.CheckButton PROCEDURE(BYTE inFlagCheck)
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_CHECKBUTTON,SELF.ButtonID,inFlagCheck)
CFCTbrButton.GetButtonIndex PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_COMMANDTOINDEX,SELF.ButtonID,0)
CFCTbrButton.GetTBBUTTON PROCEDURE
loc:TBBUTTON LIKE(CFC_TBBUTTON)
 CODE
 Err# = CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_GETBUTTON,SELF.GetButtonIndex(),ADDRESS(loc:TBBUTTON))
 RETURN loc:TBBUTTON


CFCTbrButton.UpdateTBBUTTON PROCEDURE
loc:TBBUTTON LIKE(CFC_TBBUTTON)
 CODE
 LOOP j# = 0 TO SELF.Toolbar.ButtonCount() - 1
    CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_GETBUTTON,j#,ADDRESS(loc:TBBUTTON))
    IF loc:TBBUTTON.idCommand = SELF.ButtonID
       SELF.TBBUTTON = loc:TBBUTTON
       BREAK
    END
 END
CFCTbrButton.Delete PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_DELETEBUTTON ,SELF.GetButtonIndex(),0)
CFCTbrButton.Enable PROCEDURE(BYTE inFlagEnable)
loc:RetValue LONG
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_ENABLEBUTTON,SELF.ButtonId,inFlagEnable)
CFCTbrButton.HideButton PROCEDURE(BYTE inFlagHide)
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_HIDEBUTTON,SELF.ButtonId,inFlagHide)
CFCTbrButton.GetState PROCEDURE
loc:CFC_TBBUTTONINFO LIKE(CFC_TBBUTTONINFO)
loc:RetValue         LONG
 CODE
 CLEAR(loc:CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.cbSize = SIZE(CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.dwMask = CFC_TBIF_STATE
 IF CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_GETBUTTONINFO,SELF.ButtonId,ADDRESS(loc:CFC_TBBUTTONINFO)) = -1
    loc:RetValue = -1
 ELSE
    loc:RetValue = loc:CFC_TBBUTTONINFO.fsState
 END
 RETURN loc:RetValue
CFCTbrButton.GetStyle PROCEDURE
loc:CFC_TBBUTTONINFO LIKE(CFC_TBBUTTONINFO)
loc:RetValue         LONG
 CODE
 CLEAR(loc:CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.cbSize = SIZE(CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.dwMask = CFC_TBIF_STYLE
 IF CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_GETBUTTONINFO,SELF.ButtonId,ADDRESS(loc:CFC_TBBUTTONINFO)) = -1
    loc:RetValue = -1
 ELSE
    loc:RetValue = loc:CFC_TBBUTTONINFO.fsStyle
 END
 RETURN loc:RetValue
CFCTbrButton.GetCx PROCEDURE
loc:CFC_TBBUTTONINFO LIKE(CFC_TBBUTTONINFO)
loc:RetValue         LONG
 CODE
 CLEAR(loc:CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.cbSize = SIZE(CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.dwMask = CFC_TBIF_SIZE
 IF CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_GETBUTTONINFO,SELF.ButtonId,ADDRESS(loc:CFC_TBBUTTONINFO)) = -1
    loc:RetValue = -1
 ELSE
    loc:RetValue = loc:CFC_TBBUTTONINFO.cx
 END
 RETURN loc:RetValue




CFCTbrButton.SetCx PROCEDURE(LONG cx)
loc:CFC_TBBUTTONINFO LIKE(CFC_TBBUTTONINFO)
 CODE
 CLEAR(loc:CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.cbSize = SIZE(CFC_TBBUTTONINFO)
 loc:CFC_TBBUTTONINFO.dwMask = CFC_TBIF_SIZE
 loc:CFC_TBBUTTONINFO.cx= cx
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_SETBUTTONINFO,SELF.ButtonId,ADDRESS(loc:CFC_TBBUTTONINFO))
CFCTbrButton.GetRect PROCEDURE(*CFC_RECT outRect)
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_GETITEMRECT,SELF.GetButtonIndex(),ADDRESS(outRect))
CFCTbrButton.IsChecked PROCEDURE
 CODE
 IF BAND(SELF.GetState(),CFC_TBSTATE_CHECKED) = CFC_TBSTATE_CHECKED
    RETURN TRUE
 ELSE
    RETURN FALSE
 END



CFCTbrButton.IsEnabled PROCEDURE
 CODE
 IF BAND(SELF.GetState(),CFC_TBSTATE_ENABLED) = CFC_TBSTATE_ENABLED
    RETURN TRUE
 ELSE
    RETURN FALSE
 END


CFCTbrButton.IsHidden PROCEDURE
 CODE
 IF BAND(SELF.GetState(),CFC_TBSTATE_HIDDEN) = CFC_TBSTATE_HIDDEN
    RETURN TRUE
 ELSE
    RETURN FALSE
 END



CFCTbrButton.IsPressed PROCEDURE
 CODE
 IF BAND(SELF.GetState(),CFC_TBSTATE_PRESSED) = CFC_TBSTATE_PRESSED
    RETURN TRUE
 ELSE
    RETURN FALSE
 END


CFCTbrButton.IsIndeterminate PROCEDURE
 CODE
 IF BAND(SELF.GetState(),CFC_TBSTATE_INDETERMINATE) = CFC_TBSTATE_INDETERMINATE
    RETURN TRUE
 ELSE
    RETURN FALSE
 END


CFCTbrButton.IsHighlighted  PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_ISBUTTONHIGHLIGHTED,SELF.ButtonId,0)
 !Returns nonzero if the button is highlighted, or zero otherwise.

CFCTbrButton.MarkButton  PROCEDURE(BYTE inFlagMark)
loc:lParamG          GROUP
low                     SHORT
high                    SHORT
                     END
loc:lParam           LONG,OVER(loc:lParamG)
 CODE
 loc:lParamG.low = inFlagMark
 RETURN CFC_SendMessage(SELF.Toolbar.hWndTB,CFC_TB_MARKBUTTON,SELF.ButtonId,loc:lParam)
 ! Returns nonzero if successful, or zero otherwise.


CFCTbrButton.OnCommand PROCEDURE
 CODE
CFCTbrButton.OnDropDown  PROCEDURE
 CODE
CFCTbrButton.CheckButtonAccess  PROCEDURE
 CODE
 RETURN CFC_TBA_GRANTED

!**************************************************************************************************************
CFCToolbarManager.Construct            PROCEDURE
 CODE
 SELF.tbrQ &= NEW CFC_ToolbarQ

CFCToolbarManager.Destruct             PROCEDURE
 CODE
 IF NOT SELF.tbrQ &= NULL
    DISPOSE(SELF.tbrQ)
 END

CFCToolbarManager.AddToolbar           PROCEDURE(*CFCToolbar inTbr)
 CODE
 CLEAR(SELF.tbrQ)
 SELF.tbrQ.T &= inTbr
 ADD(SELF.tbrQ)
CFCToolbarManager.CallBackProc         PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:NMHDR            LIKE(CFC_NMHDR)
loc:NMTOOLBAR        LIKE(CFC_NMTOOLBAR)
loc:NMTBCUSTOMDRAW   LIKE(CFC_NMTBCUSTOMDRAW)
loc:WM_NOTIFY        EQUATE(004Eh)
loc:WM_COMMAND       EQUATE(0111h)
loc:NM_CUSTOMDRAW    EQUATE(4294967284)
loc:CurrButton       &CFCTbrButton

loc:wParamG          GROUP,OVER(wParam)
low                     USHORT
high                    USHORT
                     END
loc:lParamG          GROUP,OVER(lParam)
low                     SHORT
high                    SHORT
                     END


hTmpBrush            LONG
rcWork               LIKE(CFC_RECT)
 CODE
 IF inMsg = loc:WM_COMMAND ! push the button
    LOOP j# = 1 TO RECORDS(SELF.tbrQ) ! process toolbars messages
       GET(SELF.tbrQ,j#)
       IF SELF.tbrQ.T.hWndTB = lParam
          loc:CurrButton &= SELF.tbrQ.T.GetButtonByID(loc:wParamG.low)
          IF NOT loc:CurrButton &= NULL
             loc:CurrButton.OnCommand()
             BREAK
          END
       END
    END
 END

 IF inMsg = loc:WM_NOTIFY
    CFC_MEMCPY(ADDRESS(loc:NMHDR),lParam,SIZE(CFC_NMHDR))
    IF loc:NMHDR._code = CFC_TBN_INITCUSTOMIZE
       RETURN CFC_TBNRF_HIDEHELP  ! supress Help Button
    END
    IF loc:NMHDR._code = CFC_TBN_TOOLBARCHANGE
       LOOP j# = 1 TO RECORDS(SELF.tbrQ)
          GET(SELF.tbrQ,j#)
          IF SELF.tbrQ.T.hWndTB = loc:NMHDR.hwndFrom
             SELF.tbrQ.T.OnToolbarChange()
             BREAK
          END
       END
    END
    IF loc:NMHDR._code = CFC_TBN_RESET
       LOOP j# = 1 TO RECORDS(SELF.tbrQ)
          GET(SELF.tbrQ,j#)
          IF SELF.tbrQ.T.hWndTB = loc:NMHDR.hwndFrom
             SELF.tbrQ.T.OnReset()
             BREAK
          END
       END
    END
 END

 IF inMsg = loc:WM_NOTIFY
    CFC_MEMCPY(ADDRESS(loc:NMHDR),lParam,SIZE(CFC_NMHDR))
    LOOP j# = 1 TO RECORDS(SELF.tbrQ)
       GET(SELF.tbrQ,j#)
       IF SELF.tbrQ.T.hWndTB = loc:NMHDR.hwndFrom
          IF loc:NMHDR._code = CFC_TBN_DROPDOWN
             CFC_MEMCPY(ADDRESS(loc:NMTOOLBAR),lParam,SIZE(CFC_NMTOOLBAR))
             loc:CurrButton &= SELF.tbrQ.T.GetButtonByID(loc:NMTOOLBAR.iItem)
             IF NOT loc:CurrButton &= NULL
                loc:CurrButton.OnDropDown()
                BREAK
             END
             RETURN 0
          END
          IF loc:NMHDR._code = CFC_TBN_QUERYDELETE
             RETURN TRUE
          END
          IF loc:NMHDR._code = CFC_TBN_QUERYINSERT
             RETURN TRUE
          END
          IF loc:NMHDR._code = CFC_TBN_GETBUTTONINFOA
             CFC_MEMCPY(ADDRESS(loc:NMTOOLBAR),lParam,SIZE(CFC_NMTOOLBAR))
             GET(SELF.tbrQ.T.tbrB,loc:NMTOOLBAR.iItem + 1)
             IF NOT ERRORCODE()
                loc:NMTOOLBAR.tbButton = SELF.tbrQ.T.tbrB.B.TBBUTTON
                IF NOT SELF.tbrQ.T.tbrB.B.cstrText &= NULL
                   loc:NMTOOLBAR.cchText = LEN(CLIP(SELF.tbrQ.T.tbrB.B.Text)) + 1
                   loc:NMTOOLBAR.pszText = ADDRESS(SELF.tbrQ.T.tbrB.B.cstrText)
                END
                CFC_MEMCPY(lParam,ADDRESS(loc:NMTOOLBAR),SIZE(CFC_NMTOOLBAR))
                RETURN TRUE
             ELSE
                RETURN FALSE
             END
          END
       END
    END
 END

 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)




