!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCTooltips.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
CFC_hook:MessageProc PROCEDURE(LONG inCode,ULONG wParam,LONG lParam),LONG,PASCAL
 END

 INCLUDE('CFCTooltips.inc'),ONCE

CFC_TooltipGlobalManager    CFCTooltipManagerClass,THREAD

CFC_TOOLTIP_MESSAGE         EQUATE(CFC_WM_USER + 1)



CFCTooltipsClass.Construct            PROCEDURE
 CODE
 SELF.ttQ &= NEW CFCTooltipsQ
CFCTooltipsClass.Destruct             PROCEDURE
 CODE
 ! free tooltips text
 LOOP j# = 1 TO RECORDS(SELF.ttQ)
    GET(SELF.ttQ,j#)
    IF NOT SELF.ttQ.cstrText &= NULL
       DISPOSE(SELF.ttQ.cstrText)
    END
 END

 IF NOT SELF.ttQ &= NULL THEN DISPOSE(SELF.ttQ).


CFCTooltipsClass.Init                 PROCEDURE(ULONG inParentHWND)
 CODE
 SELF.ParentHWND = inParentHWND
 CFC_TooltipGlobalManager.AddTooltip(SELF)
CFCTooltipsClass.Kill                 PROCEDURE
 CODE
 IF SELF.hWndTt
    SELF.RemoveCallback()
    Err# = CFC_DestroyWindow(SELF.hWndTt)
 END
CFCTooltipsClass.SetCommandCnt        PROCEDURE(*CFCCommandCnt inCnt)
 CODE
 SELF.Cnt &= inCnt
CFCTooltipsClass.CreateTooltip        PROCEDURE(<LONG inStyle>)
cstrTooltipClassName CSTRING('Tooltips_Class32')
loc:TtStyle         LONG
 CODE
 loc:TtStyle = 0
 IF NOT OMITTED(2)
    loc:TtStyle = inStyle
 END

 SELF.hWndTt = CFC_CreateWindowEx(CFC_WS_EX_TOPMOST, |
                                  ADDRESS(cstrTooltipClassName), |
                                  0, |
                                  CFC_WS_POPUP + loc:TtStyle, |
                                  0,0,0,0, |
                                  SELF.ParentHWND, |
                                  0, |
                                  SYSTEM{PROP:AppInstance}, |
                                  0)

 IF SELF.hWndTt
    Err# = CFC_SetWindowPos(SELF.hWndTt,-1, 0, 0, 0, 0,CFC_SWP_NOMOVE + CFC_SWP_NOSIZE + CFC_SWP_NOACTIVATE)
    SELF.SetCallback(SELF.hWndTt)
 END

 RETURN SELF.hWndTt

CFCTooltipsClass.AddTool        PROCEDURE(STRING inToolText,<*CFC_Rect in_rc>,<LONG inFlags>)
loc:TOOLINFO          LIKE(CFC_TOOLINFO)
loc:RetValue          LONG
loc:uFlags            LONG
 CODE
 IF NOT OMITTED(4)
    loc:uFlags = inFlags
 ELSE
    loc:uFlags = CFC_TTF_SUBCLASS ! default style
 END

 CLEAR(loc:TOOLINFO)
 CLEAR(SELF.ttQ)
 loc:TOOLINFO.cbSize = SIZE(CFC_TOOLINFO)
 loc:TOOLINFO.uFlags = loc:uFlags
 loc:TOOLINFO.hwnd = SELF.ParentHWND
 loc:TOOLINFO.uId = SELF.Cnt.GetNextID()
 IF NOT OMITTED(3) ! tooltip for rectangle
    loc:TOOLINFO.rect :=: in_rc
 ELSE              ! tooltip for whole window
    loc:TOOLINFO.uFlags += CFC_TTF_IDISHWND
    loc:TOOLINFO.uId = SELF.ParentHWND
    SELF.ttQ.FlagHwnd = TRUE
 END
 loc:TOOLINFO.hinst = 0
 SELF.ttQ.cstrText &= NEW CSTRING(LEN(CLIP(inToolText))+1)
 SELF.ttQ.cstrText = inToolText
 loc:TOOLINFO.lpszText = ADDRESS(SELF.ttQ.cstrText)

 IF CFC_SendMessage(SELF.hWndTt,CFC_TTM_ADDTOOLA,0,ADDRESS(loc:TOOLINFO))
    loc:RetValue = loc:TOOLINFO.uId
    SELF.ttQ.ID = loc:TOOLINFO.uId
    ADD(SELF.ttQ)
 ELSE
    loc:RetValue = -1 ! error
    IF NOT SELF.ttQ.cstrText &= NULL
       DISPOSE(SELF.ttQ.cstrText)
    END
 END
 RETURN loc:RetValue
CFCTooltipsClass.AddTool        PROCEDURE(<*CFC_Rect in_rc>,<LONG inFlags>)
loc:TOOLINFO          LIKE(CFC_TOOLINFO)
loc:RetValue          LONG
loc:uFlags            LONG
 CODE
 IF NOT OMITTED(3)
    loc:uFlags = inFlags
 ELSE
    loc:uFlags = CFC_TTF_SUBCLASS ! default style
 END
 CLEAR(loc:TOOLINFO)
 CLEAR(SELF.ttQ)
 loc:TOOLINFO.cbSize = SIZE(CFC_TOOLINFO)
 loc:TOOLINFO.uFlags = loc:uFlags
 loc:TOOLINFO.hwnd = SELF.ParentHWND
 loc:TOOLINFO.uId = SELF.Cnt.GetNextID()
 IF NOT OMITTED(2) ! tooltip for rectangle
    loc:TOOLINFO.rect :=: in_rc
 ELSE              ! tooltip for whole window
    loc:TOOLINFO.uFlags += CFC_TTF_IDISHWND
    loc:TOOLINFO.uId = SELF.ParentHWND
    SELF.ttQ.FlagHwnd = TRUE
 END
 loc:TOOLINFO.hinst = 0
 loc:TOOLINFO.lpszText = - 1

 IF CFC_SendMessage(SELF.hWndTt,CFC_TTM_ADDTOOLA,0,ADDRESS(loc:TOOLINFO))
    loc:RetValue = loc:TOOLINFO.uId
    SELF.ttQ.ID = loc:TOOLINFO.uId
    ADD(SELF.ttQ)
 ELSE
    loc:RetValue = -1 ! error
    IF NOT SELF.ttQ.cstrText &= NULL
       DISPOSE(SELF.ttQ.cstrText)
    END
 END
 RETURN loc:RetValue
CFCTooltipsClass.DelTool        PROCEDURE(LONG inID)
loc:TOOLINFO LIKE(CFC_TOOLINFO)
loc:RetValue LONG
 CODE
 SELF.ttQ.ID = inID
 GET(SELF.ttQ,SELF.ttQ.ID)
 IF NOT ERRORCODE()
    CLEAR(loc:TOOLINFO)
    loc:TOOLINFO.cbSize = SIZE(CFC_TOOLINFO)
    loc:TOOLINFO.hwnd = SELF.ParentHWND
    loc:TOOLINFO.uId = SELF.ttQ.ID

    CFC_SendMessage(SELF.hWndTt,CFC_TTM_DELTOOLA,0,ADDRESS(loc:TOOLINFO))

    IF NOT SELF.ttQ.cstrText &= NULL
       DISPOSE(SELF.ttQ.cstrText)
    END
    DELETE(SELF.ttQ)
 ELSE
    loc:RetValue = -1
 END
 RETURN loc:RetValue
CFCTooltipsClass.GetToolInfoByIdx        PROCEDURE(LONG inIdx,*CFC_TOOLINFO outTI)
loc:RetValue LONG
 CODE
 CLEAR(outTI)
 outTI.cbSize = SIZE(CFC_TOOLINFO)

 IF NOT CFC_SendMessage(SELF.hWndTt,CFC_TTM_ENUMTOOLSA,0,ADDRESS(outTI))
    loc:RetValue = -1
 END
 RETURN loc:RetValue
CFCTooltipsClass.GetToolInfoByID        PROCEDURE(ULONG inID,*CFC_TOOLINFO outTI)
loc:RetValue LONG
 CODE
 CLEAR(outTI)
 outTI.cbSize = SIZE(CFC_TOOLINFO)
 outTI.hwnd = SELF.ParentHWND
 outTI.uId = inID

 IF NOT CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETTOOLINFOA,0,ADDRESS(outTI))
    loc:RetValue = -1
 END
 RETURN loc:RetValue
CFCTooltipsClass.GetCurrentToolInfo        PROCEDURE(*CFC_TOOLINFO outTI)
loc:RetValue LONG
 CODE
 CLEAR(outTI)
 outTI.cbSize = SIZE(CFC_TOOLINFO)
 IF NOT CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETCURRENTTOOLA,0,ADDRESS(outTI))
    loc:RetValue = -1
 END
 RETURN loc:RetValue
CFCTooltipsClass.IsToolVisible        PROCEDURE
loc:RetValue LONG
 CODE
 IF NOT CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETCURRENTTOOLA,0,0)
    loc:RetValue = 0
 ELSE
    loc:RetValue = 1
 END
 RETURN loc:RetValue
CFCTooltipsClass.GetMargin        PROCEDURE(*CFC_RECT outRect)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETMARGIN,0,ADDRESS(outRect))
CFCTooltipsClass.SetMargin        PROCEDURE(*CFC_RECT inRect)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETMARGIN,0,ADDRESS(inRect))
CFCTooltipsClass.GetBubblesize        PROCEDURE(ULONG inID,*LONG outWidth,*LONG outHeight)
loc:TOOLINFO    LIKE(CFC_TOOLINFO)
loc:RetValue    LONG
loc:RetValueG   GROUP,OVER(loc:RetValue)
low                SHORT
high               SHORT
                END
 CODE
 outWidth = 0
 outHeight = 0
 IF NOT SELF.GetToolInfoByID(inID,loc:TOOLINFO) = -1
    loc:RetValue = CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETBUBBLESIZE,0,ADDRESS(loc:TOOLINFO))
    IF NOT loc:RetValue
       loc:RetValue = -1
       outWidth = 0
       outHeight = 0
    ELSE
       outWidth = loc:RetValueG.low
       outHeight = loc:RetValueG.high
    END
 END
 RETURN loc:RetValue
CFCTooltipsClass.GetMaxTipWidth        PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETMAXTIPWIDTH,0,0)
CFCTooltipsClass.SetMaxTipWidth        PROCEDURE(LONG inWidth)
 CODE
 RETURN CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETMAXTIPWIDTH,0,inWidth)
CFCTooltipsClass.Activate        PROCEDURE(BYTE inFlagActivate)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_ACTIVATE,inFlagActivate,0)


CFCTooltipsClass.SetTitle        PROCEDURE(STRING inTitle,ULONG inIconID)
loc:RetValue LONG
 CODE
 SELF.ToolTitle = inTitle
 SELF.TitleIconID = inIconID
 IF NOT CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETTITLEA,inIconID,ADDRESS(SELF.ToolTitle))
    loc:RetValue = -1
 END
 RETURN loc:RetValue
CFCTooltipsClass.GetTitleText        PROCEDURE
 CODE
 RETURN SELF.ToolTitle

CFCTooltipsClass.GetTitleIconID        PROCEDURE
 CODE
 RETURN SELF.TitleIconID
CFCTooltipsClass.GetTitleCopiedHIcon        PROCEDURE
loc:TTGETTITLE LIKE(CFC_TTGETTITLE)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETTITLE,0,ADDRESS(loc:TTGETTITLE))
 RETURN loc:TTGETTITLE.uTitleBitmap

 ! this method does not work





CFCTooltipsClass.GetTitleTextLen      PROCEDURE
 CODE
 RETURN LEN(CLIP(SELF.ToolTitle))
CFCTooltipsClass.RemoveTitle        PROCEDURE
 CODE
 SELF.SetTitle('',0)
CFCTooltipsClass.SetToolText        PROCEDURE(ULONG inID,STRING inText)
loc:TOOLINFO LIKE(CFC_TOOLINFO)
loc:RetValue LONG
 CODE
 SELF.ttQ.ID = inID
 GET(SELF.ttQ,SELF.ttQ.ID)
 IF NOT ERRORCODE()
    CLEAR(loc:TOOLINFO)
    loc:TOOLINFO.cbSize = SIZE(CFC_TOOLINFO)
    loc:TOOLINFO.hwnd = SELF.ParentHWND
    loc:TOOLINFO.uId = SELF.ttQ.ID

    IF NOT CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETTOOLINFOA,0,ADDRESS(loc:TOOLINFO))
       loc:RetValue = -1
    ELSE
       IF NOT SELF.ttQ.cstrText &= NULL
          DISPOSE(SELF.ttQ.cstrText)
          SELF.ttQ.cstrText &= NEW CSTRING(LEN(CLIP(inText))+1)
          SELF.ttQ.cstrText = inText
          PUT(SELF.ttQ)
          loc:TOOLINFO.lpszText = ADDRESS(SELF.ttQ.cstrText)
          CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETTOOLINFOA,0,ADDRESS(loc:TOOLINFO))
       END
    END
 ELSE
    loc:RetValue = -1
 END

 RETURN loc:RetValue
CFCTooltipsClass.GetToolText        PROCEDURE(ULONG inID)
 CODE
 SELF.ttQ.ID = inID
 GET(SELF.ttQ,SELF.ttQ.ID)
 IF NOT ERRORCODE()
    IF NOT SELF.ttQ.cstrText &= NULL
       RETURN SELF.ttQ.cstrText
    END
 END
 RETURN ''
CFCTooltipsClass.GetToolTextLen       PROCEDURE(ULONG inID)
 CODE
 SELF.ttQ.ID = inID
 GET(SELF.ttQ,SELF.ttQ.ID)
 IF NOT ERRORCODE()
    IF NOT SELF.ttQ.cstrText &= NULL
       RETURN LEN(CLIP(SELF.ttQ.cstrText))
    END
 END
 RETURN 0
CFCTooltipsClass.GetToolCount        PROCEDURE
loc:RetValue LONG
 CODE
  RETURN CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETTOOLCOUNT,0,0)
CFCTooltipsClass.GetDelayTime        PROCEDURE(LONG inDuration)
 CODE
 RETURN CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETDELAYTIME,inDuration,0)
CFCTooltipsClass.SetDelayTime        PROCEDURE(LONG inDuration,LONG inTime)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETDELAYTIME,inDuration,inTime)
CFCTooltipsClass.SetReshowTime        PROCEDURE(LONG inTime)
 CODE
 SELF.SetDelayTime(CFC_TTDT_RESHOW,inTime)
CFCTooltipsClass.SetInitialTime       PROCEDURE(LONG inTime)
 CODE
 SELF.SetDelayTime(CFC_TTDT_INITIAL,inTime)
CFCTooltipsClass.SetAutoPopTime       PROCEDURE(LONG inTime)
 CODE
 SELF.SetDelayTime(CFC_TTDT_AUTOPOP,inTime)
CFCTooltipsClass.GetAutoPopTime        PROCEDURE
 CODE
 RETURN SELF.GetDelayTime(CFC_TTDT_AUTOPOP)

CFCTooltipsClass.GetReshowTime        PROCEDURE
 CODE
 RETURN SELF.GetDelayTime(CFC_TTDT_RESHOW)

CFCTooltipsClass.GetInitialTime        PROCEDURE
 CODE
 RETURN SELF.GetDelayTime(CFC_TTDT_INITIAL)
CFCTooltipsClass.Update        PROCEDURE
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_UPDATE,0,0)
CFCTooltipsClass.ActivateTrack   PROCEDURE(ULONG inID,BYTE inAction)
loc:TOOLINFO LIKE(CFC_TOOLINFO)
loc:RetValue LONG
 CODE
 SELF.ttQ.ID = inID
 GET(SELF.ttQ,SELF.ttQ.ID)
 IF NOT ERRORCODE()
    CLEAR(loc:TOOLINFO)
    loc:TOOLINFO.cbSize = SIZE(CFC_TOOLINFO)
    loc:TOOLINFO.hwnd = SELF.ParentHWND
    loc:TOOLINFO.uId = SELF.ttQ.ID

    CFC_SendMessage(SELF.hWndTt,CFC_TTM_TRACKACTIVATE,inAction,ADDRESS(loc:TOOLINFO))
 ELSE
    loc:RetValue = -1
 END
 RETURN loc:RetValue


CFCTooltipsClass.SetTrackPos   PROCEDURE(SHORT xPos,SHORT yPos)
loc:LONG_G      GROUP
low                SHORT
high               SHORT
                END

loc:LONG_VAR    LONG,OVER(loc:LONG_G)
 CODE
 loc:LONG_G.low = xPos
 loc:LONG_G.high = yPos

 CFC_SendMessage(SELF.hWndTt,CFC_TTM_TRACKPOSITION,0,loc:LONG_VAR)



CFCTooltipsClass.GetTipBKColor  PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETTIPBKCOLOR,0,0)
 


CFCTooltipsClass.SetTipBKColor  PROCEDURE(ULONG inColor)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETTIPBKCOLOR,inColor,0)
 


CFCTooltipsClass.GetTipTextColor  PROCEDURE
 CODE
 RETURN CFC_SendMessage(SELF.hWndTt,CFC_TTM_GETTIPTEXTCOLOR,0,0)
CFCTooltipsClass.SetTipTextColor  PROCEDURE(ULONG inColor)
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_SETTIPTEXTCOLOR,inColor,0)
CFCTooltipsClass.SetNewToolRect  PROCEDURE(ULONG inID,*CFC_RECT in_rc)
loc:TOOLINFO     LIKE(CFC_TOOLINFO)
 CODE
 CLEAR(loc:TOOLINFO)
 loc:TOOLINFO.cbSize = SIZE(CFC_TOOLINFO)
 loc:TOOLINFO.hwnd = SELF.ParentHWND
 loc:TOOLINFO.uId = inID
 loc:TOOLINFO.rect :=: in_rc
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_NEWTOOLRECTA,0,ADDRESS(loc:TOOLINFO))
CFCTooltipsClass.PopTooltip  PROCEDURE
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_POP,0,0)
CFCTooltipsClass.PopupTooltip  PROCEDURE
 CODE
 CFC_SendMessage(SELF.hWndTt,CFC_TTM_POPUP,0,0)
CFCTooltipsClass.OnPop PROCEDURE
 CODE

CFCTooltipsClass.OnShow PROCEDURE
 CODE


CFCTooltipsClass.OnLinkClick PROCEDURE
 CODE
CFCTooltipsClass.OnUpdate PROCEDURE
 CODE
 SELF.Activate(FALSE)
 SELF.Update()
 SELF.Activate(TRUE)
CFCTooltipsClass.CallBackProc     PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
 CODE
 IF inMsg = CFC_TOOLTIP_MESSAGE
    CASE wParam
    OF CFC_TTN_POP
       SELF.OnPop()
    OF CFC_TTN_SHOW
       SELF.OnShow()
    OF CFC_TTN_LINKCLICK
       SELF.OnLinkClick()
    OF CFC_TTN_UPDATE
       SELF.OnUpdate()
    END
 END
 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
! **********************************************************************************************
CFCTooltipManagerClass.Construct                 PROCEDURE
 CODE
 SELF.hHook = CFC_SetWindowsHookEx(CFC_WH_CALLWNDPROC,ADDRESS(CFC_hook:MessageProc),0,CFC_GetCurrentThreadId())
 SELF.ttq &= NEW CFC_tt_queue




 
CFCTooltipManagerClass.Destruct                  PROCEDURE
 CODE
 IF NOT SELF.ttq &= NULL THEN DISPOSE(SELF.ttq).
 IF SELF.hHook THEN CFC_UnhookWindowsHookEx(SELF.hHook).


CFCTooltipManagerClass.AddTooltip                PROCEDURE(*CFCTooltipsClass inTT)
 CODE
 CLEAR(SELF.ttq)
 SELF.ttq.TT &= inTT
 ADD(SELF.ttq)
CFCTooltipManagerClass.OnPop  PROCEDURE(ULONG in_hwnd,ULONG wParam, LONG lParam)
 CODE
 LOOP j# = 1 TO RECORDS(SELF.ttq)
    GET(SELF.ttq,j#)
    IF NOT SELF.ttq.TT &= NULL
       IF SELF.ttq.TT.hWndTt
          IF SELF.ttq.TT.hWndTt = in_hwnd
             CFC_PostMessage(SELF.ttq.TT.hWndTt,CFC_TOOLTIP_MESSAGE,CFC_TTN_POP,0)
          END
          IF SELF.ttq.TT.hWndTt <> in_hwnd
             CFC_PostMessage(SELF.ttq.TT.hWndTt,CFC_TOOLTIP_MESSAGE,CFC_TTN_UPDATE,0)
          END
       END
    END
 END
CFCTooltipManagerClass.OnShow  PROCEDURE(ULONG in_hwnd,ULONG wParam, LONG lParam)
 CODE
 LOOP j# = 1 TO RECORDS(SELF.ttq)
    GET(SELF.ttq,j#)
    IF NOT SELF.ttq.TT &= NULL
       IF SELF.ttq.TT.hWndTt = in_hwnd
          CFC_PostMessage(SELF.ttq.TT.hWndTt,CFC_TOOLTIP_MESSAGE,CFC_TTN_SHOW,0)
       END
    END
 END

 

CFCTooltipManagerClass.OnLinkClick PROCEDURE(ULONG in_hwnd,ULONG wParam, LONG lParam)
 CODE
 LOOP j# = 1 TO RECORDS(SELF.ttq)
    GET(SELF.ttq,j#)
    IF NOT SELF.ttq.TT &= NULL
       IF SELF.ttq.TT.hWndTt = in_hwnd
          CFC_PostMessage(SELF.ttq.TT.hWndTt,CFC_TOOLTIP_MESSAGE,CFC_TTN_LINKCLICK,0)
       END
    END
 END
CFC_hook:MessageProc PROCEDURE(LONG inCode,ULONG wParam,LONG lParam) ! LONG,PASCAL
loc:WM_CREATE                   EQUATE(1)
loc:WM_DESTROY                  EQUATE(2)
loc:WM_NOTIFY                   EQUATE(004Eh)

loc:Msg                         LIKE(CFC_CWPSTRUCT)
loc:NMHDR                       LIKE(CFC_NMHDR)

cstrClassName                   CSTRING(80)

loc:SPI_GETMENUANIMATION        EQUATE(01002h)
loc:SPI_SETMENUANIMATION        EQUATE(01003h)
loc:SPI_GETMENUFADE             EQUATE(01012h)
loc:SPI_SETMENUFADE             EQUATE(01013h)

 CODE
 IF inCode = CFC_HC_ACTION
    CFC_memcpy(address(loc:Msg),lParam,SIZE(CFC_CWPSTRUCT))
    IF loc:Msg.hwnd
       IF loc:Msg._Msg = loc:WM_NOTIFY
          CFC_MEMCPY(ADDRESS(loc:NMHDR),loc:Msg.lParam,SIZE(CFC_NMHDR))
          CASE loc:NMHDR._code
          OF CFC_TTN_SHOW
             CFC_TooltipGlobalManager.OnShow(loc:NMHDR.hwndFrom,loc:Msg.wParam,loc:Msg.lParam)
          OF CFC_TTN_POP
             CFC_TooltipGlobalManager.OnPop(loc:NMHDR.hwndFrom,loc:Msg.wParam,loc:Msg.lParam)
          OF CFC_TTN_LINKCLICK
             CFC_TooltipGlobalManager.OnLinkClick(loc:NMHDR.hwndFrom,loc:Msg.wParam,loc:Msg.lParam)
          END
       END
       CASE loc:Msg._Msg
       OF loc:WM_CREATE
          cstrClassName = ''
          IF CFC_GetClassName(loc:Msg.hwnd,ADDRESS(cstrClassName),SIZE(cstrClassName))
             IF UPPER(CLIP(cstrClassName)) = '#32768'
                CFC_SystemParametersInfo(loc:SPI_GETMENUANIMATION,0,ADDRESS(CFC_TooltipGlobalManager.MenuAnimation),0)
                CFC_SystemParametersInfo(loc:SPI_GETMENUFADE,0,ADDRESS(CFC_TooltipGlobalManager.MenuFade),0)
                CFC_SystemParametersInfo(loc:SPI_SETMENUANIMATION,0,0,0)
                CFC_SystemParametersInfo(loc:SPI_SETMENUFADE,0,0,0)
             END
          END
       OF loc:WM_DESTROY
          cstrClassName = ''
          IF CFC_GetClassName(loc:Msg.hwnd,ADDRESS(cstrClassName),SIZE(cstrClassName))
             IF UPPER(CLIP(cstrClassName)) = '#32768'
                CFC_SystemParametersInfo(loc:SPI_SETMENUANIMATION,0,CFC_TooltipGlobalManager.MenuAnimation,0)
                CFC_SystemParametersInfo(loc:SPI_SETMENUFADE,0,CFC_TooltipGlobalManager.MenuFade,0)
             END
          END
       END
    END
 END
 RETURN CFC_CallNextHookEx(CFC_TooltipGlobalManager.hHook,inCode,wParam,lParam)
! **********************************************************************************************
! for user use
! TTM_HITTEST
! TTM_RELAYEVENT


