!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCTray.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
 END

 INCLUDE('CFCTray.inc'),ONCE
CFCTrayClass.Construct                        PROCEDURE
loc:cstr       CSTRING('TaskbarCreated')
 CODE
 SELF.uID = 128
 SELF.uCallbackMessage = 0FFFH - 2
 SELF.uTaskbarRestart = CFC_RegisterWindowMessage(ADDRESS(loc:cstr))
 SELF.FlagAllowHalt = FALSE

CFCTrayClass.Destruct                         PROCEDURE
 CODE
CFCTrayClass.Set_uID                        PROCEDURE(ULONG inID)
 CODE
 SELF.uID = inID
CFCTrayClass.Set_uCallbackMessage PROCEDURE(ULONG inCallbackMessage)
 CODE
 SELF.uCallbackMessage = inCallbackMessage
CFCTrayClass.Set_FlagHalt PROCEDURE(BYTE inFlagHalt)
 CODE
 SELF.FlagAllowHalt = inFlagHalt
CFCTrayClass.Init PROCEDURE(*WINDOW inW,*CFCComctrlClass inComctrl)
 CODE
 SELF.W &= inW
 SELF.hWnd = SELF.W{PROP:Handle}
 SELF.Comctrl &= inComctrl

 SELF.SetCallback(SELF.hWnd)
CFCTrayClass.Kill PROCEDURE
 CODE
 SELF.RemoveIcon()
 IF SELF.hIcon
    CFC_DestroyIcon(SELF.hIcon)
    SELF.hIcon = 0
 END
 SELF.RemoveCallback()
CFCTrayClass.SetIcon PROCEDURE(STRING inIconName,<STRING inDllName>)
nid                  LIKE(CFC_NOTIFYICONDATA)
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
gdi                  CFCGDIClass
 CODE
 Err# = -1 ! fatal error

 IF OMITTED(3)
    SELF.hIcon = gdi.LoadIconFromDll(inIconName)
 ELSE
    SELF.hIcon = gdi.LoadIconFromDll(inIconName,inDllName)
 END

 IF SELF.hIcon
    IF NOT SELF.Comctrl &= NULL
       IF NOT SELF.Comctrl.IsWindows2000orLater()
          CLEAR(nid)
          nid.cbSize = SIZE(CFC_NOTIFYICONDATA)
          nid.hWnd = SELF.hWnd
          nid.uID = SELF.uID
          nid.uFlags = CFC_NIF_MESSAGE + CFC_NIF_ICON
          nid.uCallbackMessage = SELF.uCallbackMessage
          nid.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_ADD,ADDRESS(nid))
       ELSE
          CLEAR(nid_nt)
          nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
          nid_nt.hWnd = SELF.hWnd
          nid_nt.uID = SELF.uID
          nid_nt.uFlags = CFC_NIF_MESSAGE + CFC_NIF_ICON
          nid_nt.uCallbackMessage = SELF.uCallbackMessage
          nid_nt.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_ADD,ADDRESS(nid_nt))
       END
       IF NOT Err#
          Err# = CFC_GetLastError()
       ELSE
          Err# = 0
       END
    END
 END
 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.ReAddIcon PROCEDURE
nid                  LIKE(CFC_NOTIFYICONDATA)
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
 CODE
 Err# = -1 ! fatal error

 IF SELF.hIcon
    IF NOT SELF.Comctrl &= NULL
       IF NOT SELF.Comctrl.IsWindows2000orLater()
          CLEAR(nid)
          nid.cbSize = SIZE(CFC_NOTIFYICONDATA)
          nid.hWnd = SELF.hWnd
          nid.uID = SELF.uID
          nid.uFlags = CFC_NIF_MESSAGE + CFC_NIF_ICON
          nid.uCallbackMessage = SELF.uCallbackMessage
          nid.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_ADD,ADDRESS(nid))
       ELSE
          CLEAR(nid_nt)
          nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
          nid_nt.hWnd = SELF.hWnd
          nid_nt.uID = SELF.uID
          nid_nt.uFlags = CFC_NIF_MESSAGE + CFC_NIF_ICON
          nid_nt.uCallbackMessage = SELF.uCallbackMessage
          nid_nt.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_ADD,ADDRESS(nid_nt))
       END
       IF NOT Err#
          Err# = CFC_GetLastError()
       ELSE
          Err# = 0
       END
    END
 END
 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.ChangeIcon PROCEDURE(STRING inIconName,<STRING inDllName>)
nid                  LIKE(CFC_NOTIFYICONDATA)
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
gdi                  CFCGDIClass
 CODE
 IF SELF.hIcon
    CFC_DestroyIcon(SELF.hIcon)
    SELF.hIcon = 0
 END

 Err# = -1 ! fatal error
 IF OMITTED(3)
    SELF.hIcon = gdi.LoadIconFromDll(inIconName)
 ELSE
    SELF.hIcon = gdi.LoadIconFromDll(inIconName,inDllName)
 END

 IF SELF.hIcon
    IF NOT SELF.Comctrl &= NULL
       IF NOT SELF.Comctrl.IsWindows2000orLater()
          CLEAR(nid)
          nid.cbSize = SIZE(CFC_NOTIFYICONDATA)
          nid.hWnd = SELF.hWnd
          nid.uID = SELF.uID
          nid.uFlags = CFC_NIF_ICON
          nid.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid))
       ELSE
          CLEAR(nid_nt)
          nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
          nid_nt.hWnd = SELF.hWnd
          nid_nt.uID = SELF.uID
          nid_nt.uFlags = CFC_NIF_ICON
          nid_nt.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid_nt))
       END
       IF NOT Err#
          Err# = CFC_GetLastError()
       ELSE
          Err# = 0
       END
    END
 END
 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.RemoveIcon PROCEDURE
nid                  LIKE(CFC_NOTIFYICONDATA)
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
 CODE
 Err# = -1 ! fatal error

 IF SELF.hIcon
    IF NOT SELF.Comctrl &= NULL
       IF NOT SELF.Comctrl.IsWindows2000orLater()
          CLEAR(nid)
          nid.cbSize = SIZE(CFC_NOTIFYICONDATA)
          nid.hWnd = SELF.hWnd
          nid.uID = SELF.uID
          nid.uFlags = CFC_NIF_ICON
          nid.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_DELETE,ADDRESS(nid))
       ELSE
          CLEAR(nid_nt)
          nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
          nid_nt.hWnd = SELF.hWnd
          nid_nt.uID = SELF.uID
          nid_nt.uFlags = CFC_NIF_ICON
          nid_nt.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_DELETE,ADDRESS(nid_nt))
       END
       IF NOT Err#
          Err# = CFC_GetLastError()
       ELSE
          Err# = 0
       END
    END
 END

 IF SELF.hIcon
    CFC_DestroyIcon(SELF.hIcon)
    SELF.hIcon = 0
 END

 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.SetTooltip PROCEDURE(STRING inTooltipText)
nid                  LIKE(CFC_NOTIFYICONDATA)
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
 CODE
 Err# = -1 ! fatal error

 IF NOT SELF.Comctrl &= NULL
    IF NOT SELF.Comctrl.IsWindows2000orLater()
       CLEAR(nid)
       nid.cbSize = SIZE(CFC_NOTIFYICONDATA)
       nid.hWnd = SELF.hWnd
       nid.uID = SELF.uID
       nid.uFlags = CFC_NIF_TIP
       nid.szTip = inTooltipText
       Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid))
    ELSE
       CLEAR(nid_nt)
       nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
       nid_nt.hWnd = SELF.hWnd
       nid_nt.uID = SELF.uID
       nid_nt.uFlags = CFC_NIF_TIP
       nid_nt.szTip = inTooltipText
       Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid_nt))
    END
    IF NOT Err#
       Err# = CFC_GetLastError()
    ELSE
       Err# = 0
    END
 END


 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.ShowBallonTooltip PROCEDURE(STRING inTooltipText,STRING inTitle,LONG inInfoFlags)
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
 CODE
 Err# = -1 ! fatal error

 IF NOT SELF.Comctrl &= NULL
    IF SELF.Comctrl.IsWindows2000orLater()
       CLEAR(nid_nt)
       nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
       nid_nt.hWnd = SELF.hWnd
       nid_nt.uID = SELF.uID
       nid_nt.uFlags = CFC_NIF_INFO
       nid_nt.szInfo = inTooltipText
       nid_nt.szInfoTitle = inTitle
       nid_nt.dwInfoFlags = inInfoFlags
       Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid_nt))
    END
    IF NOT Err#
       Err# = CFC_GetLastError()
    ELSE
       Err# = 0
    END
 END


 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.ShowBallonTooltip PROCEDURE(STRING inTooltipText,STRING inTitle,LONG inInfoFlags,STRING inIconName,<STRING inDllName>)
nid_vista            LIKE(CFC_NOTIFYICONDATA_VISTA)
loc:hIcon            ULONG
gdi                  CFCGDIClass
 CODE
 Err# = -1 ! fatal error

 IF OMITTED(6)
    loc:hIcon = gdi.LoadIconFromDll(inIconName)
 ELSE
    loc:hIcon = gdi.LoadIconFromDll(inIconName,inDllName)
 END

 IF loc:hIcon
    IF NOT SELF.Comctrl &= NULL
       IF SELF.Comctrl.IsWindowsVistaOrLater()
          CLEAR(nid_vista)
          nid_vista.cbSize = SIZE(CFC_NOTIFYICONDATA_VISTA)
          nid_vista.hWnd = SELF.hWnd
          nid_vista.uID = SELF.uID
          nid_vista.uFlags = CFC_NIF_INFO
          nid_vista.szInfo = inTooltipText
          nid_vista.szInfoTitle = inTitle
          nid_vista.dwInfoFlags = inInfoFlags
          nid_vista.hBalloonIcon = loc:hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid_vista))
       END
       IF NOT Err#
          Err# = CFC_GetLastError()
       ELSE
          Err# = 0
       END
    END
    CFC_DestroyIcon(loc:hIcon)
 END

 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.RemoveBallonTooltip PROCEDURE
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
 CODE
 Err# = -1 ! fatal error

 IF NOT SELF.Comctrl &= NULL
    IF SELF.Comctrl.IsWindows2000orLater()
       CLEAR(nid_nt)
       nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
       nid_nt.hWnd = SELF.hWnd
       nid_nt.uID = SELF.uID
       nid_nt.uFlags = CFC_NIF_INFO
       Err# = CFC_Shell_NotifyIcon(CFC_NIM_MODIFY,ADDRESS(nid_nt))
    END
    IF NOT Err#
       Err# = CFC_GetLastError()
    ELSE
       Err# = 0
    END
 END


 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.SetFocus PROCEDURE
nid_nt               LIKE(CFC_NOTIFYICONDATA_NT)
 CODE
 Err# = -1 ! fatal error

 IF SELF.hIcon
    IF NOT SELF.Comctrl &= NULL
       IF SELF.Comctrl.IsWindows2000orLater()
          CLEAR(nid_nt)
          nid_nt.cbSize = SIZE(CFC_NOTIFYICONDATA_NT)
          nid_nt.hWnd = SELF.hWnd
          nid_nt.uID = SELF.uID
          nid_nt.uFlags = CFC_NIF_MESSAGE + CFC_NIF_ICON
          nid_nt.uCallbackMessage = SELF.uCallbackMessage
          nid_nt.hIcon = SELF.hIcon
          Err# = CFC_Shell_NotifyIcon(CFC_NIM_SETFOCUS,ADDRESS(nid_nt))
       END
       IF NOT Err#
          Err# = CFC_GetLastError()
       ELSE
          Err# = 0
       END
    END
 END
 RETURN Err#
 ! returns -1 if the fatal error occured
 ! returns 0 if OK
 ! return error number (GetLastError) if any other errors occured
CFCTrayClass.HideWnd   PROCEDURE
 CODE
 SELF.W{PROP:Hide} = TRUE
 Err# = CFC_ShowWindow(SELF.hWnd,0) ! shoot it :)

CFCTrayClass.ShowWnd   PROCEDURE
 CODE
 Err# = CFC_SetForegroundWindow(SELF.hWnd)
 Err# = CFC_SetFocus(SELF.hWnd)
 Err# = CFC_BringWindowToTop(SELF.hWnd)
 IF SELF.W{PROP:Maximize}
    Err# = CFC_ShowWindow(SELF.hWnd,5)
 ELSIF SELF.W{PROP:Iconize} = 1
    Err# = CFC_ShowWindow(SELF.hWnd,9)
 ELSE
    Err# = CFC_ShowWindow(SELF.hWnd,5)
 END
 SELF.W{PROP:Hide} = FALSE
 
CFCTrayClass.OnPopupOpen                      PROCEDURE
 CODE
CFCTrayClass.OnPopupClose                     PROCEDURE
 CODE

CFCTrayClass.OnMouseMove                      PROCEDURE
 CODE

CFCTrayClass.OnBallonShow                     PROCEDURE
 CODE

CFCTrayClass.OnBallonHide                     PROCEDURE
 CODE

CFCTrayClass.OnBallonUserClick                PROCEDURE
 CODE

CFCTrayClass.OnBallonTimeOut                  PROCEDURE
 CODE

CFCTrayClass.OnMouseLDblClick  PROCEDURE
 CODE

CFCTrayClass.OnMouseRButtonUP  PROCEDURE
 CODE
 Err# = CFC_SetForegroundWindow(SELF.hWnd)

CFCTrayClass.OnMouseLButtonUP PROCEDURE
 CODE

CFCTrayClass.OnQueryEndSession                PROCEDURE
 CODE
CFCTrayClass.CallBackProc                        PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:WM_MOUSEMOVE         EQUATE(0200h)
loc:WM_LBUTTONUP         EQUATE(0202h)
loc:WM_LBUTTONDBLCLK     EQUATE(0203h)
loc:WM_RBUTTONUP         EQUATE(0205h)
loc:WM_CONTEXTMENU       EQUATE(007Bh)
loc:NIN_SELECT           EQUATE(00000400h)
loc:NIN_KEYSELECT        EQUATE(00000401h)
loc:NIN_BALLOONSHOW      EQUATE(00000402h)
loc:NIN_BALLOONHIDE      EQUATE(00000403h)
loc:NIN_BALLOONTIMEOUT   EQUATE(00000404h)
loc:NIN_BALLOONUSERCLICK EQUATE(00000405h)
loc:NIN_POPUPOPEN        EQUATE(00000406h)
loc:NIN_POPUPCLOSE       EQUATE(00000407h)
loc:WM_QUERYENDSESSION   EQUATE(0011h)
loc:WM_ENDSESSION        EQUATE(0016h)

 CODE
 IF inMsg = SELF.uCallbackMessage
    CASE lParam ! BAND(lParam, 0FFFFh)
    OF loc:WM_LBUTTONDBLCLK
       SELF.OnMouseLDblClick()
    OF loc:WM_RBUTTONUP
       SELF.OnMouseRButtonUP()
    OF loc:WM_LBUTTONUP
       SELF.OnMouseLButtonUP()
    OF loc:NIN_BALLOONSHOW
       SELF.OnBallonShow()
    OF loc:NIN_BALLOONHIDE
       SELF.OnBallonHide()
    OF loc:NIN_BALLOONUSERCLICK
       SELF.OnBallonUserClick()
    OF loc:NIN_BALLOONTIMEOUT
       SELF.OnBallonTimeOut()
    OF loc:NIN_POPUPOPEN
       SELF.OnPopupOpen()
    OF loc:NIN_POPUPCLOSE
       SELF.OnPopupClose()
    OF loc:WM_MOUSEMOVE
       SELF.OnMouseMove()
    END
 END
 IF inMsg = SELF.uTaskbarRestart
    SELF.ReAddIcon()
 END
 CASE inMsg
 OF loc:WM_QUERYENDSESSION
    SELF.OnQueryEndSession()
    RETURN TRUE
 OF loc:WM_ENDSESSION
    NOTIFY(Event:CloseDown,THREAD())
    IF SELF.FlagAllowHalt
       HALT 
    END
    RETURN TRUE
 END


 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
! ************************************************************************************************


