!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: cfchtml.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
     INCLUDE('OCX.CLW'),ONCE
     
CFC_EventFunc                    PROCEDURE(*SHORT inReference, SIGNED inOleControl, LONG inCurrentEvent),LONG
CFC_HTMLEnumerateWindows         PROCEDURE(ULONG hWnd,LONG lParam),BOOL,PASCAL
CFC_HTMLEnumerateLocalWindows    PROCEDURE(ULONG hWnd,LONG lParam),BOOL,PASCAL
 END


 INCLUDE('cfchtml.inc'),ONCE
 INCLUDE('OCXEVENT.CLW'),ONCE
 INCLUDE('ERRORS.CLW'),ONCE
 INCLUDE('KEYCODES.CLW'),ONCE

CFC_HTMLGlobalManager    CFCHTMLManagerClass !  
CFC_HTMLCriticalSection  CriticalSection     !  

CFCHTMLClass.Construct                        PROCEDURE
 CODE
CFCHTMLClass.Destruct                         PROCEDURE
 CODE

CFCHTMLClass.Init                             PROCEDURE(*WINDOW inW,LONG inOLE)
 CODE
 SELF.W &= inW
 SELF.hWnd = SELF.W{PROP:Handle}
 SELF.OLE = inOLE
 SELF.OLEhWnd = SELF.OLE{PROP:Handle}

 SELF.OLE{PROP:Create} = 'Shell.Explorer.2'

 CFC_HTMLGlobalManager.AddHtmlObj(SELF) !     

 OCXREGISTEREVENTPROC(SELF.OLE, CFC_EventFunc) !     
CFCHTMLClass.Kill                             PROCEDURE
 CODE
 OCXUNREGISTEREVENTPROC(SELF.OLE)
 CFC_HTMLGlobalManager.RemoveIEsCallback(SELF.hWnd)
 CFC_HTMLGlobalManager.DelHtmlObj(SELF) !     
CFCHTMLClass.OpenFile                         PROCEDURE(STRING inFileName)
 CODE
 SELF.OLE{'Navigate("file://' & CLIP(inFileName) & '")'}
CFCHTMLClass.GetDisplayStyle PROCEDURE(STRING inID)
 CODE
 RETURN SELF.OLE{'document.getElementById('& CLIP(inID) &').style.display'}

!!       OF 'GETVALUE' 
!!         MESSAGE(': ' & ?OLE{'document.getElementById(dform).elements(dselect).selectedIndex'} + 1 & '<13,10>' & |
!!                 ': ' & ABS(?OLE{'document.getElementById(Check1).Checked'}) & '<13,10>' & |
!!                 ': ' & CHOOSE(ABS(?OLE{'document.getElementById(radio1).Checked'}) = 1,1,2) & '<13,10>' & |
!!                 ' : ' & ?OLE{'document.getElementById(text1).Value'} & '<13,10>' & |
!!                 ' : ' & ?OLE{'document.getElementById(longtext).Value'})
!!       OF 'SETVALUE' 
!!         ?OLE{'document.getElementById(longtext).Value'} = '     Clarion  HTML   TEXTAREA.'
CFCHTMLClass.SetDisplayStyleNone PROCEDURE(STRING inID)
 CODE
 SELF.OLE{'document.getElementById('& CLIP(inID) &').style.display'} = 'none'

CFCHTMLClass.SetDisplayStyleBlock PROCEDURE(STRING inID)
 CODE
 SELF.OLE{'document.getElementById('& CLIP(inID) &').style.display'} = 'block'

CFCHTMLClass.OnCommand                        PROCEDURE(STRING inLink) ! ,VIRTUAL
 CODE
CFCHTMLClass.OnDownloadComplete PROCEDURE
 CODE
 CFC_HTMLGlobalManager.SetIEsCallback(SELF.W{PROP:ClientHandle})
CFCHTMLClass.IsImagesEnabled PROCEDURE
loc:Result            STRING(255)
loc:RetValue          BYTE
loc:REG_CURRENT_USER  EQUATE(80000001h)
 CODE
 loc:Result = GETREG(loc:REG_CURRENT_USER,'Software\Microsoft\Internet Explorer\Main','Display Inline Images')
 IF loc:Result = 'yes'
    loc:RetValue = 1
 ELSIF loc:Result = 'no'
    loc:RetValue = 0
 ELSE
    loc:RetValue = 0
 END
 RETURN loc:RetValue
CFCHTMLClass.GetIEVersion PROCEDURE
loc:Result            STRING(255)
loc:HKEY_LOCAL_MACHINE   EQUATE(80000002h)
 CODE
 loc:Result = GETREG(loc:HKEY_LOCAL_MACHINE,'Software\Microsoft\Internet Explorer','Version')
 RETURN loc:Result
CFCHTMLClass.DisableClickSound PROCEDURE
loc:REG_CURRENT_USER  EQUATE(80000001h)
 CODE
 PUTREG(loc:REG_CURRENT_USER,'AppEvents\Schemes\Apps\Explorer\Navigating\.Current','','')


CFC_EventFunc      PROCEDURE(*SHORT inReference, SIGNED inOleControl, LONG inCurrentEvent) ! ,LONG
Count           LONG
loc:Event       CSTRING(1024)
loc:Link        CSTRING(1024)
loc:html        &CFCHTMLClass
 CODE
 IF inCurrentEvent <> OCXEVENT:MouseMove

    CFC_HTMLCriticalSection.Wait()
    LOOP j# = 1 TO RECORDS(CFC_HTMLGlobalManager.html_q)
       GET(CFC_HTMLGlobalManager.html_q,j#)
       IF NOT CFC_HTMLGlobalManager.html_q.obj &= NULL
          IF CFC_HTMLGlobalManager.html_q.obj.OLEhWnd = inOleControl{PROP:Handle} !   
             loc:html &= CFC_HTMLGlobalManager.html_q.obj
             BREAK
          END
       END
    END
    CFC_HTMLCriticalSection.Release()

    loc:Event = inOleControl{PROP:LastEventName}

    CASE CLIP(loc:Event)
    OF 'BeforeNavigate2'
       loc:Link = OCXGETPARAM(inReference, 2)
       IF SUB(UPPER(loc:Link),1,8) = 'CLICK://'
          loc:Link = SUB(loc:Link, 9, LEN(loc:Link) - 9)
          IF NOT loc:html &= NULL
             loc:html.OnCommand(loc:Link)
             OCXSETPARAM(inReference, 7, 1) ! cancel navigate
          END
       END
    OF 'DownloadComplete'
       IF NOT loc:html &= NULL
          loc:html.OnDownloadComplete()
       END
    END
    
 END
 RETURN TRUE
! *********************************************************************************
CFCHTMLManagerClass.Construct                        PROCEDURE
 CODE
 SELF.html_q &= NEW CFC_html_queue
 SELF.sbw &=  NEW CFC_subclassedw_queue

CFCHTMLManagerClass.Destruct                         PROCEDURE
 CODE
 IF NOT SELF.html_q &= NULL THEN DISPOSE(SELF.html_q).
 IF NOT SELF.sbw &= NULL THEN DISPOSE(SELF.sbw).

CFCHTMLManagerClass.AddHtmlObj                       PROCEDURE(*CFCHTMLClass inHtml)
 CODE
 CFC_HTMLCriticalSection.Wait()
 SELF.html_q.obj &= inHtml
 ADD(SELF.html_q)
 CFC_HTMLCriticalSection.Release()

CFCHTMLManagerClass.DelHtmlObj                       PROCEDURE(*CFCHTMLClass inHtml)
 CODE
 CFC_HTMLCriticalSection.Wait()
 LOOP j# = RECORDS(SELF.html_q) TO 1 BY -1
    GET(SELF.html_q,j#)
    IF NOT SELF.html_q.obj &= NULL
       IF SELF.html_q.obj.OLEhWnd = inHtml.OLEhWnd !   
          DELETE(SELF.html_q)
          BREAK
       END
    END
 END
 CFC_HTMLCriticalSection.Release()
CFCHTMLManagerClass.SetIEsCallback PROCEDURE(ULONG in_hWnd)
 CODE
 SELF.parent_hWnd = in_hWnd

 Err# = CFC_EnumChildWindows(in_hWnd,ADDRESS(CFC_HTMLEnumerateWindows),ADDRESS(SELF))

 CFC_HTMLCriticalSection.Wait()
 LOOP j# = 1 TO RECORDS(SELF.sbw)
    GET(SELF.sbw,j#)
    IF SELF.sbw.CallbackFlag THEN CYCLE.
    SELF.sbw.html_cc &= NEW CFCHTMLCallbackClass
    IF NOT SELF.sbw.html_cc &= NULL
       SELF.sbw.html_cc.SetCallBack(SELF.sbw.IE_hWnd)
       SELF.sbw.CallbackFlag = TRUE
    END
    PUT(SELF.sbw)
 END
 CFC_HTMLCriticalSection.Release()
CFCHTMLManagerClass.RemoveIEsCallback PROCEDURE(ULONG in_hWnd)
loc:D               &CFCHTMLDummyClass
 CODE
 loc:D &= NEW CFCHTMLDummyClass
 loc:D.sbw &= NEW CFC_subclassedw_queue
 Err# = CFC_EnumChildWindows(in_hWnd,ADDRESS(CFC_HTMLEnumerateLocalWindows),ADDRESS(loc:D))

 CFC_HTMLCriticalSection.Wait()
 LOOP j# = 1 TO RECORDS(loc:D.sbw)
    GET(loc:D.sbw,j#)
    SELF.sbw.IE_hWnd = loc:D.sbw.IE_hWnd
    GET(SELF.sbw,SELF.sbw.IE_hWnd)
    IF NOT ERRORCODE()
       IF NOT SELF.sbw.html_cc &= NULL
          SELF.sbw.html_cc.RemoveCallBack()
          DISPOSE(SELF.sbw.html_cc)
       END
       DELETE(SELF.sbw)
    END
 END
 CFC_HTMLCriticalSection.Release()

 DISPOSE(loc:D.sbw)
 DISPOSE(loc:D)
CFC_HTMLEnumerateWindows         PROCEDURE(ULONG hWnd,LONG lParam)
cstrCaption      CSTRING(256)
cstrClassName    CSTRING(80)
loc:html_mng     &CFCHTMLManagerClass
 CODE
 CFC_HTMLCriticalSection.Wait()
 IF CFC_GetClassName(hWnd,ADDRESS(cstrClassName),SIZE(cstrClassName))
    IF SUB(UPPER(CLIP(cstrClassName)),1,24) = 'INTERNET EXPLORER_SERVER'
       loc:html_mng &= (lParam)
       IF NOT loc:html_mng &= NULL
          loc:html_mng.sbw.IE_hWnd = hWnd
          GET(loc:html_mng.sbw,loc:html_mng.sbw.IE_hWnd)
          IF ERRORCODE()
             CLEAR(loc:html_mng.sbw)
             loc:html_mng.sbw.IE_hWnd = hWnd
             ADD(loc:html_mng.sbw)
          END
       END
    END
 END
 CFC_HTMLCriticalSection.Release()

 RETURN TRUE
CFC_HTMLEnumerateLocalWindows    PROCEDURE(ULONG hWnd,LONG lParam)!,BOOL,PASCAL
cstrCaption      CSTRING(256)
cstrClassName    CSTRING(80)
loc:D            &CFCHTMLDummyClass

 CODE
 IF CFC_GetClassName(hWnd,ADDRESS(cstrClassName),SIZE(cstrClassName))
    IF SUB(UPPER(CLIP(cstrClassName)),1,24) = 'INTERNET EXPLORER_SERVER'
       loc:D &= (lParam)
       IF NOT loc:D.sbw &= NULL
          CLEAR(loc:D.sbw)
          loc:D.sbw.IE_hWnd = hWnd
          ADD(loc:D.sbw)
       END
    END
 END
 RETURN TRUE
! *********************************************************************************
CFCHTMLCallbackClass.CallBackProc                        PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:WM_RBUTTONUP         EQUATE(0205h)
loc:WM_CONTEXTMENU       EQUATE(07Bh)
loc:WM_KEYDOWN           EQUATE(0100h)
loc:WM_KEYUP             EQUATE(0101h)
 CODE
 CASE inMsg
 OF loc:WM_RBUTTONUP OROF loc:WM_CONTEXTMENU
    RETURN FALSE
 OF loc:WM_KEYDOWN
    CFC_PostMessage(0{PROP:Handle},loc:WM_KEYDOWN,wParam,lParam)
    RETURN FALSE
 OF loc:WM_KEYUP
    CFC_PostMessage(0{PROP:Handle},loc:WM_KEYUP,wParam,lParam)
    RETURN FALSE
 END

 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)



