!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: cfcnorecords.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
 END

 INCLUDE('cfcnorecords.inc'),ONCE
CFCNoRecordsAvailableClass.Construct                        PROCEDURE
 CODE
 SELF.DisplayQueue &= NEW CFC_NoRecordsQueue
 SELF.WarningStr = 'No records available'
 SELF.TimerID = 130


CFCNoRecordsAvailableClass.Destruct                         PROCEDURE
 CODE
 IF NOT SELF.DisplayQueue &= NULL THEN DISPOSE(SELF.DisplayQueue).
CFCNoRecordsAvailableClass.Init  PROCEDURE(*QUEUE inQ,LONG inListFEQ,<STRING inWarningStr>)
 CODE
 SELF.Q &= inQ
 SELF.ListBoxFeq = inListFEQ
 IF NOT OMITTED(4)
    SELF.WarningStr = inWarningStr
 END

 IF NOT SELF.DisplayQueue &= NULL
    CLEAR(SELF.DisplayQueue)
    SELF.DisplayQueue.Str = SELF.WarningStr
    ADD(SELF.DisplayQueue)
 END

 Err# = CFC_SetTimer(SELF.ListBoxFeq{Prop:Handle},SELF.TimerID,100,0) ! set the timer
 SELF.SetCallBack(SELF.ListBoxFeq{Prop:Handle},SELF.ListBoxFeq)       ! set the subclassing
CFCNoRecordsAvailableClass.Kill  PROCEDURE
 CODE
 SELF.RemoveCallBack()                                                    ! remove the subclassing
 CFC_KillTimer(SELF.ListBoxFeq{Prop:Handle},SELF.TimerID)                 ! kill the timer
CFCNoRecordsAvailableClass.SetWarningStr     PROCEDURE(STRING inStr)
 CODE
 SELF.WarningStr = inStr

 IF NOT SELF.DisplayQueue &= NULL
    GET(SELF.DisplayQueue,1)
    IF NOT ERRORCODE()
       SELF.DisplayQueue.Str = SELF.WarningStr
       PUT(SELF.DisplayQueue)
    END
 END
CFCNoRecordsAvailableClass.OnTimer PROCEDURE
 CODE
 IF NOT SELF.DisplayQueue &= NULL
    IF NOT RECORDS(SELF.Q)
       IF NOT SELF.FlagNoRecords
          SELF.FlagNoRecords = TRUE
          SELF.FlagRecords = FALSE
          SELF.SavedFormat = SELF.ListBoxFeq{PROP:Format}
          SELF.SavedLineHeight = SELF.ListBoxFeq{PROP:LineHeight}
          SELF.SavedDisableProp = SELF.ListBoxFeq{PROP:Disable}
          SELF.ListBoxFeq{PROP:From} = SELF.DisplayQueue
          SELF.ListBoxFeq{PROP:Format} = '1000C(2)@s255@'
          SELF.ListBoxFeq{PROP:Disable} = TRUE
          SELF.ListBoxFeq{PROP:LineHeight} = SELF.ListBoxFeq{PROP:Height}
       END
    ELSE
       IF NOT SELF.FlagRecords
          IF LEN(CLIP(SELF.SavedFormat))
             SELF.FlagNoRecords = FALSE
             SELF.FlagRecords = TRUE
             SELF.RestoreLBFormat()
          END
       END
    END
 END
CFCNoRecordsAvailableClass.RestoreLBFormat PROCEDURE
 CODE
 IF LEN(CLIP(SELF.SavedFormat))
    SELF.ListBoxFeq{PROP:From} = SELF.Q
    SELF.ListBoxFeq{PROP:Format} = CLIP(SELF.SavedFormat)
    SELF.ListBoxFeq{PROP:Disable} = SELF.SavedDisableProp
    SELF.ListBoxFeq{PROP:LineHeight} = SELF.SavedLineHeight
 END
CFCNoRecordsAvailableClass.CallBackProc                        PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:WM_TIMER            EQUATE(0113h)
 CODE
 IF inMsg = loc:WM_TIMER AND wParam = SELF.TimerID
    SELF.OnTimer()
 END

 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)
! ************************************************************************************************


