!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: cfcpanel.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
 END

 INCLUDE('cfcpanel.inc'),ONCE
CFCHTMLPanelClass.Construct                        PROCEDURE
 CODE
 SELF.pg &= NEW CFC_PanelGroupsType
 SELF.pi &= NEW CFC_PanelItemsType
 SELF.ptb &= NEW CFC_PanelTextBlocksType
 SELF.state_q &= NEW CFC_PanelStateType
 SELF.padding_px = 5
 SELF.FontName = '"Tahoma","Verdana"'
 SELF.FontSize = '8pt'

CFCHTMLPanelClass.Destruct                         PROCEDURE
 CODE
 IF NOT SELF.pg &= NULL THEN DISPOSE(SELF.pg).
 IF NOT SELF.pi &= NULL THEN DISPOSE(SELF.pi).
 IF NOT SELF.ptb &= NULL THEN DISPOSE(SELF.ptb).
 IF NOT SELF.state_q &= NULL THEN DISPOSE(SELF.state_q).
CFCHTMLPanelClass.Init                             PROCEDURE(STRING inFileName,*CFCHTMLClass in_html)
 CODE
 SELF.FileName = inFileName
 SELF.html &= in_html

CFCHTMLPanelClass.Kill                             PROCEDURE
 CODE
 CLOSE(CFC_HTMLTxtFile)
 REMOVE(CFC_HTMLTxtFile)
CFCHTMLPanelClass.SetIniFileName                   PROCEDURE(STRING inFileName,STRING inPanelDesc)
 CODE
 SELF.IniFileName = inFileName
 SELF.PanelDesc = inPanelDesc
CFCHTMLPanelClass.Run                          PROCEDURE
 CODE
 CFC_HTMLTxtFile{Prop:Name} = CLIP(SELF.FileName)
 CREATE(CFC_HTMLTxtFile)
 OPEN(CFC_HTMLTxtFile)

 SELF.OpenHeadTag()
 SELF.WriteContent()
 SELF.CloseHeadTag()

 CLOSE(CFC_HTMLTxtFile)

 SELF.html.OpenFile(SELF.FileName)
CFCHTMLPanelClass.Refresh                          PROCEDURE
 CODE
 CLOSE(CFC_HTMLTxtFile)
 REMOVE(CFC_HTMLTxtFile)
 SELF.SaveState()
 SELF.Run()

 
 
CFCHTMLPanelClass.AddGroup      PROCEDURE(STRING inGroupID,STRING inGroupName,STRING inImage)
 CODE
 CLEAR(SELF.pg)
 SELF.pg.GroupID = inGroupID
 SELF.pg.GroupName = inGroupName
 SELF.pg.ImageName = inImage
 ADD(SELF.pg)
CFCHTMLPanelClass.AddItem       PROCEDURE(STRING inGroupID,STRING inItemID,STRING inItemText,STRING inImage,<BYTE inFlagSepBefore>,<STRING inCheckGroup>)
 CODE
 CLEAR(SELF.pi)
 SELF.pi.GroupID = inGroupID
 SELF.pi.ItemID = inItemID
 SELF.pi.ItemText = inItemText
 SELF.pi.ImageName = inImage
 IF NOT OMITTED(6)
    SELF.pi.FlagSepBefore = inFlagSepBefore
 END
 IF NOT OMITTED(7)
    SELF.pi.CheckGroup = inCheckGroup
 END
 ADD(SELF.pi)
CFCHTMLPanelClass.AddTextBlock      PROCEDURE(STRING inGroupID,STRING inBlockID,STRING inText)
 CODE
 CLEAR(SELF.ptb)
 SELF.ptb.GroupID = inGroupID
 SELF.ptb.BlockID = inBlockID
 SELF.ptb.Text = inText
 ADD(SELF.ptb)

! you can set inGroupID = "-1" to type text before any groups
CFCHTMLPanelClass.SetItemTooltip                   PROCEDURE(STRING inItemID,STRING inTooltipText)
 CODE
 IF NOT SELF.pi &= NULL
    SELF.pi.ItemID = inItemID
    GET(SELF.pi,SELF.pi.ItemID)
    IF NOT ERRORCODE()
       SELF.pi.TooltipText = CLIP(inTooltipText)
       PUT(SELF.pi)
    END
 END
CFCHTMLPanelClass.SetItemIcon                   PROCEDURE(STRING inItemID,STRING inImage)
 CODE
 IF NOT SELF.pi &= NULL
    SELF.pi.ItemID = inItemID
    GET(SELF.pi,SELF.pi.ItemID)
    IF NOT ERRORCODE()
       SELF.pi.ImageName = CLIP(inImage)
       PUT(SELF.pi)
    END
 END

CFCHTMLPanelClass.SetItemText                   PROCEDURE(STRING inItemID,STRING inText)
 CODE
 IF NOT SELF.pi &= NULL
    SELF.pi.ItemID = inItemID
    GET(SELF.pi,SELF.pi.ItemID)
    IF NOT ERRORCODE()
       SELF.pi.ItemText = CLIP(inText)
       PUT(SELF.pi)
    END
 END
CFCHTMLPanelClass.SetItemChecked                   PROCEDURE(STRING inItemID)
loc:CheckGroup STRING(255)
 CODE
 SELF.pi.ItemID = inItemID
 GET(SELF.pi,SELF.pi.ItemID)
 IF NOT ERRORCODE()
    loc:CheckGroup = SELF.pi.CheckGroup
    SELF.pi.FlagChecked = 1
    SELF.html.SetDisplayStyleBlock(CLIP(SELF.pi.ItemID) & ':image')
    PUT(SELF.pi)
 END

 IF lEN(CLIP(loc:CheckGroup))
    LOOP j# = 1 TO RECORDS(SELF.pi)
       GET(SELF.pi,j#)
       IF loc:CheckGroup <> SELF.pi.CheckGroup THEN CYCLE.
       IF SELF.pi.ItemID = inItemID THEN CYCLE.
       SELF.pi.FlagChecked = 0
       SELF.html.SetDisplayStyleNone(CLIP(SELF.pi.ItemID) & ':image')
       PUT(SELF.pi)
    END
 END

CFCHTMLPanelClass.SetItemEnabled      PROCEDURE(STRING inItemID)
 CODE
 SELF.html.SetDisplayStyleBlock(CLIP(inItemID)& ':enabled')
 SELF.html.SetDisplayStyleNone(CLIP(inItemID)& ':disabled')
CFCHTMLPanelClass.SetItemDisabled      PROCEDURE(STRING inItemID)
 CODE
 SELF.html.SetDisplayStyleNOne(CLIP(inItemID)& ':enabled')
 SELF.html.SetDisplayStyleBlock(CLIP(inItemID)& ':disabled')
CFCHTMLPanelClass.OpenHeadTag                             PROCEDURE
DS               &IDynStr
 CODE
 DS &= NewDynStr()

 DS.Cat('<<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">')
 SELF.SaveToFile(DS); DS.Kill()
 !DS.Cat('<<!-- saved from url=(0014)about:internet -->')
 DS.Cat('<<!-- saved from url=(0016)http://localhost -->')
 SELF.SaveToFile(DS); DS.Kill()
 DS.Cat('<<html>')
 SELF.SaveToFile(DS); DS.Kill()
 DS.Cat('<<head>')
 SELF.SaveToFile(DS); DS.Kill()
 DS.Cat('<<meta http-equiv="Content-Type" content="text/html;  charset=windows-1251">')
 SELF.SaveToFile(DS); DS.Kill()


 DS.Cat('<<script language="JavaScript" type="text/javascript">')
 SELF.SaveToFile(DS); DS.Kill()
 DS.Cat('function expandIt(inID)')
 DS.Cat('{{ ')
 DS.Cat(' inIDs = eval(inID);')
 DS.Cat(' if (inIDs.style.display=="none")')
 DS.Cat('    {{ ')
 DS.Cat('    inIDs.style.display="block";')
 DS.Cat('    } ')
 DS.Cat(' else ')
 DS.Cat('    {{ ')
 DS.Cat('    inIDs.style.display="none"; ')
 DS.Cat('    } ')
 DS.Cat('} ')
 SELF.SaveToFile(DS); DS.Kill()


 DS.Cat('function click_ot(inID,inGroupID)')
 DS.Cat('{{')
 IF NOT SELF.FlagNoImages
    IF LEN(CLIP(SELF.img_contract)) AND LEN(CLIP(SELF.img_expand))
       DS.Cat(' inIDs = eval(inGroupID);')
       DS.Cat(' if (inIDs.style.display=="none")')
       DS.Cat('    {{')
       DS.Cat('    document.images[inID].src = ''' & 'file://' & CLIP(SELF.DoubleSlash(SELF.img_expand)) & ''';')
       DS.Cat('    }')
       SELF.SaveToFile(DS); DS.Kill()
       DS.Cat(' else')                                             
       DS.Cat('    {{')
       DS.Cat('    document.images[inID].src = ''' & 'file://' & CLIP(SELF.DoubleSlash(SELF.img_contract)) & ''';')
       DS.Cat('    }')
    END
 END
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()
 

 DS.Cat('<</script> ')
 SELF.SaveToFile(DS); DS.Kill()

 SELF.WriteStyle() !  

 DS.Cat('<</head>')
 SELF.SaveToFile(DS); DS.Kill()
 DS.Cat('<<body>')
 SELF.SaveToFile(DS); DS.Kill()


 DisposeDynStr(DS)


CFCHTMLPanelClass.WriteStyle                          PROCEDURE
DS               &IDynStr
 CODE
 DS &= NewDynStr()

 DS.Cat('<<style type="text/css">')
 SELF.SaveToFile(DS); DS.Kill()
 DS.Cat('body')
 DS.Cat('{{')
 DS.Cat('font-family: ' & CLIP(SELF.FontName) & ';')
 DS.Cat('font-weight: normal;')
 DS.Cat('font-size: '& CLIP(SELF.FontSize) &';')
 DS.Cat('background: #7495E2;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('td')
 DS.Cat('{{')
 DS.Cat('font-family: ' & CLIP(SELF.FontName) & ';')
 DS.Cat('font-weight: normal;')
 DS.Cat('font-size: '& CLIP(SELF.FontSize) &';')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('td.sep-top')
 DS.Cat('{{')
 DS.Cat('border-top: 1px solid #FFFFFF;')
 DS.Cat('padding-left: '& SELF.padding_px &'px;')
 DS.Cat('padding-right: '& SELF.padding_px &'px;')
 DS.Cat('padding-top: '& SELF.padding_px &'px;')
 DS.Cat('padding-bottom: '& SELF.padding_px &'px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()


 DS.Cat('td.hdr')
 DS.Cat('{{')
 DS.Cat('padding-left: '& SELF.padding_px &'px;')
 DS.Cat('padding-right: '& SELF.padding_px &'px;')
! DS.Cat('padding-top: '& SELF.padding_px &'px;')
! DS.Cat('padding-bottom: '& SELF.padding_px &'px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('td.item')
 DS.Cat('{{')
 DS.Cat('padding-left: '& SELF.padding_px &'px;')
 DS.Cat('padding-right: '& SELF.padding_px &'px;')
 DS.Cat('padding-top: '& SELF.padding_px &'px;')
 DS.Cat('padding-bottom: '& SELF.padding_px &'px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.item-img')
 DS.Cat('{{')
 DS.Cat('padding-left: '& SELF.padding_px &'px;')
 DS.Cat('padding-right: '& SELF.padding_px &'px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('A {{outline:none;}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('A.header:link    {{color:#FFFFFF; text-decoration:none;}')
 DS.Cat('A.header:visited {{color:#FFFFFF; text-decoration:none;}')
 DS.Cat('A.header:hover   {{color:#D6DFF7; text-decoration:none;}')
 SELF.SaveToFile(DS); DS.Kill()


 DS.Cat('A.task:link    {{color:#3931BC; text-decoration:none;}')
 DS.Cat('A.task:visited {{color:#3931BC; text-decoration:none;}')
 DS.Cat('A.task:hover   {{color:#3931BC; text-decoration:underline;}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('img')
 DS.Cat('{{')
 DS.Cat('border: none;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('hr')
 DS.Cat('{{')
 DS.Cat('height: 0px;')
 DS.Cat('color: #FFFFFF;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.r1, .r2, .r3')
 DS.Cat('{{')
 DS.Cat('display: block;')
 DS.Cat('font-size: 0;')
 DS.Cat('height: 1px;')
 DS.Cat('background: #1A57C1;')
 DS.Cat('}')
 DS.Cat('.r1 {{ margin: 0 4px;}')
 DS.Cat('.r2 {{ margin: 0 2px;}')
 DS.Cat('.r3 {{ margin: 0 1px; height: 2px;}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.block-header')
 DS.Cat('{{')
 DS.Cat('background: #1A57C1;')
 DS.Cat('padding: 1px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.block-tasks')
 DS.Cat('{{')
 DS.Cat('display: block;')
 DS.Cat('padding: 0px;')
 DS.Cat('background: #D6DFF7;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.disabled')
 DS.Cat('{{')
 DS.Cat('color:#9F9DB9;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.text-block-top')
 DS.Cat('{{')
 DS.Cat('display: block;')
 DS.Cat('color:#FFFFFF;')
 DS.Cat('text-align: justify;')
 DS.Cat('padding-left: 0px;')
 DS.Cat('padding-right: 0px;')
 DS.Cat('padding-top: 0px;')
 DS.Cat('padding-bottom: '& SELF.padding_px &'px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()

 DS.Cat('.text-block')
 DS.Cat('{{')
 DS.Cat('color:#FFFFFF;')
 DS.Cat('text-align: justify;')
 DS.Cat('padding-left: 0px;')
 DS.Cat('padding-right: 0px;')
 DS.Cat('padding-top: '& SELF.padding_px &'px;')
 DS.Cat('padding-bottom: '& SELF.padding_px &'px;')
 DS.Cat('}')
 SELF.SaveToFile(DS); DS.Kill()


 DS.Cat('<</style>')
 SELF.SaveToFile(DS); DS.Kill()
 DisposeDynStr(DS)
CFCHTMLPanelClass.WriteContent                          PROCEDURE
DS               &IDynStr
 CODE
 DS &= NewDynStr()

 !  -   ,    ?
 SELF.ptb.GroupID = '-1'
 GET(SELF.ptb,SELF.ptb.GroupID)
 IF NOT ERRORCODE()
    DS.Cat('<<div class="text-block-top" id="'& CLIP(SELF.ptb.BlockID) &'">')
    DS.Cat(CLIP(SELF.ptb.Text))
    DS.Cat('<</div>')
    SELF.SaveToFile(DS); DS.Kill()
 END

 LOOP j# = 1 TO RECORDS(SELF.pg)
    GET(SELF.pg,j#)
    DS.Kill()
    DS.Cat('<<b class="r1">&nbsp;<</b><<b class="r2">&nbsp;<</b><<b class="r3">&nbsp;<</b>')
    DS.Cat('<<div class="block-header">')
    DS.Cat('<<table border="0px" width="99%">')

    SELF.SaveToFile(DS); DS.Kill()

    DS.Cat('<<tr>')
    DS.Cat('<<td valign = "center">')
    IF NOT SELF.FlagNoImages
       IF LEN(CLIP(SELF.pg.ImageName))
          DS.Cat('<<img src="file://'& CLIP(SELF.pg.ImageName) &'"><</img>')
       END
    END
    DS.Cat('<</td>')
    SELF.SaveToFile(DS); DS.Kill()
    DS.Cat('<<td valign = "center" width="100%" class="hdr">')
    DS.Cat('<<a href="" class="header" onclick="expandIt(''' & CLIP(SELF.pg.GroupID) &'''); click_ot(''img'& j# &''','''& CLIP(SELF.pg.GroupID) &'''); return false;"><<b>' & CLIP(SELF.pg.GroupName) & '<</b><</a>')
    DS.Cat('<</td>')

    SELF.SaveToFile(DS); DS.Kill()

    DS.Cat('<<td valign = "center">')
    IF NOT SELF.FlagNoImages
       IF LEN(CLIP(SELF.img_contract)) AND LEN(CLIP(SELF.img_expand))
          DS.Cat('<<a href=""  onclick="expandIt(''' & CLIP(SELF.pg.GroupID) & '''); click_ot(''img'& j# &''','''& CLIP(SELF.pg.GroupID) &'''); return false;">')
          SELF.state_q.ID = CLIP(SELF.pg.GroupID)
          GET(SELF.state_q,SELF.state_q.ID)
          IF ERRORCODE()
             DS.Cat('<<img src="file://'& CLIP(SELF.img_contract) &'" id="img'& j# &'"><</img>')
          ELSE
             IF UPPER(CLIP(SELF.state_q.state)) = 'NONE'
                DS.Cat('<<img src="file://'& CLIP(SELF.img_expand) &'" id="img'& j# &'"><</img>')
             ELSE
                DS.Cat('<<img src="file://'& CLIP(SELF.img_contract) &'" id="img'& j# &'"><</img>')
             END
          END
          DS.Cat('<</a>')
       END
    END
    DS.Cat('<</td>')
    DS.Cat('<</tr>')
    DS.Cat('<</table>')
    DS.Cat('<</div>')

    SELF.SaveToFile(DS); DS.Kill()

    !  
    DS.Cat('<<div class="block-tasks" id="'& CLIP(SELF.pg.GroupID) &'">')
    DS.Cat('<<table border="0px" width="100%" cellspacing="0" cellpadding = "0">')
    SELF.SaveToFile(DS); DS.Kill()

    LOOP k# = 1 TO RECORDS(SELF.pi)
       GET(SELF.pi,k#)
       IF SELF.pi.GroupID <> SELF.pg.GroupID THEN CYCLE.
       DS.Cat('<<tr>')
       SELF.SaveToFile(DS); DS.Kill()

       DS.Cat('<<td>')
       IF NOT SELF.FlagNoImages
          IF LEN(CLIP(SELF.pi.CheckGroup)) AND LEN(CLIP(SELF.img_check))
             DS.Cat('<<div style="display:none;" id="'& CLIP(SELF.pi.ItemID) &':image">')
             DS.Cat('<<img src="file://'& CLIP(SELF.img_check) &'" class="item-img"><</img>')
             DS.Cat('<</div>')
          ELSE
             IF LEN(CLIP(SELF.pi.ImageName))
                DS.Cat('<<img src="file://'& CLIP(SELF.pi.ImageName) &'" class="item-img"><</img>')
             END
          END
       ELSE
          IF LEN(CLIP(SELF.pi.CheckGroup)) AND LEN(CLIP(SELF.img_check))
             DS.Cat('<<div style="display:none;" id="'& CLIP(SELF.pi.ItemID) &':image">')
             DS.Cat('&nbsp;&times;')
             DS.Cat('<</div>')
          END
       END
       
       DS.Cat('<</td> ')
       SELF.SaveToFile(DS); DS.Kill()
       IF SELF.pi.FlagSepBefore
          DS.Cat('<<td width="100%" class="sep-top">')
       ELSE
          DS.Cat('<<td width="100%" class="item">')
       END
       DS.Cat('<<div style="display:block;" id="'& CLIP(SELF.pi.ItemID) &':enabled">')
       DS.Cat('<<a href="CLICK://'& CLIP(SELF.pi.ItemID) &'" class="task"')
       IF LEN(CLIP(SELF.pi.TooltipText))
          DS.Cat(' title="' & CLIP(SELF.pi.TooltipText) & '"')
       END
       DS.Cat('>'& CLIP(SELF.pi.ItemText) &'<</a>')
       DS.Cat('<</div>')
       DS.Cat('<<div style="display:none;" class="disabled" id="'& CLIP(SELF.pi.ItemID) &':disabled">')
       DS.Cat(CLIP(SELF.pi.ItemText))
       DS.Cat('<</div>')

       DS.Cat('<</td>')
       SELF.SaveToFile(DS); DS.Kill()

       DS.Cat('<</tr>')
       SELF.SaveToFile(DS); DS.Kill()
    END
    DS.Cat('<</table>')
    DS.Cat('<</div>')
    SELF.SaveToFile(DS); DS.Kill()

    !     
    LOOP k# = 1 TO RECORDS(SELF.ptb)
       GET(SELF.ptb,k#)
       IF SELF.ptb.GroupID <> SELF.pg.GroupID THEN CYCLE.
       DS.Cat('<<div class="text-block" id="'& CLIP(SELF.ptb.BlockID) &'">')
       DS.Cat(CLIP(SELF.ptb.Text))
       DS.Cat('<</div>')
       SELF.SaveToFile(DS); DS.Kill()
    END
    DS.Cat('&nbsp;') !    
    SELF.SaveToFile(DS); DS.Kill()
 END
 DisposeDynStr(DS)
CFCHTMLPanelClass.CloseHeadTag                             PROCEDURE
DS               &IDynStr
 CODE
 DS &= NewDynStr()

 DS.Cat('<</body>')
 DS.Cat('<</html>')

 SELF.SaveToFile(DS)

 DisposeDynStr(DS)
CFCHTMLPanelClass.SaveToFile            PROCEDURE(*IDynStr inDS)
 CODE
 CFC_HTMLTxtFile.DataStr = inDS.Str()
 ADD(CFC_HTMLTxtFile)

CFCHTMLPanelClass.DoubleSlash   PROCEDURE(STRING inStr)
loc:tmp_str      STRING(1024)
 CODE
 cnt# = 1
 LOOP j# = 1 TO LEN(CLIP(inStr))
    loc:tmp_str[cnt#] = inStr[j#]
    IF inStr[j#] = '\'
       cnt# += 1
       loc:tmp_str[cnt#] = '\'
    END
    cnt# += 1
 END
 RETURN loc:tmp_str
CFCHTMLPanelClass.SaveState PROCEDURE
 CODE
 FREE(SELF.state_q)
 LOOP j# = 1 TO RECORDS(SELF.ptb)
    GET(SELF.ptb,j#)
    CLEAR(SELF.state_q)
    SELF.state_q.ID = SELF.ptb.BlockID
    SELF.state_q.state = SELF.html.GetDisplayStyle(SELF.ptb.BlockID)
    ADD(SELF.state_q)
 END

 LOOP j# = 1 TO RECORDS(SELF.pg)
    GET(SELF.pg,j#)
    CLEAR(SELF.state_q)
    SELF.state_q.ID = SELF.pg.GroupID
    SELF.state_q.state = SELF.html.GetDisplayStyle(SELF.pg.GroupID)
    ADD(SELF.state_q)
 END

 LOOP j# = 1 TO RECORDS(SELF.pi)
    GET(SELF.pi,j#)
    CLEAR(SELF.state_q)
    SELF.state_q.ID = CLIP(SELF.pi.ItemID) &':image'
    SELF.state_q.state = SELF.html.GetDisplayStyle(CLIP(SELF.pi.ItemID) &':image')
    ADD(SELF.state_q)

    CLEAR(SELF.state_q)
    SELF.state_q.ID = CLIP(SELF.pi.ItemID) &':disabled'
    SELF.state_q.state = SELF.html.GetDisplayStyle(CLIP(SELF.pi.ItemID) &':disabled')
    ADD(SELF.state_q)

    CLEAR(SELF.state_q)
    SELF.state_q.ID = CLIP(SELF.pi.ItemID) &':enabled'
    SELF.state_q.state = SELF.html.GetDisplayStyle(CLIP(SELF.pi.ItemID) &':enabled')
    ADD(SELF.state_q)
 END





CFCHTMLPanelClass.RestoreState PROCEDURE
 CODE
 LOOP j# = 1 TO RECORDS(SELF.state_q)
    GET(SELF.state_q,j#)
    IF UPPER(CLIP(SELF.state_q.state)) = 'NONE'
       SELF.html.SetDisplayStyleNone(SELF.state_q.ID)
    END
 END


CFCHTMLPanelClass.SaveToIni PROCEDURE
 CODE
 LOOP j# = 1 TO RECORDS(SELF.pg)
    GET(SELF.pg,j#)
    PUTINI(CLIP(SELF.PanelDesc),SELF.pg.GroupID,SELF.html.GetDisplayStyle(SELF.pg.GroupID),SELF.IniFileName)
 END
CFCHTMLPanelClass.RestoreFromIni                    PROCEDURE
loc:State STRING(260)
 CODE
 LOOP j# = 1 TO RECORDS(SELF.pg)
    GET(SELF.pg,j#)
    loc:State = GETINI(CLIP(SELF.PanelDesc),SELF.pg.GroupID,,SELF.IniFileName)

    IF UPPER(CLIP(loc:State)) = 'NONE' !   
       SELF.state_q.ID = SELF.pg.GroupID
       GET(SELF.state_q,SELF.state_q.ID)
       IF ERRORCODE()
          CLEAR(SELF.state_q)
          SELF.state_q.ID = SELF.pg.GroupID
          SELF.state_q.state = loc:State
          ADD(SELF.state_q)
       END
    END
 END






